var JSON;
if (!JSON) {
    JSON = {};
}
(function() {
    'use strict';

    function f(n) {
        return n < 10 ? '0' + n : n;
    }
    if (typeof Date.prototype.toJSON !== 'function') {
        Date.prototype.toJSON = function(key) {
            return isFinite(this.valueOf()) ? this.getUTCFullYear() + '-' +
                f(this.getUTCMonth() + 1) + '-' +
                f(this.getUTCDate()) + 'T' +
                f(this.getUTCHours()) + ':' +
                f(this.getUTCMinutes()) + ':' +
                f(this.getUTCSeconds()) + 'Z' : null;
        };
        String.prototype.toJSON = Number.prototype.toJSON = Boolean.prototype.toJSON = function(key) {
            return this.valueOf();
        };
    }
    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap, indent, meta = {
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"': '\\"',
            '\\': '\\\\'
        }, rep;

    function quote(string) {
        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function(a) {
            var c = meta[a];
            return typeof c === 'string' ? c : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }

    function str(key, holder) {
        var i, k, v, length, mind = gap,
            partial, value = holder[key];
        if (value && typeof value === 'object' && typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }
        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }
        switch (typeof value) {
            case 'string':
                return quote(value);
            case 'number':
                return isFinite(value) ? String(value) : 'null';
            case 'boolean':
            case 'null':
                return String(value);
            case 'object':
                if (!value) {
                    return 'null';
                }
                gap += indent;
                partial = [];
                if (Object.prototype.toString.apply(value) === '[object Array]') {
                    length = value.length;
                    for (i = 0; i < length; i += 1) {
                        partial[i] = str(i, value) || 'null';
                    }
                    v = partial.length === 0 ? '[]' : gap ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' : '[' + partial.join(',') + ']';
                    gap = mind;
                    return v;
                }
                if (rep && typeof rep === 'object') {
                    length = rep.length;
                    for (i = 0; i < length; i += 1) {
                        if (typeof rep[i] === 'string') {
                            k = rep[i];
                            v = str(k, value);
                            if (v) {
                                partial.push(quote(k) + (gap ? ': ' : ':') + v);
                            }
                        }
                    }
                } else {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = str(k, value);
                            if (v) {
                                partial.push(quote(k) + (gap ? ': ' : ':') + v);
                            }
                        }
                    }
                }
                v = partial.length === 0 ? '{}' : gap ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' : '{' + partial.join(',') + '}';
                gap = mind;
                return v;
        }
    }
    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function(value, replacer, space) {
            var i;
            gap = '';
            indent = '';
            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }
            } else if (typeof space === 'string') {
                indent = space;
            }
            rep = replacer;
            if (replacer && typeof replacer !== 'function' && (typeof replacer !== 'object' || typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }
            return str('', {
                '': value
            });
        };
    }
    if (typeof JSON.parse !== 'function') {
        JSON.parse = function(text, reviver) {
            var j;

            function walk(holder, key) {
                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }
            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function(a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }
            if (/^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                j = eval('(' + text + ')');
                return typeof reviver === 'function' ? walk({
                    '': j
                }, '') : j;
            }
            throw new SyntaxError('JSON.parse');
        };
    }
}());

function setup_new_fb_js() {
    $('#homepage_signup_form, #login_dialog_wrapper, #login_dialog_container, #upsell_form, #gallery_homepage_bottom_upsell, #homepage_signup, #landing_content_container').on({
        'click': function(e) {
            if (window.pass_to_js.f_domain) {
                parent.postMessage('likes-success-redirect: ' + 'http://' + pass_to_js.f_domain + '/signin', '*');
                return true;
            }
            var redirect_url = '';
            if (typeof PageData !== "undefined" && !PageData.gallery_homepage) {
                redirect_url = window.location.href;
            };
            var $this = $(this);
            show_signin_spinny($this);
            fb_login();
            $.post('//' + window.location.host + '/api/track_event', {
                path: 'fb_login/click'
            });
            return false;
        }
    }, '#signup_fb_button, #signup_fb_button_upsell');
    $('#common_dialog_wrapper, #verify_profile_wrapper').on({
        'click': function(e) {
            show_signin_spinny($(this));
            fb_login(fb_verification_cb, null, fb_verification_cb);
            $.post('//' + window.location.host + '/api/track_event', {
                path: 'fb_verification/click'
            });
            return false;
        }
    }, '#link_facebook_action');

    function fb_login(callback, redirect_url, error_callback) {
        var perms = "user_friends,email,user_birthday";
        var pd = window.pass_to_js || window.PageData;
        if (pd && pd.experiment_config && pd.experiment_config.desktop_fb_permissions) {
            perms = pd.experiment_config.desktop_fb_permissions;
        }
        redirect_url = redirect_url || '/';
        $("#feed_example .scrollable").addClass('still');
        FB.login(function(response) {
            if (response && response.authResponse) {
                var params = {
                    'access_token': response.authResponse.accessToken,
                    'expires': response.authResponse.expires || response.authResponse.expiresIn,
                    'fb_uid': response.authResponse.userID
                };
                params.state = $("input[name='referer_url']").val();
                params.signup_action = $('#signup_action').val();
                params.in_iframe = $('#signup_in_iframe').val() || '';
                xhr = $.ajax({
                    type: "POST",
                    url: '//' + window.location.host + '/api/complete_facebook_login',
                    data: $.param(params),
                    dataType: "json",
                    success: function(data) {
                        if (data && data.success) {
                            params = null;
                            if (callback) {
                                callback(data);
                                return;
                            }
                            if (data && data.oauth_info && data.oauth_info.new_user) {
                                redirect_url = data.redirect_url || '/friends';
                            }
                            var pass_to_js = window.pass_to_js || PageData;
                            var cd_signup_frame = (window.parent && pass_to_js && pass_to_js.cd_signup_iframe);
                            var success_redirect = redirect_url;
                            if (cd_signup_frame) {
                                parent.postMessage('likes-success-redirect: ' + 'http://' + window.location.host + success_redirect, '*');
                            } else {
                                top.location = success_redirect;
                            }
                        } else {
                            if (error_callback) {
                                error_callback({
                                    'error': (data && data.oauth_info && data.oauth_info.errors) ? data.oauth_info.errors[0] : "There was a problem signing up with your Facebook account. Please try again!"
                                });
                                return;
                            }
                            hide_fb_signin_spinny();
                            var gallery_upsell = ($("#signup_form_gallery_upsell").length) ? true : false;
                            var signup_error_selector = (gallery_upsell) ? ERROR_SELECTOR + "_gallery_upsell" : ERROR_SELECTOR;
                            render_signin_errors(data && data.oauth_info && data.oauth_info.errors || ["There was a problem signing up with your Facebook account. Please try again!"]);
                        }
                    },
                    error: function() {
                        $("#feed_example .scrollable").removeClass('still');
                        if (error_callback) {
                            error_callback({
                                'error': "There was a problem connecting to our server. Please try again!"
                            });
                            return;
                        }
                        hide_fb_signin_spinny();
                        render_signin_errors(["There was a problem connecting to our server. Please try again!"]);
                    }
                });
            } else {
                $("#feed_example .scrollable").removeClass('still');
                if (error_callback) {
                    error_callback({
                        'error': "There was a problem connecting to Facebook. Please try again!"
                    });
                    return;
                }
                hide_fb_signin_spinny();
                render_signin_errors(["There was a problem connecting to Facebook. Please try again!"]);
                $.post('//' + window.location.host + '/api/track_event', {
                    path: 'fb_login/error',
                    fbresponse: JSON.stringify(response)
                });
            }
        }, {
            'scope': perms
        });
    }
}
$().ready(function() {
    setup_new_fb_js();
});
$().ready(function() {
    $("#update_new_account_info_button").on({
        'click': function() {
            var data = {
                'email': $("#email").val(),
                'name': $("#name").val(),
                'user_name': $("#user_name").val(),
            };
            PageData.save_twitter_user_info(data);
        }
    });
});;
(function($) {
    "use strict";
    var feature = {};
    feature.fileapi = $("<input type='file'/>").get(0).files !== undefined;
    feature.formdata = window.FormData !== undefined;
    $.fn.ajaxSubmit = function(options) {
        if (!this.length) {
            log('ajaxSubmit: skipping submit process - no element selected');
            return this;
        }
        var method, action, url, $form = this;
        if (typeof options == 'function') {
            options = {
                success: options
            };
        }
        method = this.attr('method');
        action = this.attr('action');
        url = (typeof action === 'string') ? $.trim(action) : '';
        url = url || window.location.href || '';
        if (url) {
            url = (url.match(/^([^#]+)/) || [])[1];
        }
        options = $.extend(true, {
            url: url,
            success: $.ajaxSettings.success,
            type: method || 'GET',
            iframeSrc: /^https/i.test(window.location.href || '') ? 'javascript:false' : 'about:blank'
        }, options);
        var veto = {};
        this.trigger('form-pre-serialize', [this, options, veto]);
        if (veto.veto) {
            log('ajaxSubmit: submit vetoed via form-pre-serialize trigger');
            return this;
        }
        if (options.beforeSerialize && options.beforeSerialize(this, options) === false) {
            log('ajaxSubmit: submit aborted via beforeSerialize callback');
            return this;
        }
        var traditional = options.traditional;
        if (traditional === undefined) {
            traditional = $.ajaxSettings.traditional;
        }
        var elements = [];
        var qx, a = this.formToArray(options.semantic, elements);
        if (options.data) {
            options.extraData = options.data;
            qx = $.param(options.data, traditional);
        }
        if (options.beforeSubmit && options.beforeSubmit(a, this, options) === false) {
            log('ajaxSubmit: submit aborted via beforeSubmit callback');
            return this;
        }
        this.trigger('form-submit-validate', [a, this, options, veto]);
        if (veto.veto) {
            log('ajaxSubmit: submit vetoed via form-submit-validate trigger');
            return this;
        }
        var q = $.param(a, traditional);
        if (qx) {
            q = (q ? (q + '&' + qx) : qx);
        }
        if (options.type.toUpperCase() == 'GET') {
            options.url += (options.url.indexOf('?') >= 0 ? '&' : '?') + q;
            options.data = null;
        } else {
            options.data = q;
        }
        var callbacks = [];
        if (options.resetForm) {
            callbacks.push(function() {
                $form.resetForm();
            });
        }
        if (options.clearForm) {
            callbacks.push(function() {
                $form.clearForm(options.includeHidden);
            });
        }
        if (!options.dataType && options.target) {
            var oldSuccess = options.success || function() {};
            callbacks.push(function(data) {
                var fn = options.replaceTarget ? 'replaceWith' : 'html';
                $(options.target)[fn](data).each(oldSuccess, arguments);
            });
        } else if (options.success) {
            callbacks.push(options.success);
        }
        options.success = function(data, status, xhr) {
            var context = options.context || this;
            for (var i = 0, max = callbacks.length; i < max; i++) {
                callbacks[i].apply(context, [data, status, xhr || $form, $form]);
            }
        };
        var fileInputs = $('input:file:enabled[value]', this);
        var hasFileInputs = fileInputs.length > 0;
        var mp = 'multipart/form-data';
        var multipart = ($form.attr('enctype') == mp || $form.attr('encoding') == mp);
        var fileAPI = feature.fileapi && feature.formdata;
        log("fileAPI :" + fileAPI);
        var shouldUseFrame = (hasFileInputs || multipart) && !fileAPI;
        var jqxhr;
        if (options.iframe !== false && (options.iframe || shouldUseFrame)) {
            if (options.closeKeepAlive) {
                $.get(options.closeKeepAlive, function() {
                    jqxhr = fileUploadIframe(a);
                });
            } else {
                jqxhr = fileUploadIframe(a);
            }
        } else if ((hasFileInputs || multipart) && fileAPI) {
            jqxhr = fileUploadXhr(a);
        } else {
            jqxhr = $.ajax(options);
        }
        $form.removeData('jqxhr').data('jqxhr', jqxhr);
        for (var k = 0; k < elements.length; k++)
            elements[k] = null;
        this.trigger('form-submit-notify', [this, options]);
        return this;

        function deepSerialize(extraData) {
            var serialized = $.param(extraData).split('&');
            var len = serialized.length;
            var result = {};
            var i, part;
            for (i = 0; i < len; i++) {
                part = serialized[i].split('=');
                result[decodeURIComponent(part[0])] = decodeURIComponent(part[1]);
            }
            return result;
        }

        function fileUploadXhr(a) {
            var formdata = new FormData();
            for (var i = 0; i < a.length; i++) {
                formdata.append(a[i].name, a[i].value);
            }
            if (options.extraData) {
                var serializedData = deepSerialize(options.extraData);
                for (var p in serializedData)
                    if (serializedData.hasOwnProperty(p))
                        formdata.append(p, serializedData[p]);
            }
            options.data = null;
            var s = $.extend(true, {}, $.ajaxSettings, options, {
                contentType: false,
                processData: false,
                cache: false,
                type: method || 'POST'
            });
            if (options.uploadProgress) {
                s.xhr = function() {
                    var xhr = jQuery.ajaxSettings.xhr();
                    if (xhr.upload) {
                        xhr.upload.onprogress = function(event) {
                            var percent = 0;
                            var position = event.loaded || event.position;
                            var total = event.total;
                            if (event.lengthComputable) {
                                percent = Math.ceil(position / total * 100);
                            }
                            options.uploadProgress(event, position, total, percent);
                        };
                    }
                    return xhr;
                };
            }
            s.data = null;
            var beforeSend = s.beforeSend;
            s.beforeSend = function(xhr, o) {
                o.data = formdata;
                if (beforeSend)
                    beforeSend.call(this, xhr, o);
            };
            return $.ajax(s);
        }

        function fileUploadIframe(a) {
            var form = $form[0],
                el, i, s, g, id, $io, io, xhr, sub, n, timedOut, timeoutHandle;
            var useProp = !! $.fn.prop;
            var deferred = $.Deferred();
            if ($(':input[name=submit],:input[id=submit]', form).length) {
                alert('Error: Form elements must not have name or id of "submit".');
                deferred.reject();
                return deferred;
            }
            if (a) {
                for (i = 0; i < elements.length; i++) {
                    el = $(elements[i]);
                    if (useProp)
                        el.prop('disabled', false);
                    else
                        el.removeAttr('disabled');
                }
            }
            s = $.extend(true, {}, $.ajaxSettings, options);
            s.context = s.context || s;
            id = 'jqFormIO' + (new Date().getTime());
            if (s.iframeTarget) {
                $io = $(s.iframeTarget);
                n = $io.attr('name');
                if (!n)
                    $io.attr('name', id);
                else
                    id = n;
            } else {
                $io = $('<iframe name="' + id + '" src="' + s.iframeSrc + '" />');
                $io.css({
                    position: 'absolute',
                    top: '-1000px',
                    left: '-1000px'
                });
            }
            io = $io[0];
            xhr = {
                aborted: 0,
                responseText: null,
                responseXML: null,
                status: 0,
                statusText: 'n/a',
                getAllResponseHeaders: function() {},
                getResponseHeader: function() {},
                setRequestHeader: function() {},
                abort: function(status) {
                    var e = (status === 'timeout' ? 'timeout' : 'aborted');
                    log('aborting upload... ' + e);
                    this.aborted = 1;
                    if (io.contentWindow.document.execCommand) {
                        try {
                            io.contentWindow.document.execCommand('Stop');
                        } catch (ignore) {}
                    }
                    $io.attr('src', s.iframeSrc);
                    xhr.error = e;
                    if (s.error)
                        s.error.call(s.context, xhr, e, status);
                    if (g)
                        $.event.trigger("ajaxError", [xhr, s, e]);
                    if (s.complete)
                        s.complete.call(s.context, xhr, e);
                }
            };
            g = s.global;
            if (g && 0 === $.active++) {
                $.event.trigger("ajaxStart");
            }
            if (g) {
                $.event.trigger("ajaxSend", [xhr, s]);
            }
            if (s.beforeSend && s.beforeSend.call(s.context, xhr, s) === false) {
                if (s.global) {
                    $.active--;
                }
                deferred.reject();
                return deferred;
            }
            if (xhr.aborted) {
                deferred.reject();
                return deferred;
            }
            sub = form.clk;
            if (sub) {
                n = sub.name;
                if (n && !sub.disabled) {
                    s.extraData = s.extraData || {};
                    s.extraData[n] = sub.value;
                    if (sub.type == "image") {
                        s.extraData[n + '.x'] = form.clk_x;
                        s.extraData[n + '.y'] = form.clk_y;
                    }
                }
            }
            var CLIENT_TIMEOUT_ABORT = 1;
            var SERVER_ABORT = 2;

            function getDoc(frame) {
                var doc = frame.contentWindow ? frame.contentWindow.document : frame.contentDocument ? frame.contentDocument : frame.document;
                return doc;
            }
            var csrf_token = $('meta[name=csrf-token]').attr('content');
            var csrf_param = $('meta[name=csrf-param]').attr('content');
            if (csrf_param && csrf_token) {
                s.extraData = s.extraData || {};
                s.extraData[csrf_param] = csrf_token;
            }

            function doSubmit() {
                var t = $form.attr('target'),
                    a = $form.attr('action');
                form.setAttribute('target', id);
                if (!method) {
                    form.setAttribute('method', 'POST');
                }
                if (a != s.url) {
                    form.setAttribute('action', s.url);
                }
                if (!s.skipEncodingOverride && (!method || /post/i.test(method))) {
                    $form.attr({
                        encoding: 'multipart/form-data',
                        enctype: 'multipart/form-data'
                    });
                }
                if (s.timeout) {
                    timeoutHandle = setTimeout(function() {
                        timedOut = true;
                        cb(CLIENT_TIMEOUT_ABORT);
                    }, s.timeout);
                }

                function checkState() {
                    try {
                        var state = getDoc(io).readyState;
                        log('state = ' + state);
                        if (state && state.toLowerCase() == 'uninitialized')
                            setTimeout(checkState, 50);
                    } catch (e) {
                        log('Server abort: ', e, ' (', e.name, ')');
                        cb(SERVER_ABORT);
                        if (timeoutHandle)
                            clearTimeout(timeoutHandle);
                        timeoutHandle = undefined;
                    }
                }
                var extraInputs = [];
                try {
                    if (s.extraData) {
                        for (var n in s.extraData) {
                            if (s.extraData.hasOwnProperty(n)) {
                                if ($.isPlainObject(s.extraData[n]) && s.extraData[n].hasOwnProperty('name') && s.extraData[n].hasOwnProperty('value')) {
                                    extraInputs.push($('<input type="hidden" name="' + s.extraData[n].name + '">').attr('value', s.extraData[n].value).appendTo(form)[0]);
                                } else {
                                    extraInputs.push($('<input type="hidden" name="' + n + '">').attr('value', s.extraData[n]).appendTo(form)[0]);
                                }
                            }
                        }
                    }
                    if (!s.iframeTarget) {
                        $io.appendTo('body');
                        if (io.attachEvent)
                            io.attachEvent('onload', cb);
                        else
                            io.addEventListener('load', cb, false);
                    }
                    setTimeout(checkState, 15);
                    form.submit();
                } finally {
                    form.setAttribute('action', a);
                    if (t) {
                        form.setAttribute('target', t);
                    } else {
                        $form.removeAttr('target');
                    }
                    $(extraInputs).remove();
                }
            }
            if (s.forceSync) {
                doSubmit();
            } else {
                setTimeout(doSubmit, 10);
            }
            var data, doc, domCheckCount = 50,
                callbackProcessed;

            function cb(e) {
                if (xhr.aborted || callbackProcessed) {
                    return;
                }
                try {
                    doc = getDoc(io);
                } catch (ex) {
                    log('cannot access response document: ', ex);
                    e = SERVER_ABORT;
                }
                if (e === CLIENT_TIMEOUT_ABORT && xhr) {
                    xhr.abort('timeout');
                    deferred.reject(xhr, 'timeout');
                    return;
                } else if (e == SERVER_ABORT && xhr) {
                    xhr.abort('server abort');
                    deferred.reject(xhr, 'error', 'server abort');
                    return;
                }
                if (!doc || doc.location.href == s.iframeSrc) {
                    if (!timedOut)
                        return;
                }
                if (io.detachEvent)
                    io.detachEvent('onload', cb);
                else
                    io.removeEventListener('load', cb, false);
                var status = 'success',
                    errMsg;
                try {
                    if (timedOut) {
                        throw 'timeout';
                    }
                    var isXml = s.dataType == 'xml' || doc.XMLDocument || $.isXMLDoc(doc);
                    log('isXml=' + isXml);
                    if (!isXml && window.opera && (doc.body === null || !doc.body.innerHTML)) {
                        if (--domCheckCount) {
                            log('requeing onLoad callback, DOM not available');
                            setTimeout(cb, 250);
                            return;
                        }
                    }
                    var docRoot = doc.body ? doc.body : doc.documentElement;
                    xhr.responseText = docRoot ? docRoot.innerHTML : null;
                    xhr.responseXML = doc.XMLDocument ? doc.XMLDocument : doc;
                    if (isXml)
                        s.dataType = 'xml';
                    xhr.getResponseHeader = function(header) {
                        var headers = {
                            'content-type': s.dataType
                        };
                        return headers[header];
                    };
                    if (docRoot) {
                        xhr.status = Number(docRoot.getAttribute('status')) || xhr.status;
                        xhr.statusText = docRoot.getAttribute('statusText') || xhr.statusText;
                    }
                    var dt = (s.dataType || '').toLowerCase();
                    var scr = /(json|script|text)/.test(dt);
                    if (scr || s.textarea) {
                        var ta = doc.getElementsByTagName('textarea')[0];
                        if (ta) {
                            xhr.responseText = ta.value;
                            xhr.status = Number(ta.getAttribute('status')) || xhr.status;
                            xhr.statusText = ta.getAttribute('statusText') || xhr.statusText;
                        } else if (scr) {
                            var pre = doc.getElementsByTagName('pre')[0];
                            var b = doc.getElementsByTagName('body')[0];
                            if (pre) {
                                xhr.responseText = pre.textContent ? pre.textContent : pre.innerText;
                            } else if (b) {
                                xhr.responseText = b.textContent ? b.textContent : b.innerText;
                            }
                        }
                    } else if (dt == 'xml' && !xhr.responseXML && xhr.responseText) {
                        xhr.responseXML = toXml(xhr.responseText);
                    }
                    try {
                        data = httpData(xhr, dt, s);
                    } catch (e) {
                        status = 'parsererror';
                        xhr.error = errMsg = (e || status);
                    }
                } catch (e) {
                    log('error caught: ', e);
                    status = 'error';
                    xhr.error = errMsg = (e || status);
                }
                if (xhr.aborted) {
                    log('upload aborted');
                    status = null;
                }
                if (xhr.status) {
                    status = (xhr.status >= 200 && xhr.status < 300 || xhr.status === 304) ? 'success' : 'error';
                }
                if (status === 'success') {
                    if (s.success)
                        s.success.call(s.context, data, 'success', xhr);
                    deferred.resolve(xhr.responseText, 'success', xhr);
                    if (g)
                        $.event.trigger("ajaxSuccess", [xhr, s]);
                } else if (status) {
                    if (errMsg === undefined)
                        errMsg = xhr.statusText;
                    if (s.error)
                        s.error.call(s.context, xhr, status, errMsg);
                    deferred.reject(xhr, 'error', errMsg);
                    if (g)
                        $.event.trigger("ajaxError", [xhr, s, errMsg]);
                }
                if (g)
                    $.event.trigger("ajaxComplete", [xhr, s]);
                if (g && !--$.active) {
                    $.event.trigger("ajaxStop");
                }
                if (s.complete)
                    s.complete.call(s.context, xhr, status);
                callbackProcessed = true;
                if (s.timeout)
                    clearTimeout(timeoutHandle);
                setTimeout(function() {
                    if (!s.iframeTarget)
                        $io.remove();
                    xhr.responseXML = null;
                }, 100);
            }
            var toXml = $.parseXML || function(s, doc) {
                    if (window.ActiveXObject) {
                        doc = new ActiveXObject('Microsoft.XMLDOM');
                        doc.async = 'false';
                        doc.loadXML(s);
                    } else {
                        doc = (new DOMParser()).parseFromString(s, 'text/xml');
                    }
                    return (doc && doc.documentElement && doc.documentElement.nodeName != 'parsererror') ? doc : null;
                };
            var parseJSON = $.parseJSON || function(s) {
                    return window['eval']('(' + s + ')');
                };
            var httpData = function(xhr, type, s) {
                var ct = xhr.getResponseHeader('content-type') || '',
                    xml = type === 'xml' || !type && ct.indexOf('xml') >= 0,
                    data = xml ? xhr.responseXML : xhr.responseText;
                if (xml && data.documentElement.nodeName === 'parsererror') {
                    if ($.error)
                        $.error('parsererror');
                }
                if (s && s.dataFilter) {
                    data = s.dataFilter(data, type);
                }
                if (typeof data === 'string') {
                    if (type === 'json' || !type && ct.indexOf('json') >= 0) {
                        data = parseJSON(data || "null");
                    } else if (type === "script" || !type && ct.indexOf("javascript") >= 0) {
                        $.globalEval(data);
                    }
                }
                return data;
            };
            return deferred;
        }
    };
    $.fn.ajaxForm = function(options) {
        options = options || {};
        options.delegation = options.delegation && $.isFunction($.fn.on);
        if (!options.delegation && this.length === 0) {
            var o = {
                s: this.selector,
                c: this.context
            };
            if (!$.isReady && o.s) {
                log('DOM not ready, queuing ajaxForm');
                $(function() {
                    $(o.s, o.c).ajaxForm(options);
                });
                return this;
            }
            log('terminating; zero elements found by selector' + ($.isReady ? '' : ' (DOM not ready)'));
            return this;
        }
        if (options.delegation) {
            $(document).off('submit.form-plugin', this.selector, doAjaxSubmit).off('click.form-plugin', this.selector, captureSubmittingElement).on('submit.form-plugin', this.selector, options, doAjaxSubmit).on('click.form-plugin', this.selector, options, captureSubmittingElement);
            return this;
        }
        return this.ajaxFormUnbind().bind('submit.form-plugin', options, doAjaxSubmit).bind('click.form-plugin', options, captureSubmittingElement);
    };

    function doAjaxSubmit(e) {
        var options = e.data;
        if (!e.isDefaultPrevented()) {
            e.preventDefault();
            $(this).ajaxSubmit(options);
        }
    }

    function captureSubmittingElement(e) {
        var target = e.target;
        var $el = $(target);
        if (!($el.is(":submit,input:image"))) {
            var t = $el.closest(':submit');
            if (t.length === 0) {
                return;
            }
            target = t[0];
        }
        var form = this;
        form.clk = target;
        if (target.type == 'image') {
            if (e.offsetX !== undefined) {
                form.clk_x = e.offsetX;
                form.clk_y = e.offsetY;
            } else if (typeof $.fn.offset == 'function') {
                var offset = $el.offset();
                form.clk_x = e.pageX - offset.left;
                form.clk_y = e.pageY - offset.top;
            } else {
                form.clk_x = e.pageX - target.offsetLeft;
                form.clk_y = e.pageY - target.offsetTop;
            }
        }
        setTimeout(function() {
            form.clk = form.clk_x = form.clk_y = null;
        }, 100);
    }
    $.fn.ajaxFormUnbind = function() {
        return this.unbind('submit.form-plugin click.form-plugin');
    };
    $.fn.formToArray = function(semantic, elements) {
        var a = [];
        if (this.length === 0) {
            return a;
        }
        var form = this[0];
        var els = semantic ? form.getElementsByTagName('*') : form.elements;
        if (!els) {
            return a;
        }
        var i, j, n, v, el, max, jmax;
        for (i = 0, max = els.length; i < max; i++) {
            el = els[i];
            n = el.name;
            if (!n) {
                continue;
            }
            if (semantic && form.clk && el.type == "image") {
                if (!el.disabled && form.clk == el) {
                    a.push({
                        name: n,
                        value: $(el).val(),
                        type: el.type
                    });
                    a.push({
                        name: n + '.x',
                        value: form.clk_x
                    }, {
                        name: n + '.y',
                        value: form.clk_y
                    });
                }
                continue;
            }
            v = $.fieldValue(el, true);
            if (v && v.constructor == Array) {
                if (elements)
                    elements.push(el);
                for (j = 0, jmax = v.length; j < jmax; j++) {
                    a.push({
                        name: n,
                        value: v[j]
                    });
                }
            } else if (feature.fileapi && el.type == 'file' && !el.disabled) {
                if (elements)
                    elements.push(el);
                var files = el.files;
                if (files.length) {
                    for (j = 0; j < files.length; j++) {
                        a.push({
                            name: n,
                            value: files[j],
                            type: el.type
                        });
                    }
                } else {
                    a.push({
                        name: n,
                        value: '',
                        type: el.type
                    });
                }
            } else if (v !== null && typeof v != 'undefined') {
                if (elements)
                    elements.push(el);
                a.push({
                    name: n,
                    value: v,
                    type: el.type,
                    required: el.required
                });
            }
        }
        if (!semantic && form.clk) {
            var $input = $(form.clk),
                input = $input[0];
            n = input.name;
            if (n && !input.disabled && input.type == 'image') {
                a.push({
                    name: n,
                    value: $input.val()
                });
                a.push({
                    name: n + '.x',
                    value: form.clk_x
                }, {
                    name: n + '.y',
                    value: form.clk_y
                });
            }
        }
        return a;
    };
    $.fn.formSerialize = function(semantic) {
        return $.param(this.formToArray(semantic));
    };
    $.fn.fieldSerialize = function(successful) {
        var a = [];
        this.each(function() {
            var n = this.name;
            if (!n) {
                return;
            }
            var v = $.fieldValue(this, successful);
            if (v && v.constructor == Array) {
                for (var i = 0, max = v.length; i < max; i++) {
                    a.push({
                        name: n,
                        value: v[i]
                    });
                }
            } else if (v !== null && typeof v != 'undefined') {
                a.push({
                    name: this.name,
                    value: v
                });
            }
        });
        return $.param(a);
    };
    $.fn.fieldValue = function(successful) {
        for (var val = [], i = 0, max = this.length; i < max; i++) {
            var el = this[i];
            var v = $.fieldValue(el, successful);
            if (v === null || typeof v == 'undefined' || (v.constructor == Array && !v.length)) {
                continue;
            }
            if (v.constructor == Array)
                $.merge(val, v);
            else
                val.push(v);
        }
        return val;
    };
    $.fieldValue = function(el, successful) {
        var n = el.name,
            t = el.type,
            tag = el.tagName.toLowerCase();
        if (successful === undefined) {
            successful = true;
        }
        if (successful && (!n || el.disabled || t == 'reset' || t == 'button' || (t == 'checkbox' || t == 'radio') && !el.checked || (t == 'submit' || t == 'image') && el.form && el.form.clk != el || tag == 'select' && el.selectedIndex == -1)) {
            return null;
        }
        if (tag == 'select') {
            var index = el.selectedIndex;
            if (index < 0) {
                return null;
            }
            var a = [],
                ops = el.options;
            var one = (t == 'select-one');
            var max = (one ? index + 1 : ops.length);
            for (var i = (one ? index : 0); i < max; i++) {
                var op = ops[i];
                if (op.selected) {
                    var v = op.value;
                    if (!v) {
                        v = (op.attributes && op.attributes['value'] && !(op.attributes['value'].specified)) ? op.text : op.value;
                    }
                    if (one) {
                        return v;
                    }
                    a.push(v);
                }
            }
            return a;
        }
        return $(el).val();
    };
    $.fn.clearForm = function(includeHidden) {
        return this.each(function() {
            $('input,select,textarea', this).clearFields(includeHidden);
        });
    };
    $.fn.clearFields = $.fn.clearInputs = function(includeHidden) {
        var re = /^(?:color|date|datetime|email|month|number|password|range|search|tel|text|time|url|week)$/i;
        return this.each(function() {
            var t = this.type,
                tag = this.tagName.toLowerCase();
            if (re.test(t) || tag == 'textarea') {
                this.value = '';
            } else if (t == 'checkbox' || t == 'radio') {
                this.checked = false;
            } else if (tag == 'select') {
                this.selectedIndex = -1;
            } else if (includeHidden) {
                if ((includeHidden === true && /hidden/.test(t)) || (typeof includeHidden == 'string' && $(this).is(includeHidden)))
                    this.value = '';
            }
        });
    };
    $.fn.resetForm = function() {
        return this.each(function() {
            if (typeof this.reset == 'function' || (typeof this.reset == 'object' && !this.reset.nodeType)) {
                this.reset();
            }
        });
    };
    $.fn.enable = function(b) {
        if (b === undefined) {
            b = true;
        }
        return this.each(function() {
            this.disabled = !b;
        });
    };
    $.fn.selected = function(select) {
        if (select === undefined) {
            select = true;
        }
        return this.each(function() {
            var t = this.type;
            if (t == 'checkbox' || t == 'radio') {
                this.checked = select;
            } else if (this.tagName.toLowerCase() == 'option') {
                var $sel = $(this).parent('select');
                if (select && $sel[0] && $sel[0].type == 'select-one') {
                    $sel.find('option').selected(false);
                }
                this.selected = select;
            }
        });
    };
    $.fn.ajaxSubmit.debug = false;

    function log() {
        if (!$.fn.ajaxSubmit.debug)
            return;
        var msg = '[jquery.form] ' + Array.prototype.join.call(arguments, '');
        if (window.console && window.console.log) {
            window.console.log(msg);
        } else if (window.opera && window.opera.postError) {
            window.opera.postError(msg);
        }
    }
})(jQuery);

function nicetime(date) {
    if (typeof(date) == 'number') {
        date = new Date(date * 1000);
    }
    if (!date) return '';
    var diff = (((new Date()).getTime() - date.getTime()) / 1000),
        day_diff = Math.floor(diff / 86400);
    if (isNaN(day_diff) || day_diff < 0)
        return '';
    return day_diff == 0 && (diff < 5 && "just now" || diff < 60 && (Math.floor(diff) + ' seconds ago') || diff < 120 && "1 minute ago" || diff < 3600 && Math.floor(diff / 60) + " minutes ago" || diff < 7200 && "1 hour ago" || diff < 86400 && Math.floor(diff / 3600) + " hours ago") || day_diff == 1 && "Yesterday" || day_diff < 7 && day_diff + " days ago" || day_diff < 14 && "1 week ago" || day_diff < 30 && Math.floor(day_diff / 7) + " weeks ago" || day_diff < 60 && "1 month ago" || Math.floor(day_diff / 30) + " months ago";
}

function format_date(date, format_string) {
    if (typeof(date) == 'number') {
        date = new Date(date * 1000);
    }
    if (!date) return '';
    if (!format_string) format_string = "%a %b %d %Y";
    var mthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var dayNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
    var zeroPad = function(number) {
        return ("0" + number).substr(-2, 2);
    };
    var dateMarkers = {
        d: ['getDate',
            function(v) {
                return zeroPad(v)
            }
        ],
        m: ['getMonth',
            function(v) {
                return zeroPad(v + 1)
            }
        ],
        b: ['getMonth',
            function(v) {
                return mthNames[v];
            }
        ],
        a: ['getDay',
            function(v) {
                return dayNames[v];
            }
        ],
        Y: ['getFullYear'],
        H: ['getHours',
            function(v) {
                return zeroPad(v)
            }
        ],
        M: ['getMinutes',
            function(v) {
                return zeroPad(v)
            }
        ],
        S: ['getSeconds',
            function(v) {
                return zeroPad(v)
            }
        ],
        i: ['toISOString']
    };
    return format_string.replace(/%(.)/g, function(m, p) {
        var rv = date[(dateMarkers[p])[0]]();
        if (dateMarkers[p][1] != null) rv = dateMarkers[p][1](rv);
        return rv;
    });
}

function nicetime_v2(date) {
    if (typeof(date) == 'number') {
        date = new Date(date * 1000);
    }
    var diff = (((new Date()).getTime() - date.getTime()) / 1000),
        day_diff = Math.floor(diff / 86400);
    if (day_diff <= 365) {
        format_string = "%a, %b %d at %H:%M";
    } else {
        format_string = "%a, %b %d %Y at %H:%M";
    }
    if (day_diff <= 1) {
        return nicetime(date);
    } else {
        return format_date(date, format_string);
    }
}

function format_number(num, opt_prec) {
    var precision = opt_prec;
    if (num == parseInt(num)) {
        var rounded = opt_prec ? +num.toPrecision(precision) : +num;
        var characters = rounded.toString();
        var output = '';
        for (var offset = characters.length; offset > 0; offset -= 3) {
            output = characters.slice(Math.max(offset - 3, 0), offset) + (output ? ',' + output : '');
        }
        return output;
    }
    if (precision !== undefined && num) return num.toFixed(precision);
    return num;
}

function format_num_k(num, opt_prec) {
    if (!num && num !== 0) return num;
    opt_prec = opt_prec || 3;
    num = parseInt(num);
    if (num < 1000) return '' + num;
    if (num < 10000) return format_number(num, opt_prec);
    if (num < 1000000) {
        num = +num.toPrecision(opt_prec) / 1000;
        return num + 'K';
    }
    num = +num.toPrecision(opt_prec) / 1000000;
    return num + 'M';
}

function format_duration(duration) {
    if (!duration) return "0:00";
    duration = parseInt(duration);
    var mins = parseInt(duration / 60);
    var secs = duration % 60;
    return mins.toString() + ':' + (secs < 10 ? '0' : '') + secs.toString();
}

function pluralize(numbered_string) {
    var pluralize_re = /([0-9]+)( *)([^ ]+)/;
    var match = pluralize_re.exec(numbered_string);
    if (!match) {
        return numbered_string;
    }
    match.splice(0, 1);
    if (match[0] != '1' && match[2][match[2].length - 1] != 's') {
        match.push('s');
    }
    pluralize_re = null;
    return match.join('');
}

function get_params_from_url(url) {
    var query = url.split("?")[1] || '';
    var param_list = query.split('&');
    var params = {};
    for (var i = 0; i < param_list.length; i++) {
        var param = param_list[i].split('=');
        if (decodeURIComponent(param[0]).length) {
            params[decodeURIComponent(param[0])] = decodeURIComponent(param[1]);
        }
    }
    return params;
};

function add_or_replace_param(url, param_name, param_val) {
    var path = url.split("?")[0];
    var params = get_params_from_url(url);
    var added = false;
    for (var key in params) {
        if (key == param_name && !added) {
            params[param_name] = param_val;
            added = true;
        }
    }
    if (!added && param_name) {
        params[param_name] = param_val;
    }
    var new_url = path;
    var first = true;
    for (var key in params) {
        var param_string = encodeURIComponent(key) + "=" + encodeURIComponent(params[key]);
        if (first) {
            new_url = new_url + "?" + param_string;
            first = false;
        } else {
            new_url = new_url + "&" + param_string;
        }
    }
    return new_url;
}
var GRID_LIST = ['50l cb', '25', '25', '25', '25', '75r cb', '25', '25', '25'],
    GRID_LIST_MINI = ['75l cb', '25', '25', '25', '50l cb', '50l', '75l cb'],
    MIX_GRID_LIST = ['50l cb', '25', '25', '25', '25', '25 cb', '25', '50r', '25', '25'];

function grid_size(info) {
    var grid_list = GRID_LIST;
    var array_length = info.array_length;
    if (array_length && array_length < 5) {
        if (array_length == 1) {
            return '75l';
        } else if (array_length == 2 || array_length == 4) {
            return '50l';
        } else if (array_length == 3) {
            return info.index < 2 ? '50l' : '75l';
        } else {
            grid_list = GRID_LIST_MINI;
        }
    }
    return grid_list[info.index % grid_list.length];
}

function grid_size_mix(info) {
    return MIX_GRID_LIST[info.index % MIX_GRID_LIST.length];
}

function thumbnail(image_url, size) {
    size = size || '90x90';
    var MYLIKES_IMAGE_RE = /http:\/\/.*\.cloudfront\.net\/uimg\/[0-9a-f]+$/;
    if (image_url.match(MYLIKES_IMAGE_RE)) {
        return image_url + '.' + size;
    }
    return image_url;
}

function crop(image_url, opt_size) {
    if (!image_url) return image_url;
    if (!image_url.match(/^http:.*/)) return image_url;
    if (image_url.match(/http:\/\/d2l8ua2kqfocke.cloudfront.net.*/)) return image_url;
    var size = opt_size || '100';
    return 'http://d2l8ua2kqfocke.cloudfront.net/crop?url=' + encodeURIComponent(image_url) + '&size=' + size;
}
var USER_THUMB_CDN = 's.likes-media.com';

function user_thumb(thumb_key, size) {
    return get_thumb_url(thumb_key, size, USER_THUMB_CDN, 'uimg');
}

function get_thumb_url(thumb_key, size, cdn, dir_name) {
    if (!thumb_key || thumb_key.match(/^http/) || (thumb_key.length != 32) || !thumb_key.match(/^[0-9a-f]+$/)) {
        return thumb_key ? thumb_key : '';
    }
    if (size == null || size == undefined || size.length == 0) {
        size = '';
    } else {
        size = '.' + size;
    }
    return '//' + cdn + '/' + dir_name + '/' + thumb_key + size;
}

function breakwords(text) {
    if (!text) {
        return text;
    }
    var words = text.split(/ +/);
    for (var i = 0, l = words.length; i < l; i++) {
        if (words[i].length > 8) {
            var parts = [];
            for (var j = 0, wl = words[i].length; j < wl; j += 8) {
                parts.push(escapeHTMLMustache(words[i].slice(j, j + 8)));
            }
            words[i] = parts.join('&shy;');
        } else {
            words[i] = escapeHTMLMustache(words[i]);
        }
    }
    return words.join(' ');
}
var USERNAME_RE = /(.*)@:([0-9]+):([a-zA-Z0-9_]+)(.*)/;

function escape_and_link(text) {
    var words = text.split(/ +/);
    for (var i = 0, l = words.length; i < l; i++) {
        var match = USERNAME_RE.exec(words[i]);
        if (match) {
            words[i] = escapeHTMLMustache(match[1]) + '<a class="bright-blue show_hover_card" user_id="' + match[2] + '" href="/' + match[3] + '">@' + match[3] + '</a>' + escapeHTMLMustache(match[4]);
        } else if (words[i].length > 8) {
            var parts = [];
            for (var j = 0, wl = words[i].length; j < wl; j += 8) {
                parts.push(escapeHTMLMustache(words[i].slice(j, j + 8)));
            }
            words[i] = parts.join('&shy;');
        } else {
            words[i] = escapeHTMLMustache(words[i]);
        }
    }
    return words.join(' ');
}

function get_from_context(contexts, name) {
    if (typeof(contexts) == "object" && contexts.length == undefined) return contexts[name];
    for (var i = 0; i < contexts.length; i++) {
        if (contexts[i] && contexts[i][name] !== undefined) return contexts[i][name];
    }
}

function push_context(context, contexts) {
    if (contexts && Array.isArray(contexts)) {
        var new_contexts = contexts.slice();
        new_contexts.unshift(context);
        return new_contexts;
    } else if (contexts && typeof(contexts) == "object") {
        return [context, contexts];
    }
    return [context];
}

function increment_forloop(forloop, item) {
    forloop.index++;
    forloop.counter = forloop.index + 1;
    forloop.first = forloop.index == 0;
    forloop.last = forloop.array_length && forloop.index == forloop.array_length - 1;
    forloop.even = forloop.counter % 2 == 0;
    forloop.odd = !forloop.even;
    forloop.item = item;
}

function slice(obj) {
    if (!obj) return obj;
    var args = Array.prototype.slice.call(arguments, 1);
    return Array.prototype.slice.apply(obj, args);
}

function count(obj, word, show_zero) {
    if (obj === undefined) obj = 0;
    var length = (typeof obj != 'number') ? obj.length : obj;
    if (length == 0 && !show_zero) {
        return '';
    }
    if (!word) return length;
    return length + ' ' + word + (length != 1 ? 's' : '');
}
var escapeHTMLMustache;

function linkify(text, link_class) {
    if (!(text || text.length)) return text;
    link_class = link_class || 'blue underline';
    var link_re = /(?:[A-Za-z]{3,5}:\/\/)(?:[A-Za-z0-9\-]+\.)?(?:[A-Za-z0-9\-]+\.)?(?:[A-Za-z0-9\-]+\.)?[A-Za-z0-9\-]+\.[A-Za-z]{2,3}(?:\/[^\s]+)?/g;

    function linky(match) {
        return "<a href='" + match + "' target='_blank' onclick='window.open(this.href,'_blank');return false;' class='" + link_class + "'>" + match + "</a>";
    }
    text = escapeHTMLMustache(text);
    return text.replace(link_re, linky);
}

function linkify_tags(text, link_class) {
    if (!(text || text.length)) return text;
    link_class = link_class || 'blue grid_tag underline';
    var tag_re = /#[0-9A-Za-z\-]+/g;

    function linky(match) {
        return "<a href='/tagged/" + match.substring(1) + "' class='" + link_class + "'>" + match + "</a>";
    }
    return text.replace(tag_re, linky);
}

function number(text) {
    return parseInt(text) || 0;
}

function nopad(url) {
    return (url || '') + '.nopad';
}

function noanim(url) {
    return (url || '') + '.noanim';
}

function truncate_html(html, opt_length, ellipsis) {
    var len = opt_length || 30,
        ellipsis = ellipsis || '...';
    var $div = $('<div>' + html + '</div>');
    if ($div.text().length <= len) return html;
    while ($div.text().length > len) {
        html = html.slice(0, html.length - 1).replace(/<[^>]*$/, '');
        $div.html(html);
    }
    return $div.html() + ellipsis;
}
var RTL_RE = /[\u0509-\u06ff]/g;

function is_rtl(text) {
    if (!text) return false;
    return RTL_RE.test(text);
}

function translation_link(text, target_lang) {
    if (!target_lang) target_lang = 'en';
    return "http://translate.google.com/#auto/" + target_lang + "/" + encodeURIComponent(text);
}

function message_pic_sizing(message, max_width, max_height) {
    if (!max_width) max_width = 250;
    if (!max_height) max_height = 250;
    if (!message || !message.width || !message.height) {
        return '';
    }
    var width = message['width'],
        height = message['height'],
        resize_height, resize_width;
    resize_width = message['width'];
    resize_height = message['height'];
    if (width > max_width) {
        resize_height = max_width * height / width;
        resize_width = max_width;
    }
    if (resize_height > max_height) {
        resize_width = max_height * width / height;
        resize_height = max_height;
    }
    return 'width: ' + resize_width + 'px; height: ' + resize_height + 'px';
}
var Mustache = function() {
    var _toString = Object.prototype.toString;
    Array.isArray = Array.isArray || function(obj) {
        return _toString.call(obj) == "[object Array]";
    }
    var _trim = String.prototype.trim,
        trim;
    if (_trim) {
        trim = function(text) {
            return text == null ? "" : _trim.call(text);
        }
    } else {
        var trimLeft, trimRight;
        if ((/\S/).test("\xA0")) {
            trimLeft = /^[\s\xA0]+/;
            trimRight = /[\s\xA0]+$/;
        } else {
            trimLeft = /^\s+/;
            trimRight = /\s+$/;
        }
        trim = function(text) {
            return text == null ? "" : text.toString().replace(trimLeft, "").replace(trimRight, "");
        }
    }
    var escapeMap = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': '&quot;',
        "'": '&#39;'
    };

    function escapeHTML(string) {
        return String(string).replace(/&(?!\w+;)|[<>\"\']/g, function(s) {
            return escapeMap[s] || s;
        });
    }
    escapeHTMLMustache = escapeHTML;
    var regexCache = {};
    var Renderer = function() {};
    var OPERATE_RE_1 = /\|\||&&/;
    var OPERATE_RE_2 = /[<>]|[<>!=]=/;
    var OPERATE_RE_3 = /[+*\/\-%]/;
    var LITERAL_RE = /^('(\\'|[^'])*'|"(\\"|[^"])*"|-?[0-9\.]+)$/;
    Renderer.prototype = {
        otag: "{{",
        ctag: "}}",
        pragmas: {},
        buffer: [],
        pragmas_implemented: {
            "IMPLICIT-ITERATOR": true
        },
        context: {},
        render: function(template, context, partials, in_recursion) {
            if (!in_recursion) {
                this.context = context;
                this.buffer = [];
            }
            if (!this.includes("", template)) {
                if (in_recursion) {
                    return template;
                } else {
                    this.send(template);
                    return;
                }
            }
            template = this.render_pragmas(template);
            var html = this.render_section(template, context, partials);
            if (html === false) {
                html = this.render_tags(template, context, partials, in_recursion);
            }
            if (in_recursion) {
                return html;
            } else {
                this.sendLines(html);
            }
        },
        send: function(line) {
            if (line !== "") {
                this.buffer.push(line);
            }
        },
        sendLines: function(text) {
            if (text) {
                var lines = text.split("\n");
                for (var i = 0; i < lines.length; i++) {
                    this.send(lines[i]);
                }
            }
        },
        render_pragmas: function(template) {
            if (!this.includes("%", template)) {
                return template;
            }
            var that = this;
            var regex = this.getCachedRegex("render_pragmas", function(otag, ctag) {
                return new RegExp(otag + "%([\\w-]+) ?([\\w]+=[\\w]+)?" + ctag, "g");
            });
            return template.replace(regex, function(match, pragma, options) {
                if (!that.pragmas_implemented[pragma]) {
                    throw ({
                        message: "This implementation of mustache doesn't understand the '" +
                            pragma + "' pragma"
                    });
                }
                that.pragmas[pragma] = {};
                if (options) {
                    var opts = options.split("=");
                    that.pragmas[pragma][opts[0]] = opts[1];
                }
                return "";
            });
        },
        render_partial: function(name, context, partials) {
            name = trim(name);
            if (name.indexOf('var:') === 0) {
                name = this.find(name.slice(4), context);
            }
            if (!partials || partials[name] === undefined) {
                throw ({
                    message: "unknown_partial '" + name + "'"
                });
            }
            if (!context || typeof get_from_context(context, name) != "object") {
                return this.render(partials[name], context, partials, true);
            }
            return this.render(partials[name], push_context(get_from_context(context, name), context), partials, true);
        },
        render_section: function(template, context, partials) {
            if (!this.includes("#", template) && !this.includes("^", template)) {
                return false;
            }
            var that = this;
            var regex = this.getCachedRegex("render_section", function(otag, ctag) {
                return new RegExp("^([\\s\\S]*?)" +
                    otag + "(\\^|\\#)\\s*(.+)\\s*" +
                    ctag + "\n*([\\s\\S]*?)" +
                    otag + "\\/\\s*\\3\\s*" +
                    ctag + "\\s*([\\s\\S]*)$", "g");
            });
            return template.replace(regex, function(match, before, type, name, content, after) {
                var renderedBefore = before ? that.render_tags(before, context, partials, true) : "",
                    renderedAfter = after ? that.render(after, context, partials, true) : "",
                    renderedContent, value = that.find(name, context);
                if (type === "^") {
                    if (!value || Array.isArray(value) && value.length === 0) {
                        renderedContent = that.render(content, context, partials, true);
                    } else {
                        renderedContent = "";
                    }
                } else if (type === "#") {
                    if (Array.isArray(value)) {
                        var forloop = {
                            index: -1,
                            array_length: value.length
                        };
                        renderedContent = that.map(value, function(row) {
                            increment_forloop(forloop, row);
                            return that.render(content, that.create_context(row, context, forloop), partials, true);
                        }).join("");
                    } else if (that.is_object(value)) {
                        renderedContent = that.render(content, that.create_context(value, context), partials, true);
                    } else if (typeof value == "function") {
                        renderedContent = value.call(context[0], content, function(text) {
                            return that.render(text, context, partials, true);
                        });
                    } else if (value) {
                        renderedContent = that.render(content, context, partials, true);
                    } else {
                        renderedContent = "";
                    }
                }
                return renderedBefore + renderedContent + renderedAfter;
            });
        },
        render_tags: function(template, context, partials, in_recursion) {
            var that = this;
            var new_regex = function() {
                return that.getCachedRegex("render_tags", function(otag, ctag) {
                    return new RegExp(otag + "(=|!|>|jinja_now>|jinja>|\\{|%)?([^#\\^]+?)\\1?" + ctag + "+", "g");
                });
            };
            var regex = new_regex();
            var tag_replace_callback = function(match, operator, name) {
                switch (operator) {
                    case "!":
                        return "";
                    case "=":
                        that.set_delimiters(name);
                        regex = new_regex();
                        return "";
                    case ">":
                        return that.render_partial(name, context, partials);
                    case "jinja>":
                    case "jinja_now>":
                        name = name.replace(/ /g, '');
                        var ctx = {}, min_ctx = 0;
                        if (name.indexOf(':') > -1) {
                            var parts = name.split(':');
                            name = parts[0];
                            var var_name = parts[1];
                            if (var_name.indexOf('=') > -1) {
                                parts = var_name.split('=');
                                var_name = parts[0];
                                ctx[var_name] = that.find(parts[1], context);
                            } else {
                                ctx[var_name] = context[0];
                                min_ctx = 1;
                            }
                        }
                        for (var i = context.length - 1; i >= min_ctx; i--) {
                            ctx = $.extend(ctx, context[i]);
                        }
                        return jinja[name.replace(/\.html$/, '')](ctx, true);
                    case "{":
                        return that.find(name, context);
                    default:
                        return escapeHTML(that.find(name, context));
                }
            };
            var lines = template.split("\n");
            for (var i = 0; i < lines.length; i++) {
                lines[i] = lines[i].replace(regex, tag_replace_callback, this);
                if (!in_recursion) {
                    this.send(lines[i]);
                }
            }
            if (in_recursion) {
                return lines.join("\n");
            }
        },
        set_delimiters: function(delimiters) {
            var dels = delimiters.split(" ");
            this.otag = this.escape_regex(dels[0]);
            this.ctag = this.escape_regex(dels[1]);
        },
        escape_regex: function(text) {
            if (!arguments.callee.sRE) {
                var specials = ['/', '.', '*', '+', '?', '|', '(', ')', '[', ']', '{', '}', '\\'];
                arguments.callee.sRE = new RegExp('(\\' + specials.join('|\\') + ')', 'g');
            }
            return text.replace(arguments.callee.sRE, '\\$1');
        },
        get_filter: function(f_name) {
            var args = [];
            while (true) {
                var match = f_name.match(/^([^:"]+|"[^"]*?"):(.*)$/);
                if (!match) {
                    args.push(f_name);
                    break;
                }
                args.push(match[1]);
                f_name = match[2];
            }
            var f_func = Mustache.FILTERS[args[0]];
            if (args.length > 1) {
                return function(m) {
                    for (var i = 1; i < args.length; i++) {
                        if (args[i].match(LITERAL_RE)) {
                            args[i] = $.parseJSON(args[i]);
                        }
                    }
                    args[0] = m;
                    return f_func.apply(this, args);
                };
            }
            return f_func;
        },
        parse_operator_1: function(name, context) {
            var sides = name.split(OPERATE_RE_1);
            if (sides.length > 2) {
                sides = [sides[0], name.slice(sides[0].length + 2)];
            }
            var operator = name.match(OPERATE_RE_1)[0];
            var left = this.find(sides[0], context),
                right = this.find(sides[1], context);
            if (operator == '&&') return left && right;
            if (operator == '||') return left || right;
        },
        parse_operator_2: function(name, context) {
            var sides = name.split(OPERATE_RE_2);
            var operator = name.match(OPERATE_RE_2)[0];
            var left = this.find(sides[0], context),
                right = this.find(sides[1], context);
            if (operator == '<') return left < right;
            if (operator == '>') return left > right;
            if (operator == '<=') return left <= right;
            if (operator == '>=') return left >= right;
            if (operator == '==') return left == right;
            if (operator == '!=') return left != right;
        },
        parse_operator_3: function(name, context) {
            var sides = name.split(OPERATE_RE_3);
            var operator = name.match(OPERATE_RE_3)[0];
            var left = this.find(sides[0], context),
                right = this.find(sides[1], context);
            if (operator == '+') return left + right;
            if (operator == '-') return left - right;
            if (operator == '*') return left * right;
            if (operator == '/') return left / right;
            if (operator == '%') return left % right;
        },
        find: function(name, context) {
            name = trim(name);
            if (name.match(LITERAL_RE)) return $.parseJSON(name);
            if (name.match(OPERATE_RE_1)) return this.parse_operator_1(name, context);
            if (name.match(OPERATE_RE_2)) return this.parse_operator_2(name, context);
            if (name.match(OPERATE_RE_3)) return this.parse_operator_3(name, context);

            function is_kinda_truthy(bool) {
                return bool === false || bool === 0 || bool;
            }
            var value;
            var filters = [];
            var parts = name.split('|');
            name = parts[0];
            for (var i = 1; i < parts.length; i++) {
                filters.push(this.get_filter(parts[i]));
            }
            if (name.match(/([a-z_]+)\./ig)) {
                var childValue = this.walk_context(name, context);
                if (is_kinda_truthy(childValue)) {
                    value = childValue;
                }
            } else {
                if (is_kinda_truthy(get_from_context(context, name))) {
                    value = get_from_context(context, name);
                }
            }
            for (var i = 0; i < filters.length; i++) {
                try {
                    value = filters[i](value);
                } catch (e) {
                    console.error("Filter broken: " + filters[i] + " -- " + name + "\n" + e.message + "\n" + e.stack);
                }
            }
            if (typeof value == "function") {
                return value.apply(context[0]);
            }
            if (value !== undefined) {
                return value;
            }
            return "";
        },
        walk_context: function(name, context) {
            var path = name.split('.');
            var value_context = context[0];
            var value = get_from_context(context, path.shift());
            while (value !== undefined && value !== null && path.length > 0) {
                value_context = value;
                value = value[path.shift()];
            }
            if (typeof value == "function") {
                return value.apply(value_context);
            }
            return value;
        },
        includes: function(needle, haystack) {
            return haystack.indexOf(this.otag + needle) != -1;
        },
        create_context: function(_context, contexts, opt_forloop) {
            if (opt_forloop) {
                contexts = push_context({
                    forloop: opt_forloop
                }, contexts);
            }
            if (this.is_object(_context)) {
                return push_context(_context, contexts);
            } else {
                var iterator = ".";
                if (this.pragmas["IMPLICIT-ITERATOR"]) {
                    iterator = this.pragmas["IMPLICIT-ITERATOR"].iterator;
                }
                var ctx = {};
                ctx[iterator] = _context;
                return push_context(ctx, contexts);
            }
        },
        is_object: function(a) {
            return a && typeof a == "object";
        },
        map: function(array, fn) {
            if (typeof array.map == "function") {
                return array.map(fn);
            } else {
                var r = [];
                var l = array.length;
                for (var i = 0; i < l; i++) {
                    r.push(fn(array[i]));
                }
                return r;
            }
        },
        getCachedRegex: function(name, generator) {
            var byOtag = regexCache[this.otag];
            if (!byOtag) {
                byOtag = regexCache[this.otag] = {};
            }
            var byCtag = byOtag[this.ctag];
            if (!byCtag) {
                byCtag = byOtag[this.ctag] = {};
            }
            var regex = byCtag[name];
            if (!regex) {
                regex = byCtag[name] = generator(this.otag, this.ctag);
            }
            return regex;
        }
    };
    return ({
        name: "mustache.js",
        version: "0.4.0-dev",
        to_html: function(template, view, partials, send_fun) {
            var renderer = new Renderer();
            if (send_fun) {
                renderer.send = send_fun;
            }
            renderer.render(template, [view || {}], partials);
            if (!send_fun) {
                return renderer.buffer.join("\n");
            }
        },
        FILTERS: {
            truncate: function(m, opt_length) {
                if (m) {
                    var length = +opt_length || 30;
                    return m.length > length - 3 ? m.substr(0, length - 3) + '...' : m;
                }
                return m;
            },
            truncate_html: truncate_html,
            length: function(m) {
                if (!m) return 0;
                if (m.length !== undefined) return m.length;
                var key_count = 0;
                for (var key in m) {
                    if (m.hasOwnProperty(key)) key_count++;
                }
                return key_count;
            },
            is_context: function(m) {
                return m && (Array.isArray(m) || typeof m == "object");
            },
            is_not_context: function(m) {
                return !Mustache.FILTERS.is_context(m);
            },
            quote_plus: function(m) {
                return encodeURIComponent(m).replace(/%20/g, '+');
            },
            iter_items: function(m) {
                var items = [];
                for (var key in m) {
                    if (m.hasOwnProperty(key)) {
                        items.push([key, m[key]]);
                    }
                }
                return items;
            },
            replace: function(m, opt_find, opt_replace) {
                if (opt_find && opt_replace !== undefined) {
                    return m.replace(opt_find, opt_replace);
                }
                return m;
            },
            json: function(m) {
                return JSON.stringify(m).replace(/<\//g, '<\\/');
            },
            child_tag: function(tag) {
                return (tag.indexOf(':') !== -1) ? tag.split(':')[1] : tag;
            },
            format_number: format_number,
            format_num_k: format_num_k,
            format_duration: format_duration,
            format_date: format_date,
            nicetime: nicetime,
            nicetime_v2: nicetime_v2,
            timestamp: function(dt) {
                return dt;
            },
            pluralize: pluralize,
            grid_size: grid_size,
            grid_size_mix: grid_size_mix,
            thumbnail: thumbnail,
            crop: crop,
            breakwords: breakwords,
            escape_and_link: escape_and_link,
            slice: slice,
            count: count,
            linkify: linkify,
            linkify_tags: linkify_tags,
            number: number,
            is_rtl: is_rtl,
            user_thumb: user_thumb,
            is_online: function(user_id) {
                return window.RT && window.RT.online_users[user_id];
            },
            in_list: function(obj, arr) {
                if (!arr) return false;
                return arr.indexOf && arr.indexOf(obj) > -1;
            },
            add_url_param: function(url, param) {
                if (!param) return url;
                return (url.match(/[?]/) ? '&' : '?') + param;
            },
            add_or_replace_param: add_or_replace_param,
            translation_link: translation_link,
            message_pic_sizing: message_pic_sizing
        }
    });
}();
(function() {
    function trim(stuff) {
        if (''.trim) return stuff.trim();
        else return stuff.replace(/^\s+/, '').replace(/\s+$/, '');
    }
    var ich = {
        VERSION: "0.9",
        templates: {},
        $: (typeof window !== 'undefined') ? window.jQuery || window.Zepto || null : null,
        addTemplate: function(name, templateString) {
            if (ich[name]) throw "Invalid name: " + name + ".";
            if (ich.templates[name]) throw "Template \" + name + \" exists";
            ich.templates[name] = templateString;
            ich[name] = function(data, raw) {
                data = $.extend({}, window.global_ich_data || {}, data || {});
                var result = Mustache.to_html(ich.templates[name], data, ich.templates);
                return (ich.$ && !raw) ? ich.$(result) : result;
            };
        },
        clearAll: function() {
            for (var key in ich.templates) {
                delete ich[key];
            }
            ich.templates = {};
        },
        refresh: function() {
            ich.clearAll();
            ich.grabTemplates();
        },
        grabTemplates: function() {
            var i, scripts = document.getElementsByTagName('script'),
                l = (scripts !== undefined ? scripts.length : 0),
                script, trash = [];
            for (i = 0; i < l; i++) {
                script = scripts[i];
                if (script && script.innerHTML && script.id && (script.type === "text/html" || script.type === "text/x-icanhaz")) {
                    ich.addTemplate(script.id, trim(script.innerHTML));
                    trash.unshift(script);
                }
            }
            for (i = 0, l = trash.length; i < l; i++) {
                trash[i].parentNode.removeChild(trash[i]);
            }
        }
    };
    window.ich = ich;
    ich.$().ready(function() {
        ich.grabTemplates();
    });
})();

function close_login_prompt() {
    if (!$("#livestream_view").is(':visible')) {
        var top = $("html").scrollTop();
        $("html").css("overflow", "auto").scrollTop(top);
    }
    $("#login_dialog_wrapper").hide();
}

function render_login_prompt(opts) {
    if (PageData) {
        var user_id = PageData.feed.user_id;
        if (PageData.users && PageData.users[user_id] && PageData.users[user_id].domain_name == window.location.host) {
            window.location = '/signin';
            return;
        }
    }
    var data = PageData || window.pass_to_js || {};
    var experiment_config = data.experiment_config || {};
    opts = opts || {};
    var display = {
        'redirect_url': window.location.href
    };
    display.form_type = (opts.form_type) ? opts.form_type : "home";
    if (window && window.pass_to_js && window.pass_to_js.referer_url) {
        display.referer_url = window.pass_to_js.referer_url;
    } else if (PageData && PageData.referer_url) {
        display.referer_url = PageData.referer_url;
    } else {
        display.referer_url = window.location.href;
    }
    if (opts.form_type == "signup" || opts.form_type == "signup_upsell") {
        display['redirect_url'] = '/';
        display['error_redirect'] = '/signup';
    } else if (opts.form_type == "login") {
        display['redirect_url'] = window.location.href;
        display['error_redirect'] = '/login';
    }
    if (opts.redirect_url) {
        display.redirect_url = opts.redirect_url;
    }
    display['login_redirect_param'] = '?redirect_url=' + encodeURIComponent(display.redirect_url);
    if (opts.signup_action) {
        display.signup_action = opts.signup_action;
    }
    if (true || experiment_config.agegender) {
        display['agegender'] = 1;
    }
    if (!experiment_config.hide_email_signup) {
        display['show_email_signup'] = 1;
    }
    if (data.birthday_params) {
        $.extend(display, data.birthday_params);
    }
    display['experiment'] = {
        'config': {
            'enable_twitter_signup': experiment_config.enable_twitter_signup
        }
    };
    display['product_name'] = data.product_name;
    display['signup_token'] = data.signup_token;
    var top = $("html").scrollTop();
    $("html").css("overflow", "hidden").scrollTop(top);
    display['friendlife_upsell'] = PageData.friendlife_upsell;
    $("#login_dialog_wrapper").show().empty().html('').html(jinja.login_dialog(display, true));
    $('.fb_disclaimer').show();
    $('#landing_fb_button').show();
    $('#landing_twitter_button').show();
    setup_captcha($("#login_dialog_wrapper"), 'dark');
    Forms.initDefaults("#login_dialog_container .logintext");
};
var ERROR_SELECTOR = "#signin_error_box";

function render_signin_errors(errors, this_error_selector) {
    this_error_selector = this_error_selector || ERROR_SELECTOR;
    $errors = $(this_error_selector);
    $errors.empty().html();
    $errors.show();
    $.each(errors, function(index) {
        $errors.append('<div class="signin_error_message">' + errors[index] + '</div>');
    });
    if (window.resize_frame) {
        resize_frame();
    } else {
        var height = $errors.height();
        if (height) {
            $errors.css({
                height: 0
            }).animate({
                height: height + 'px'
            }, {
                complete: function() {
                    $errors.css({
                        height: 'auto'
                    });
                    if (window.position_footer) {
                        position_footer();
                    }
                }
            });
        }
    }
}

function show_signin_spinny($parent) {
    $parent.find(".text").hide();
    $parent.find(".loggedout_form_spinny").css("display", "inline-block");
}

function hide_fb_signin_spinny() {
    var $button = $("#signup_fb_button");
    if ($button.length) {
        hide_signin_spinny($button);
    }
    $button = $("#signup_fb_button_upsell");
    if ($button.length) {
        hide_signin_spinny($button);
    }
}

function hide_signin_spinny($parent) {
    $parent.find(".loggedout_form_spinny").hide();
    $parent.find(".text").show();
}

function submit_login_form() {
    var $this;
    if ($("#landing_content_container").is(':visible')) {
        $this = $("#landing_content_container #submit_login_form");
    } else {
        $this = $("#submit_login_form");
    }
    if ($this.hasClass('clicked'))
        return false;
    $this.addClass('clicked');
    show_signin_spinny($this);
    var pass_to_js = window.pass_to_js || window.PageData || {};
    var params = {};
    params.username = $('#login_username').val();
    params.password = $('#login_password').val();
    params.redirect_url = $('#login_redirect_url').val();
    params.referer_url = $('#login_referer_url').val();
    params.signup_action = $('#signup_action').val();
    params.ajax = true;
    $(ERROR_SELECTOR).empty().html();
    $.ajax({
        type: "POST",
        dataType: 'json',
        data: $.param(params),
        url: Api.get_uri('login'),
        success: function(data) {
            if (data.success) {
                var cd_signup_frame = (window.parent && pass_to_js.cd_signup_iframe);
                var success_redirect = data.redirect_url || '/';
                if (cd_signup_frame) {
                    if (pass_to_js.f_domain) {
                        parent.postMessage('likes-success-redirect: ' + 'http://' + pass_to_js.f_domain + success_redirect, '*');
                    } else {
                        parent.postMessage('likes-success-redirect: ' + 'http://' + window.location.host + success_redirect, '*');
                    }
                } else {
                    window.location = success_redirect;
                }
            } else {
                hide_signin_spinny($this);
                render_signin_errors([data.error]);
                $this.removeClass('clicked');
            }
        }
    });
}

function submit_forgot_password_form() {
    var $this = $("#submit_forgot_password_form");
    if ($this.hasClass('clicked'))
        return false;
    $this.addClass('clicked');
    show_signin_spinny($this);
    var params = {};
    params.ajax = true;
    params.mobile = false;
    params.email = $.trim($('#email').val());
    $(ERROR_SELECTOR).empty().html();
    $.ajax({
        type: "POST",
        dataType: 'json',
        data: $.param(params),
        url: Api.get_uri('forgot_password'),
        success: function(data) {
            if (data.success) {
                $('#forgot_password_form').fadeOut();
                $('#forgot_password_success').fadeIn();
                $this.removeClass('clicked');
                if ($('#homepage_splash').length) {
                    $("#homepage_splash .loggedout_form_desc").fadeOut(function() {
                        $("#forgot_password_form").html('').html(jinja.forgot_password({
                            'success': 1
                        })).hide().fadeIn();
                    });
                }
            } else {
                hide_signin_spinny($this);
                render_signin_errors([data.error]);
                $this.removeClass('clicked');
            }
        }
    });
}
var my_captcha;

function setup_captcha($form, theme) {
    var $captcha = $form.find(".captcha");
    var captcha_id = 'captcha_' + Math.floor(Math.random() * 1000);
    if ($captcha.size() && window.grecaptcha) {
        $captcha.attr('id', captcha_id);
        my_captcha = grecaptcha.render(captcha_id, {
            sitekey: '6LeNSAETAAAAADba-8kmM6YBoBSmN-EUzHjvwSDc',
            theme: theme || 'light'
        });
        $captcha.show();
    }
}

function submit_signup_form($this) {
    if ($this.hasClass('clicked'))
        return false;
    $form = $this.parents("form");
    var gallery_upsell = ($form.attr("id") == "signup_form_gallery_upsell") ? true : false;
    var signup_error_selector = (gallery_upsell) ? ERROR_SELECTOR + "_gallery_upsell" : ERROR_SELECTOR;
    $(signup_error_selector).empty().html();
    var pass_to_js = window.pass_to_js || window.PageData || {};
    var params = {};
    params.ajax = true;
    params.email = $.trim($form.find("input[name='email']").val());
    params.name = $form.find("input[name='name']").val();
    if (pass_to_js.signup_username) {
        params.nickname = $.trim($form.find("input[name='nickname']").val());
    }
    params.password = $form.find("input[name='password']").val();
    if ($form.find('#birthday_day').length) {
        var year = $form.find('#birthday_year').val().toString();
        var month = $form.find('#birthday_month').val().toString();
        var day = $form.find('#birthday_day').val().toString();
        if (year.length && month.length && day.length) {
            params.birthday = year + "-" + month + "-" + day;
        }
    }
    if ($form.find("input[name='gender']:checked").length) {
        params.gender = $form.find("input[name='gender']:checked").val();
    }
    if ($form.find("input[name='picture']").length) {
        params.picture = $form.find("input[name='picture']").val();
    }
    params.redirect_url = $form.find("input[name='redirect_url']").val();
    params.error_redirect = $form.find("input[name='error_redirect']").val();
    params.token = $form.find("input[name='token']").val();
    params.referer_url = $form.find("input[name='referer_url']").val();
    params.referral_code = $form.find("input[name='referral_code']").val();
    params.signup_action = $('#signup_action').val() || '';
    params.in_iframe = $('#signup_in_iframe').val() || '';
    params.partner = $form.find("input[name='partner']").val();
    params.invited = $form.find("input[name='invited']").val();
    params.is_mature = $form.find("input[name='is_mature']").val() || '';
    params.premium = $form.find("input[name='premium']").val() || 0;
    params.signup_token = $form.find("input[name='signup_token']").val() || '';
    var $captcha = $form.find(".captcha");
    if ($captcha.size() && window.grecaptcha) {
        params.captcha = grecaptcha.getResponse(my_captcha);
    }
    show_signin_spinny($this);
    $this.addClass('clicked');
    $.ajax({
        dataType: 'json',
        url: Api.get_uri('signupprocess'),
        data: $.param(params),
        type: 'POST',
        success: function(data) {
            var cd_signup_frame = (window.parent && pass_to_js.cd_signup_iframe);
            if (data.success) {
                var success_redirect = data.redirect_url;
                if (cd_signup_frame) {
                    if (pass_to_js.f_domain) {
                        parent.postMessage('likes-success-redirect: ' + 'http://' + pass_to_js.f_domain + success_redirect, '*');
                    } else {
                        parent.postMessage('likes-success-redirect: ' + 'http://' + window.location.host + success_redirect, '*');
                    }
                } else {
                    window.location = success_redirect;
                }
            } else {
                hide_signin_spinny($this);
                if (cd_signup_frame) {
                    var errors_string = data.errors.join("^");
                    parent.postMessage('likes-signup-errors: ' + errors_string, '*');
                    if (window.parent && pass_to_js.likes_upsell) {
                        render_signin_errors(data.errors, signup_error_selector);
                    }
                } else if (data.force_reload) {
                    var redirect_params = {
                        'email': params.email,
                        'name': params.name
                    };
                    if (params.gender) {
                        redirect_params['gender'] = params.gender;
                    }
                    if (params.birthday) {
                        redirect_params['birthday'] = params.birthday;
                    }
                    if (params.token) {
                        redirect_params['token'] = params.token;
                    }
                    var redirect_url = 'http://' + window.location.host + (params.error_redirect ? params.error_redirect : '/signup');
                    if (redirect_url.indexOf('?') >= 0) {
                        redirect_url = redirect_url + '&' + $.param(redirect_params);
                    } else {
                        redirect_url = redirect_url + '?' + $.param(redirect_params);
                    }
                    window.location = redirect_url;
                } else {
                    render_signin_errors(data.errors, signup_error_selector);
                }
                $this.removeClass('clicked');
            }
        }
    });
}

function render_maxlength($this) {
    if (!$this.val() || !$this.attr("maxlength")) {
        return;
    }
    var maxlength = parseInt($this.attr("maxlength"));
    var error = $this.next(".error");
    if ($this.val().length == maxlength && error.length && !error.html().length) {
        error.html("Maximum " + maxlength.toString() + " characters.").fadeInSafe().next(".settings_message").hide();
    } else if ($this.val().length < maxlength && error.length && error.html().length) {
        error.fadeOutSafe().html('').next(".settings_message").show();
    }
}

function setup_login_dialog_events() {
    $("body").on({
        'click': function(e) {
            show_signin_spinny($(this));
        }
    }, "#signup_twitter_button, #signup_twitter_button_upsell");
    $("body").on({
        'submit': function(e) {
            return false;
        }
    }, "#signup_form, #signup_form_gallery_upsell, #login_form, #forgot_password_form");
    $("body").on({
        'click': function() {
            submit_signup_form($(this));
        }
    }, '.submit_signup_form');
    $("body").on({
        'click': function() {
            submit_login_form();
        }
    }, '#submit_login_form');
    $("body").on({
        'click': function() {
            submit_forgot_password_form();
        }
    }, '#submit_forgot_password_form');
    $("body").on({
        'keypress': function(e) {
            var key_code = (e.which) ? e.which : e.keyCode;
            if (key_code == 13 && $(this).val()) {
                submit_forgot_password_form();
            }
        }
    }, '#forgot_password_form .logintext');
    $("body").on({
        'keypress': function(e) {
            var $this = $(this);
            var key_code = (e.which) ? e.which : e.keyCode;
            if (key_code == 13 && $this.val()) {
                submit_signup_form($this.parents("form").find(".submit_signup_form"));
            } else {
                render_maxlength($this);
            }
        },
        'change': function(e) {
            render_maxlength($(this));
        },
        'keyup': function(e) {
            render_maxlength($(this));
        }
    }, '#signup_form .logintext, #signup_form_gallery_upsell .logintext');
    $("body").on({
        'keypress': function(e) {
            var key_code = (e.which) ? e.which : e.keyCode;
            if (key_code == 13 && $(this).val()) {
                submit_login_form();
            }
        }
    }, '#login_form .logintext');
    $("body").on({
        "click": function(e) {
            if ($(this).hasClass("no_ajax")) {
                return;
            }
            if (window.State && window.State.page_state) {
                return;
            };
            e.preventDefault();
            var $this = $(this);
            var display = {
                'redirect_url': $(this).attr('redirect_url') || '/',
                'error_redirect': '/login',
                'new_login': 1,
                'referer_url': $("#referer_url").val(),
                'referer_param': $("#referer_param").val()
            };
            if (PageData.friendlife_upsell) {
                var markup = jinja.fl_login_form(display, true);
            } else {
                var markup = jinja.login_form(display, true);
            }
            $this.parent().empty().html('').html(markup);
            Forms.initDefaults(".logintext");
        }
    }, "#show_login_fields");
    $("body").on({
        "click": function(e) {
            if ($(this).hasClass("no_ajax")) {
                return;
            }
            if (window.State && window.State.page_state) {
                return;
            };
            e.preventDefault();
            var markup;
            var $this = $(this);
            var display = {
                'redirect_url': $(this).attr('redirect_url') || '/',
                'error_redirect': '/signup',
                'referral_code': $this.attr('referral_code'),
                'new_login': 1,
                'referer_url': $("#referer_url").val(),
                'referer_param': $("#referer_param").val()
            };
            if (true || (window.pass_to_js && window.pass_to_js.experiment_config && window.pass_to_js.experiment_config.agegender)) {
                display['agegender'] = 1;
            }
            var pass_to_js = window.pass_to_js || window.PageData || {};
            if (pass_to_js.birthday_params) {
                $.extend(display, pass_to_js.birthday_params);
            }
            ['curr_name', 'age', 'gender', 'birthday', 'email_to_display'].forEach(function(key) {
                if (pass_to_js['signup_' + key]) {
                    display[key] = pass_to_js['signup_' + key];
                }
            });
            display.gallery_homepage = pass_to_js.gallery_homepage;
            display.friendlife_upsell = pass_to_js.friendlife_upsell;
            display['experiment'] = {
                'config': {
                    'enable_twitter_signup': pass_to_js.experiment_config.enable_twitter_signup
                }
            };
            display['photo_verify_signup'] = (pass_to_js.experiment_config.photo_verify_signup && !pass_to_js.experiment_config.require_captcha);
            display['signup_token'] = pass_to_js.signup_token;
            display['product_name'] = pass_to_js.product_name;
            if ($("#upsell_form").length) {
                display['gallery_upsell'] = 1;
            }
            if (!$("#landing_content_container").is(":visible")) {
                display['in_page'] = 1;
            }
            if (pass_to_js.friendlife_upsell) {
                markup = jinja.fl_signup_form(display, true);
            } else {
                markup = jinja.signup_form(display, true);
            }
            var $container = $(this).parent();
            $container.empty().html('').html(markup);
            if ($("#footer_content").length) {
                position_footer();
            }
            Forms.initDefaults(".logintext");
            setup_captcha($container);
            setup_signup_events();
            $("#feed_example .scrollable").addClass('still');
        }
    }, "#show_signup_fields");
    $("body").on({
        "click": function(e) {
            if ($(this).hasClass("no_ajax")) {
                return;
            }
            e.preventDefault();
            var markup;
            var $this = $(this);
            var display = {
                'redirect_url': $(this).attr('redirect_url') || '/',
                'error_redirect': '/signup',
                'referral_code': $this.attr('referral_code'),
                'new_login': 1,
                'referer_url': $("#referer_url").val(),
                'referer_param': $("#referer_param").val()
            };
            var pass_to_js = window.pass_to_js || window.PageData || {};
            display.gallery_homepage = pass_to_js.gallery_homepage;
            display.show_email_signup = (!pass_to_js.experiment_config.hide_email_signup);
            display.likes_upsell = pass_to_js.likes_upsell;
            if (!pass_to_js.f_upsell) {
                if (pass_to_js.friendlife_upsell) {
                    markup = jinja.fl_login_form(display);
                } else {
                    markup = jinja.login_form(display);
                }
            } else {
                markup = jinja.friendlife_upsell_login(display);
            }
            $this.parent().empty().html('').html(markup);
            if ($("#footer_content").length) {
                position_footer();
            }
            $("#feed_example .scrollable").removeClass('still');
            Forms.initDefaults(".logintext");
        }
    }, "#hide_signup_fields");
    $("#fb_default_continue").on({
        'click': function() {
            var $form = $("#fb_default_content");
            var data = {
                'name': $form.find("#name").val(),
                'user_name': $form.find("#user_name").val(),
                'age': $form.find("#age").val(),
                'gender': $form.find("#gender").val()
            };
            PageData.save_user_info(data);
            PageData.track_event('fb_username_cont', PageData.my_info.user_id);
        }
    });
    $("body").on({
        'click': function() {
            var signup_error_selector = ERROR_SELECTOR;
            $(signup_error_selector).empty().html();
            var params = {};
            params.ajax = true;
            params.email = params.email = $.trim($form.find("input[name='email']").val());
            params.redirect_url = $form.find("input[name='redirect_url']").val();
            $.ajax({
                dataType: 'json',
                url: Api.get_uri('forcepartner'),
                data: $.param(params),
                type: 'POST',
                success: function(data) {
                    if (data.success) {
                        window.location = data.redirect_url;
                    } else {
                        render_signin_errors(data.errors, signup_error_selector);
                    }
                }
            });
        }
    }, '.make_partner_link');
    $("#feed_link").click(function() {
        parent.postMessage('likes-success-redirect: ' + 'http://' + window.location.host + '/feed', '*');
    });
    $("#channel_login_tab").on('click', function(e) {
        if (!$(this).hasClass("no_ajax")) {
            e.preventDefault();
            var opts = {
                'form_type': 'login'
            };
            render_login_prompt(opts);
        }
    });
    $("#channel_signup_tab").on('click', function(e) {
        if (!$(this).hasClass("no_ajax")) {
            e.preventDefault();
            var opts = {
                'form_type': 'signup_upsell'
            };
            render_login_prompt(opts);
        }
    });
    $("#channel_signin_tab").on('click', function(e) {
        if (!$(this).hasClass("no_ajax") && !PageData.users[PageData.feed.user_id].domain_name) {
            e.preventDefault();
            render_login_prompt();
        }
    });
    $("body").on({
        'click': function() {
            close_login_prompt();
        }
    }, "#login_dialog_container .close_button_container, #twitter_login_dialog_wrapper .close_button_container");
    $("#login_dialog_wrapper").on('click', function(e) {
        if (e.target.className == "dialog_content_over_transparent") {
            close_login_prompt();
        }
    });
}
$(document).ready(function() {
    setup_login_dialog_events();
    if (window.parent) {
        if (window.pass_to_js) {
            if (window.pass_to_js.follow_success) {
                parent.postMessage('likes-follow-success', '*');
            }
        }
    }
    if ($("#desktop_landing_container").length) {
        setTimeout(function() {
            setup_captcha($("#login_dialog_container"))
        }, 1000);
    }
});
$().ready(function() {
    $("#homepage_signup_form").on('click', '#show_login_form', function() {
        $("#show_login_form").hide();
        $("#login_form_fields").show().css('display', 'block');
        $("#submit_login_form").show().css('display', 'block');
        $("#feed_example .scrollable").addClass('still');
    });
    $("#homepage_signup_form").on('focus', 'input', function() {
        $("#feed_example .scrollable").addClass('still');
    });
    $("#homepage_signup_form").on('focusout', 'input', function() {
        $("#feed_example .scrollable").removeClass('still');
    });
});

function noop() {};
window.console = window.console || {
    log: noop,
    error: noop
};
Array.prototype.max = function() {
    if (this.hasOwnProperty('length')) {
        return Math.max.apply(Math, this);
    }
};
Array.prototype.min = function() {
    if (this.hasOwnProperty('length')) {
        return Math.min.apply(Math, this);
    }
};
jQuery.fn.fadeInSafe = function(opt_time, opt_cb) {
    var $this = this;
    $this.fadeIn(opt_time, opt_cb);
    return this;
};
jQuery.fn.fadeOutSafe = function(opt_time, opt_cb) {
    var $this = this;
    $this.fadeOut(opt_time, opt_cb);
    return this;
};

function num_true_in_object(obj) {
    var num_true = 0;
    for (var k in obj) {
        if (obj[k]) {
            num_true++;
        }
    }
    return num_true;
};

function module(name) {
    if (window[name]) {
        return window[name];
    }
    return window[name] = {};
}

function now() {
    return (new Date()).getTime();
}

function page_ready() {
    if ($.fn.tipsy) {
        $('img.tooltip,a.tooltip,div.tooltip').tipsy({
            delayIn: 100,
            fade: 150,
            opacity: 1,
            live: true,
            gravity: function() {
                return $(this).attr("tooltip-gravity") || 's';
            }
        });
    }
}
$().ready(page_ready);

function doSetCaretPosition(oField, iCaretPos) {
    if (document.selection) {
        oField.focus();
        var oSel = document.selection.createRange();
        oSel.moveStart('character', -oField.value.length);
        oSel.moveStart('character', iCaretPos);
        oSel.moveEnd('character', 0);
        oSel.select();
    } else if (oField.selectionStart || oField.selectionStart == '0') {
        oField.selectionStart = iCaretPos;
        oField.selectionEnd = iCaretPos;
        oField.focus();
    }
}

function is_ipad() {
    var ua = navigator.userAgent;
    var isiPad = /iPad/i.test(ua);
    return isiPad;
}

function is_small_screen_ios_device() {
    return navigator.userAgent.match(/(iPhone)|(iPod)/i);
}

function unwrap_thumbnail(url) {
    if (!url || url === undefined) {
        return;
    }
    var info = url.match(/http:\/\/upload.mylikes.com\/thumb\/yt:[a-z0-9A-Z_\-]+\?thumbnail=([^&]*)&/);
    if (info) {
        return unescape(info[1]);
    }
    return url;
}

function float_message_near($div, message) {
    var $floater = $('<div class="floating_notification">' + message + '</div>');
    var offset = $div.offset();
    $$('body').append($floater);
    $floater.css({
        top: (offset.top + 5) + 'px',
        left: (offset.left + $div.width() / 2 - $floater.width() / 2) + 'px'
    });
    $floater.animate({
        top: "-=25",
        opacity: 0
    }, 1500, 'linear', function() {
        $floater.remove();
    });
}

function validateURL(val, elem) {
    val = $.trim(val);
    if (val.length == 0) {
        return true;
    }
    if (!/^(https?|ftp):\/\//i.test(val)) {
        val = 'http://' + val;
        $(elem).val(val);
    }
    return /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&amp;'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&amp;'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&amp;'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&amp;'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&amp;'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(val);
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    return (results == null) ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}
error_handling_broken = false;
in_error_handler = false;
window.onerror = function(m, u, l) {
    if ((u == null || u.length == 0) && l == 0 && m == 'Script error.') return false;
    if (error_handling_broken) return false;
    if (in_error_handler) {
        error_handling_broken = true;
        return false;
    }
    in_error_handler = true;
    if (window.$) {
        var message = "  user: " + (window.PageData && PageData.my_info && PageData.my_info.user_name || 'loggedout') + ' - url: ' + window.location.href + '\n';
        message += '  message: ' + m + '\n';
        message += '  url: ' + u + '\n';
        message += '  line: ' + l;
        if (window.likes_error_tracking) {
            $.post('/api/track_error', {
                'message': message
            }).error(function() {
                error_handling_broken = true;
            });
        }
    }
    in_error_handler = false;
    return false;
};

function add_image_ids_to_class() {
    $('.need_id').each(function() {});
}

function insert_tag(tag, hash, tag_id) {
    tag = tag || "";
    if (tag_id != "photography") {
        tag = Helpers.get_tags(tag, hash);
        if (tag.length) {
            tag = tag[0];
        }
    }
    tag_id = tag_id || tag;
}

function render_crowded_images(image_id) {
    var image = PageData.images[image_id];
    if (!(image && image.crowded_image_ids && image.crowded_image_ids.length)) {
        return;
    }
    var crowded_image_ids = image.crowded_image_ids;
    var images = Helpers.buildRenderData(crowded_image_ids, 'images', PageData);
    render_images_after_id(image_id, images, true, null);
}
var last_rt_image_id;

function render_images_after_id(image_id, image_data, animate, max_images) {
    var realtime;
    if (!image_data) {
        realtime = true;
        if (max_images) {
            image_data = PageData.RT_FEED.slice(0, max_images);
            PageData.RT_FEED_NOT_SEEN.push(image_data);
            PageData.RT_FEED = PageData.RT_FEED.slice(max_images);
        } else {
            image_data = PageData.RT_FEED;
        }
        if (image_data.length) {
            last_rt_image_id = image_data[0].image_id;
        }
        if (!max_images) {
            $("#rt_feed_notification").fadeOutSafe(200);
        }
    }
    var display = {
        'my_info': PageData.my_info,
        'view': State.view,
        'crowded': 1,
        'internal_only': PageData.internal_only,
        'page_state': State.page_state,
        'caption_below_post': PageData.caption_below_post
    };
    display.images = image_data;
    display.hostname = window.location.hostname;
    display.realtime = realtime;
    for (var i = 0; i < display.images.length; i++) {
        if (animate) {
            display.images[i].inserted_image = 1;
        }
        if (!(display.images[i].nsfw || display.images[i].mistage || display.images[i].is_spam)) {
            if (!PageData.internal_only && display.images[i].user_id != PageData.my_info.user_id) {
                display.images[i].public_mod = 1;
            }
        }
    }
    var $images = PageData.experiment_config.new_friendlife_site ? jinja.feed_post_list(display) : jinja.images_list_jinja(display);
    $cur_post = ($("#crowded_after_" + image_id).length) ? $("#crowded_after_" + image_id) : $("#image_" + image_id);
    $cur_post.after($images);
    $images.find('.tooltip').tipsy({
        delayIn: 100,
        fade: 150,
        opacity: 1,
        live: true,
        gravity: 's'
    });
    if (animate) {
        if (!max_images) {
            window.setTimeout(function() {
                var headers = 50;
                var $first_elem;
                if (realtime) {
                    if (window.rt_feed_after_image_id) {
                        $first_elem = $("#realtime_" + last_rt_image_id);
                        if (!$first_elem.size()) $first_elem = $("#image_" + last_rt_image_id);
                        $("#image_" + last_rt_image_id + " .list_view_content_container").removeClass('no_shadow');
                    } else {
                        $first_elem = $("#realtime_" + display.images[0].image_id);
                    }
                } else {
                    $first_elem = $("#image_" + display.images[0].image_id);
                }
                var offset = $first_elem.offset().top - headers;
                $("html,body").animate({
                    scrollTop: offset
                }, 200);
            }, 10);
        }
        window.setTimeout(function() {
            $(".image .list_view_content_container").addClass("no_shadow");
            if (window.rt_feed_after_image_id && last_rt_image_id) {
                $("#image_" + last_rt_image_id).find('.list_view_content_container').addClass('no_shadow');
            }
        }, 800);
    }
    if (realtime && !max_images) {
        PageData.RT_FEED = [];
        PageData.RT_FEED_NOT_SEEN = [];
    }
}

function render_full_comment(selector) {
    var $comment = $(selector);
    $comment.find(".comment_ellipses").hide();
    $comment.find(".long_comment").show();
}

function render_follow_all_success() {
    $("#follow_all_subscriptions").addClass("set").removeClass("blue_button").addClass("blue_button_set");
    var $buttons, $button, i, l;
    if (State.page_state != "tagged") {
        $buttons = $(".subscribe_button.blue_button");
        for (i = 0, l = $buttons.length; i < l; i++) {
            $button = $($buttons[i]);
            render_change_button_state($button, "subscribed");
        }
    } else {
        $buttons = $(".subscribe_button.text_only.not_subscribed");
        for (i = 0, l = $buttons.length; i < l; i++) {
            $button = $($buttons[i]);
            render_change_button_state($button, "text_subscribed");
        }
    }
}

function render_nsfw_ok(image_id) {
    var $feed_image = $("#image_" + image_id);
    if ($feed_image.length) {
        $feed_image.find(".nsfw_overlay").hide();
    }
    if ($("#backpage").is(":visible")) {
        $("#backpage").find(".nsfw_overlay").hide();
    }
}

function open_cover_photo_dialog() {
    if (State.page_state != 'user' && State.page_state != 'settings') {
        return;
    }
    var cover_photo_ids = [];
    for (var i = 1; i < 22; i++) {
        cover_photo_ids.push({
            'cp_id': i,
            'cdn_num': (i % 4) + 1
        });
    }
    var info = {
        'cover_photo_ids': cover_photo_ids
    };
    var $wrapper = $("#common_dialog_wrapper");
    Helpers.disableScroll();
    $wrapper.html('').html(jinja.cover_photo_dialog(info, true)).show();
}

function render_change_cover_photo(data) {
    if (State.page_state != 'user' && State.page_state != 'settings') {
        return;
    }
    $("#cover_photo_image").attr("src", data.new_cover_photo).show();
    $(".cover_photo_image_bg").css("background-image", "url('" + data.new_cover_photo + "')");
    $("#remove_cover_photo").fadeIn();
    hide_common_dialog();
}

function open_action_users_dialog(item_id, action_type) {
    var display = {
        'item_id': item_id,
        'action_type': action_type,
    };
    var $wrapper = $("#common_dialog_wrapper");
    Helpers.disableScroll();
    $wrapper.html('').html(jinja.action_users_dialog(display, true)).show();
    if (action_type == "likes") {
        PageData.get_likes(item_id);
    } else if (action_type == "comment_likes") {
        PageData.get_comment_likes(item_id);
    }
}

function open_remove_dialog(image_id, gallery_id, extra_msg) {
    var info = {
        'image_id': image_id,
        'gallery_id': gallery_id || '',
        'extra_msg': extra_msg || ''
    };
    var $wrapper = $("#common_dialog_wrapper");
    Helpers.disableScroll();
    $wrapper.html('').html(jinja.remove_dialog(info), true).show();
}

function fb_like_callback() {
    if ($("#like_us_outer").length) {
        $("#like_us_inner").animate({
            height: "500px"
        }, 100);
        $("#like_us_headline").html("<p>Thanks, we like you too!</p><p><span class='cancel button blue_button med_button'>Continue to Your Feed  &raquo;</span></p>");
    }
}

function open_like_us() {
    var $wrapper = $("#common_dialog_wrapper");
    Helpers.disableScroll();
    $wrapper.html('').html(jinja.like_us_dialog({}, true));
    if (window.FB) {
        try {
            FB.XFBML.parse();
            $wrapper.show();
        } catch (e) {}
    }
}

function set_content_height($content) {
    var height = $(window).height() - ($content.outerHeight() - $content.height());
    if ($content.height() < height) {
        $content.css({
            "min-height": height + 'px'
        });
    }
};

function show_share_dialog($button, form_type, source_action, get_info) {
    $button = $button || [];
    form_type = form_type || "";
    get_info = get_info || false;
    var image_id, gallery_id;
    var info = {};
    var $form = $$("#common_dialog_wrapper");
    var display = {};
    var fields = ['image_id', 'width', 'height', 'thumb_url', 'caption', 'source_url', 'attribution_url', 'tags', 'nsfw', 'type', 'original_image_id', 'description', 'parsed_description'];
    var field;
    var i, l;
    if ($button.length > 0) {
        $(".sharing").removeClass('sharing');
        $button.addClass('sharing');
        image_id = $button.attr('image_id');
        gallery_id = $button.attr("gallery_id");
        info = PageData.images[image_id];
        Search.adding_temp_id = image_id;
    }
    display.form_type = form_type;
    display.my_picture = PageData.my_info.picture;
    if (form_type == "reshare") {
        var user_id = info.original_user_id || info.user_id;
        display.user_info = PageData.users[user_id];
    }
    if (info) {
        for (i = 0, l = fields.length; i < l; i++) {
            field = fields[i];
            if (info && info[field]) {
                display[field] = info[field];
            }
        }
    } else {
        return;
    }
    if (display.nsfw) {
        return;
    }
    display['source_url'] = display['source_url'] || $("#single_image_thumbnail").attr("src");
    display['image_id'] = display['image_id'] || $("#single_image_thumbnail").attr("image_id");
    if (display['type'] == 'text' || display['type'] == 'link' || display['type'] == 'video') {
        display['description'] = info['description'];
        display['short_description'] = info['short_description'];
    }
    var markup;
    if (form_type == "add") {
        display.need_image = 1;
        display.host = window.location.host;
    } else {
        if (display['tags']) {
            display.ft_tag = find_ft_tag(display['tags']);
        }
        if (info && form_type == "reshare_gallery") {
            var gallery_info = PageData.galleries[info.gallery_id];
            display['gallery_id'] = gallery_info.gallery_id;
            display['title'] = gallery_info.title;
            display['tags'] = gallery_info.tags || [];
            display['gallery_type'] = gallery_info.gallery_type;
        }
        display.add_source = form_type;
    }
    if (PageData.experiment_config.enable_ugc_video) {
        display.video = true;
    }
    display.fb_uid = PageData.my_info.fb_uid;
    display.fb_post_to_wall = PageData.fb_post_to_wall;
    display.fb_post_to_wall_deny = PageData.fb_post_to_wall_deny;
    display.suggested_tags = PageData.suggested_tags;
    display.reshare_preserve_original = PageData.experiment_config.reshare_preserve_original;
    PageData.track_event("share_dialog_rendered", source_action, "");
    if (PageData.page_path == "partner") {
        markup = ich.add_image_form_paid(display);
    } else {
        markup = ich.add_image_form(display);
    }
    $(markup).find('.tooltip').tipsy({
        delayIn: 100,
        fade: 150,
        opacity: 1,
        gravity: 's'
    });
    $form.empty().html('').html(markup).show();
    Forms.initDefaults(".share_input");
    Helpers.disableScroll();
}

function hide_common_dialog(closed) {
    closed = closed || false;
    if ($("#verify_profile_dialog").length) {
        if ($("#verify_profile_wrapper").hasClass('verified')) {
            return window.location.reload();
        }
        webcam.clear_audio_check();
        $$("#webcam_wrapper").hide().html('').removeClass('verification');
        if (State.page_state != 'verification') {
            Helpers.enableScroll();
        }
    } else if (!$("#livestream_view").is(":visible")) {
        Helpers.enableScroll();
    }
    $$("#common_dialog_wrapper").hide();
    Notifications.fadeStaticNotification();
    if ($("#message_setting_final").length) {
        window.location.reload();
    }
}
var Render = (function() {
    var my = {};
    my.render_fb_share_popup = function(item_opts) {
        var params = PageData.get_fb_post_content(item_opts);
        var fb_url = "https://www.facebook.com/dialog/feed?display=popup";
        var app_id = $("#fb-root").attr("appid");
        if (app_id.length) {
            fb_url = fb_url + "&app_id=" + app_id;
        }
        var fb_params = ["name", "link", "picture"];
        for (var i = 0; i < fb_params.length; i++) {
            if (params[fb_params[i]]) {
                fb_url = fb_url + "&" + fb_params[i] + "=" + encodeURIComponent(params[fb_params[i]]);
            }
        }
        fb_url = fb_url + "&caption=" + encodeURIComponent(params.likesdotcom);
        fb_url = fb_url + "&description=" + encodeURIComponent(params.description);
        fb_url = fb_url + "&redirect_uri=http://" + window.location.host + "/close_window.html";
        window.open(fb_url, "fb_popup", "width=600,height=310");
    }, my.position_fixed_elements = function(scroll_y) {
        scroll_y = scroll_y || null;
        var $sidebar, sidebar_diff;
        if (PageData.sidebar) {
            $sidebar = $("#side_info_container_inner");
            sidebar_diff = $("#side_info_container_inner").outerHeight() - PageData.window_height;
            if (PageData.sidebar == "sidebar_fixed") {
                if (sidebar_diff > 0) {
                    if (scroll_y > sidebar_diff) {
                        $sidebar.css({
                            "position": "fixed",
                            "top": sidebar_diff * -1
                        });
                    } else {
                        $sidebar.css({
                            "position": "absolute",
                            "top": "auto"
                        });
                    }
                } else {
                    $sidebar.parent().css({
                        "position": "fixed",
                        "top": "auto"
                    });
                }
            }
            var min_left = $("#channel_images_wrapper").outerWidth() || 750;
            if (PageData.sidebar) {
                $sidebar = $("#side_info_container");
                sidebar_diff = $("#side_info_container").outerWidth() + min_left - PageData.window_width;
                if (sidebar_diff > 0) {
                    $sidebar.css({
                        "right": "auto",
                        "left": min_left
                    });
                } else {
                    $sidebar.css({
                        "left": "auto",
                        "right": 0
                    });
                }
            }
        }
    };
    my.maybe_setup_content_height = function() {
        Helpers.get_window_dimensions();
        var $channel_images = $('#channel_images');
        var $thepage = $$("#thepage");
        if ($channel_images.length) {
            set_content_height($thepage);
            $(window).resize(function() {
                set_content_height($thepage);
            });
        } else if ($thepage.length) {
            set_content_height($thepage);
            $(window).resize(function() {
                set_content_height($thepage);
            });
        }
    };
    my.get_grid_content_height = function() {
        return $('#channel_images').height();
        var $last_image = $('.image:last');
        var top = $$('#thepage').position().top;
        var bottom = ($last_image.length) ? $last_image.position().top + $last_image.outerHeight() : 0;
        return top + bottom;
    };
    my.set_side_module_height = function() {
        var available_height = $("#side_info_container").innerHeight() - $("#feed_side_user_info").outerHeight(true) - $("#side_trending_tags").outerHeight(true) - $("#header").outerHeight(true);
        var user_height = $(".side_suggested_user").outerHeight(true);
        var max_users_to_display = Math.floor(available_height / user_height) - 1;
        var final_height = max_users_to_display * user_height - 1;
        if (final_height > 0) {
            $("#who_to_follow").css("height", final_height + "px");
        }
    };
    my.render_like_success = function(image_id) {
        var info = {
            'user': Helpers.copyObj(PageData.my_info),
            'my_info': Helpers.copyObj(PageData.my_info)
        };
        info.thats_me = true;
        var $feed_image = $("#image_" + image_id);
        var $list, $faces, my_face_markup, $my_face, new_num_likes;
        var $stream = $("#livestream_view[image_id=" + image_id + "]");
        var new_num_likes;
        if ($stream.size()) {
            if (PageData.experiment_config.old_stream_ui) {
                new_num_likes = parseInt($stream.find(".like_stat[image_id=" + image_id + "] span").text() || 0) + 1;
            } else {
                new_num_likes = parseInt($("#livestream_actions").find(".like_stat[image_id=" + image_id + "] span").text() || 0) + 1;
            }
        } else {
            new_num_likes = parseInt($feed_image.find(".like_image_button[image_id=" + image_id + "]").parent().find(".num_likes_value").text() || 0) + 1;
        }
        $(".liking").attr('original-title', 'Liked!').find(".like_icon").addClass("set");
        var $tipsy = $(".tipsy-inner");
        if ($tipsy.text() == "Like" || $tipsy.text() == "Unlike") {
            $tipsy.text("Liked!");
        }
        var $feed_like_buttons = $("#image_" + image_id + " .like_image_button");
        $feed_like_buttons.each(function() {
            var $this = $(this);
            if (!$this.hasClass("set")) {
                $this.addClass("set").attr('original-title', 'Liked!').find(".label").text("Liked");
            }
            if ($this.hasClass("blue_button")) {
                $this.removeClass("blue_button").addClass("blue_button_set");
            }
        });
        $feed_image.find(".num_likes_value").text(new_num_likes).addClass("set");
        $feed_image.find(".like_image_container").addClass('set').find('.heart-grey').removeClass('heart-grey').addClass('heart-red');
        $feed_image.find('.num_likes_text').text((new_num_likes == 1) ? "Like" : "Likes");
        var markup = "<span>" + new_num_likes + "</span> like";
        if (new_num_likes != 1) markup += "s";
        $stream.find(".like_stat[image_id=" + image_id + "]").empty().html(markup);
        $stream.find(".like_image_button[image_id=" + image_id + "]").addClass("set").addClass('blue_button_set').removeClass('blue_button');
        $("#livestream_actions").find(".like_stat[image_id=" + image_id + "]").empty().html(markup);
        $("#livestream_actions").find(".like_image_button[image_id=" + image_id + "]").addClass("set").addClass('blue_button_set').removeClass('blue_button');
        $my_face = $feed_image.find(".thats_me");
        $list = $feed_image.find(".share_info_thumbs");
        var suffix = "";
        if ($list.length && $list.find(".no_likes_msg").length) {
            $list.find(".like_msg_end").show();
        } else {
            if ($list.find(".recent_like_user").length > 2) {
                $list.find(".recent_like_user").last().hide();
                $list.find(".leftover_like_count").text(parseInt($list.find(".leftover_like_count").text()) + 1);
            }
        }
        if ($my_face.length == 0) {
            var profile = window.Jasinja.filters.profile(PageData.my_info.user_name);
            var like_thumb = window.Jasinja.filters.user_thumb(PageData.my_info.picture, "100x100.crop");
            var my_markup = "<span class='recent_like thats_me'><img class='like_thumb first' src='" + like_thumb + "'<a class='likes-blue recent_like_user' href='" + profile + "'>You</a>" + suffix + "</span>";
            $list.prepend(my_markup);
            $list.find(".ending_s").hide();
        }
    };
    my.render_unlike_success = function(image_id, gallery_id) {
        var image = PageData.images[image_id];
        gallery_id = gallery_id || 0;
        var gallery = PageData.galleries[gallery_id];
        if (gallery) {
            image_id = (State.page_state != "single_image") ? gallery.cover_image_id : PageData.feed.image_ids[0];
        }
        var $feed_image = $("#image_" + image_id);
        var $like_icon = $(".unliking");
        $like_icon.find(".like_icon").removeClass("set");
        $like_icon.removeClass("set").addClass("just_unliked").attr('original-title', 'Like');
        if ($like_icon.hasClass("blue_button_set")) {
            $like_icon.removeClass("blue_button_set").addClass("blue_button").find(".label").text("Like");
        }
        var $tipsy = $(".tipsy-inner");
        if ($tipsy.text() == "Liked!" || $tipsy.text() == "Unlike") {
            $tipsy.text("Unliked!");
        }
        var $feed_like_buttons = $("#image_" + image_id + " .like_image_button");
        $feed_like_buttons.each(function() {
            var $this = $(this);
            if ($this.hasClass("set")) {
                $this.removeClass("set").attr('original-title', 'Like');
            }
            if ($this.hasClass("blue_button_set")) {
                $this.removeClass("blue_button_set").addClass("blue_button");
            }
        });
        var $stream = $("#livestream_view[image_id=" + image_id + "]");
        var new_num_likes;
        if ($stream.length) {
            if (PageData.experiment_config.old_stream_ui) {
                new_num_likes = parseInt($stream.find(".like_stat[image_id=" + image_id + "] span").text() || 0) - 1;
            } else {
                new_num_likes = parseInt($("#livestream_actions").find(".like_stat[image_id=" + image_id + "] span").text() || 0) - 1;
            }
        } else {
            new_num_likes = parseInt($(".like_image_button[image_id=" + image_id + "]").parent().find(".num_likes_value").text() || 0) - 1;
        }
        if (new_num_likes < 0) new_num_likes = 0;
        $feed_image.find(".num_likes_value").text(new_num_likes).removeClass("set");
        $feed_image.find('.like_image_container').removeClass('set').find('.heart-red').removeClass('heart-red').addClass('heart-grey');;
        $feed_image.find('.num_likes_text').text((new_num_likes == 1) ? "Like" : "Likes");
        $stream.find(".like_image_button[image_id=" + image_id + "]").removeClass('set').addClass('blue_button').removeClass('blue_button_set');
        var markup = "<span>" + new_num_likes + "</span> like";
        if (new_num_likes != 1) markup += "s";
        $stream.find(".like_stat[image_id=" + image_id + "]").empty().html(markup);
        $("#livestream_actions").find(".like_image_button[image_id=" + image_id + "]").removeClass('set').addClass('blue_button').removeClass('blue_button_set');
        $("#livestream_actions").find(".like_stat[image_id=" + image_id + "]").empty().html(markup);
        var $my_face = $feed_image.find(".thats_me");
        if ($my_face.length) {
            $my_face.remove();
            var num_faces = $feed_image.find(".recent_like").length;
            if (!num_faces) {
                $feed_image.find(".like_msg_end").hide();
            }
            if (num_faces == 1) {
                $feed_image.find(".ending_s").show();
            }
        }
    };
    my.render_delete_image = function(image_id) {
        hide_common_dialog();
        if ($$("#backpage").is(":visible")) {
            if (PageData.feed.image_ids.length) {
                nav_hover_player('next');
            } else {
                collapse_hover_player();
            }
        }
        if (State.page_state == "single_image") {
            window.location = '/' + PageData.my_info.user_name;
        }
        $('#image_' + image_id).fadeOut(111);
    };
    my.render_delete_comment = function(image_id, comment_id) {
        hide_common_dialog();
        var image = PageData.images[image_id];
        var $feed_image = $("#image_" + image_id);
        $("#list_comment_" + comment_id).fadeOutSafe();
        $("#livestream_comment_" + comment_id).fadeOutSafe();
    };
    my.render_like_comment = function(comment_id, curr_likes) {
        var $target_comment;
        $target_comment = $("#livestream_comment_" + comment_id);
        if ($target_comment.length) {
            if (curr_likes == 0) {
                $target_comment.find(".plus_one_count").html('').hide();
            } else {
                $target_comment.find(".plus_one_count").html('+' + curr_likes).show();
            }
            if ($target_comment.find(".like_comment").hasClass("user_liked")) {
                $target_comment.find(".like_comment").removeClass("user_liked");
            } else {
                $target_comment.find(".like_comment").addClass("user_liked");
            }
            return;
        }
        hide_common_dialog();
        $target_comment = $("#list_comment_" + comment_id);
        if (curr_likes == 0) {
            $target_comment.find(".plus_one_count").html('').hide();
        } else {
            $target_comment.find(".plus_one_count").html('+' + curr_likes).show();
        }
        if ($target_comment.find(".like_comment").hasClass("user_liked")) {
            $target_comment.find(".like_comment").removeClass("user_liked");
        } else {
            $target_comment.find(".like_comment").addClass("user_liked");
        }
    };
    my.render_reshare_before_send = function(data) {
        var $button = $(".reshare_image_button[image_id=" + data.reshared_image_id + "]").hide();
        $("#image_" + data.reshared_image_id).addClass("sharing");
    };
    my.render_reshare_image = function(data, my_info) {
        var image_id = data.reshared_image_id;
        var gallery_id = data.reshared_gallery_id;
        var gallery = PageData.galleries[gallery_id];
        if (gallery) {
            image_id = (State.page_state != "single_image") ? gallery.cover_image_id : PageData.feed.image_ids[0];
        }
        var image = PageData.images[image_id];
        var $feed_image = $("#image_" + image_id);
        var $list, $faces, my_face_markup, $my_face, new_num_shares;
        hide_common_dialog();
        new_num_shares = (gallery) ? gallery.num_shares : image.num_shares;
        Notifications.renderTemporaryNotification("success_white", "Success! This image will now appear on your profile. <a href='/" + PageData.my_info.user_name + "'>Click here to see it.</a>");
        var $feed_share_buttons = $("#image_" + image_id + " .reshare_image_button");
        $feed_share_buttons.each(function() {
            var $this = $(this);
            if (!$this.hasClass("set")) {
                $this.addClass("set").attr('original-title', 'Shared!').find(".label").text("Shared");
            }
            if ($this.hasClass("blue_button")) {
                $this.removeClass("blue_button").addClass("blue_button_set");
            }
        });
    };
    var $win = $(window);
    my.render_add_comment = function(image_id, new_comment_info, opt_user) {
        var $feed_image = $("#image_" + image_id);
        var feed_type;
        var markup, $feed_comment_container;
        var my_info = opt_user || PageData.my_info;
        new_comment_info.user_name = my_info.user_name;
        new_comment_info.name = my_info.name;
        new_comment_info.picture = my_info.picture;
        new_comment_info.c_t_create = new_comment_info.t_create;
        var display = PageData.images[image_id] || {
            image_id: image_id
        };
        display['comments'] = [new_comment_info];
        display['my_info'] = PageData.my_info;
        if ($("#livestream_view[image_id=" + image_id + "]").length) {
            $feed_comment_container = $("#livestream_comments");
            if (!opt_user) {
                $("#" + image_id + "_livestream_comment_text").val("").attr("disabled", false).css("height", "32px").focus();
                $("#" + image_id + "_livestream_comment_text").attr('real_text', '');
                $('#' + image_id + '_livestream_comment_text').parent().find('.mentions_container').remove();
            }
            if (!$("#livestream_comment_" + new_comment_info.comment_id).length) {
                my.render_rt_stream_comment(image_id, jinja.livestream_comment(display));
            }
            return;
        }
        $feed_comment_container = $feed_image.find(".grid_comment_module");
        feed_type = "grid";
        if (!$feed_comment_container.length) {
            $feed_comment_container = $feed_image.find(".list_comment_feed");
            feed_type = "list";
            if (!opt_user) {
                $("#" + image_id + "_comment_text").val("").attr("disabled", false).css("height", "32px");
                $("#" + image_id + "_comment_text").attr('real_text', '');
                $('#' + image_id + '_comment_text').parent().find('.mentions_container').remove();
            }
        }
        if ($feed_comment_container.length > 0) {
            markup = PageData.experiment_config.new_friendlife_site ? jinja.feed_comment(display) : jinja.list_comment(display);
            $feed_comment_container.append(markup);
            var scroll_top = $win.scrollTop();
            var comment_top = $feed_comment_container.offset().top;
            if (comment_top < scroll_top) {
                $win.scrollTop(scroll_top + markup.outerHeight(true));
            } else if (comment_top + $feed_comment_container.outerHeight(true) < scroll_top + PageData.window_height) {
                markup.hide().slideDown();
            }
        }
    };
    my.render_rt_stream_comment = function(image_id, markup, noanimate) {
        if ($("#livestream_view[image_id=" + image_id + "]").length && (webcam.current_stream || currentRecordedStream)) {
            var $stream = $("#livestream_comments");
            if ($stream.length > 0) {
                $("#notice_starting").remove();
                if ($stream.is(':animated')) {
                    $stream.finish();
                    $stream.find('.list_comment:last').finish();
                }
                var t = $stream[0].scrollTop;
                var h_old = $stream[0].scrollHeight;
                var $markup = $(markup);
                $stream.append($markup);
                var m_height = $markup.height();
                var h_new = $stream[0].scrollHeight;
                var height = $stream.height();
                if (h_old - height - t < 100) {
                    var final_h = h_new + $markup.outerHeight(true) - height;
                    if (!noanimate) {
                        $markup.css({
                            opacity: 0,
                            height: '0px'
                        }).animate({
                            'height': m_height,
                            'opacity': 1
                        }, 'fast', null);
                    }
                    $stream.finish().animate({
                        'scrollTop': final_h + 'px'
                    }, 'fast', null);
                }
            }
        }
    };
    my.render_livestream_viewers = function(image_id, count, user, remove) {
        var viewer_text = "<span>" + count + "</span> viewer" + (count != 1 ? "s" : "");
        $(".view_stat[image_id=" + image_id + "]").html(viewer_text);
        if (user) {
            if (remove) {
                if (count < 8) {
                    $("#livestream_user_" + user.user_id).animate({
                        width: 0,
                        opacity: 0
                    }, 'slow', function() {
                        $(this).remove();
                    });
                } else {
                    $("#livestream_user_" + user.user_id).remove();
                }
            } else if (!$("#livestream_user_" + user.user_id).length) {
                var $viewer_thumb = jinja.livestream_user({
                    'user': user
                });
                $viewer_thumb.css('width', '0px').css('opacity', '0px');
                $("#user_row").prepend($viewer_thumb);
                $("#livestream_user_" + user.user_id).animate({
                    width: '37px',
                    opacity: 1
                }, 'slow', null);
            }
        }
    };
    my.render_gallery_share = function(data) {
        var gallery_id = data.reshared_gallery_id;
        var $gallery = $('div[data-gallery_id="' + gallery_id + '"]');
        $gallery.find(".gallery_share_button").addClass("set").addClass("blue_button_set").removeClass("blue_button");
        $gallery.find(".gallery_button_label").addClass("shared").text("Shared");
    };
    my.render_report_image_success = function(data) {
        var container = (State.view == "list") ? ".list_view_image" : "grid_thumb_container";
        if (State.page_state == "single_image") {
            container = "#single_image";
        } else if ($("#backpage").is(":visible")) {
            $("#browser_image_container").append(jinja.nsfw_overlay({
                'image_id': data.reported_image_id
            }));
        }
        $("#image_" + data.reported_image_id).find(container).append(jinja.nsfw_overlay({
            'image_id': data.reported_image_id
        }));
        $("#image_" + data.reported_image_id).find($(".social_media_container").hide());
    };
    my.render_action_page_before_send = function(data) {
        $("#get_next_action_page").hide();
    };
    my.render_get_action_users = function(data) {
        var new_ids = data.new_ids;
        var display = {
            'action_users': Helpers.buildRenderData(new_ids, 'users'),
            'next_action_page': data.result.next_action_page,
            'my_info': PageData.my_info
        };
        var markup = jinja.action_user_thumb(display, true);
        $("#action_users_inner").append(markup);
        if (!display.next_action_page) {
            $("#get_next_action_page").fadeOutSafe();
        } else {
            $("#get_next_action_page").fadeInSafe();
        }
    };
    my.render_get_friends_success = function(data) {
        var grid_width = $(window).width() - 100;
        var cols = ImageUtils.get_num_cols_from_width(grid_width);
        if (!cols) return;
        if (false && cols > 1) {
            $('#channel_images_grid').css({
                'max-width': (ImageUtils.COL_WIDTH * cols) + 'px'
            });
        }
    };
    my.render_get_feed = function(data) {
        var result = data.result,
            markup, markup_1, markup_2, display, add_tutorial_markup;
        var view = State.view;
        display = {
            'show_plus': PageData.feed.show_plus,
            'my_info': PageData.my_info,
            'view': State.view,
            'page_state': State.page_state,
            'internal_only': window.internal_only,
            'caption_below_post': data.result.caption_below_post,
            'experiment': {
                "config": PageData.experiment_config
            }
        };
        if (State.page_state == "user" && State.is_my_channel) {
            display.is_my_channel = true;
        }
        if (State.page_state == "label") {
            display.label = PageData.feed.label;
        }
        if (data.markup && data.markup.length) {
            markup = data.markup;
        } else {
            var feed_ids = (State.page_state != "people") ? result.feed.image_ids : result.feed.suggested_user_ids;
            feed_ids = Helpers.remove_common_elements(feed_ids, Helpers.image_ids_already_displayed());
            if (result.ads) {
                feed_ids = Helpers.remove_common_elements(feed_ids, Helpers.ads_already_displayed(), 'a:');
                feed_ids = Helpers.remove_consecutive_ads(feed_ids);
            }
            if (feed_ids.length < 1 && !PageData.feed.image_ids.length) {
                display = my.set_empty_message_info(result, display);
                PageData.next_page = undefined;
            }
            display.images = Helpers.buildRenderData(feed_ids, 'images', result);
            var final_images = [];
            for (var i = 0; i < display.images.length; i++) {
                var image = display.images[i];
                if (!$('#image_' + image.image_id).size()) {
                    final_images.push(image);
                }
            }
            display.images = final_images;
            display.hostname = window.location.hostname;
            if (display.images.length > 0 || PageData.feed.image_ids.length == 0) {
                markup = PageData.experiment_config.new_friendlife_site ? jinja.feed_post_list(display, true) : jinja.images_list_jinja(display, true);
            } else if (State.page_state == "tagged") {
                markup = jinja.feed_empty({
                    'page_state': State.page_state
                });
            }
        }
        ImageUtils.handle_thumb_sizes($(markup).find('.unprocessed img'));
        $('#feed_loading_spinny').remove();
        if (add_tutorial_markup) {
            $$("#channel_images").append(add_tutorial_markup);
        }
        $$("#channel_images").append(markup);
        $(markup).find('.tooltip').tipsy({
            delayIn: 100,
            fade: 150,
            opacity: 1,
            live: true,
            gravity: 's'
        });
    };
    my.set_empty_message_info = function(infos, render_data) {
        if (State.page_state == "user") {
            render_data.user_info = PageData.users[infos.feed.user_id];
        } else if (State.page_state == "tagged") {
            render_data.tag = infos.feed.tag;
        }
        $("#feed_view_toggle").hide();
        return render_data;
    };
    my.empty_out_feed = function() {
        $('#channel_images').html('').empty();
    };
    my.settings_initialize = function() {
        setup_validation();
        if (State.args.success) {
            Notifications.renderTemporaryNotification("success", "Your settings have been saved.");
        }
        if (State.args.error) {
            Notifications.renderTemporaryNotification("error", decodeURIComponent(State.args.error));
        }
    };
    my.unvalidated_email_notification = function(data) {
        if (State.args.emailsuccess) {
            Notifications.renderTemporaryNotification("success", "Your validation email has been sent!");
        }
    };
    my.email_validated_success = function() {
        Notifications.renderTemporaryNotification("success", "Your email has been validated!");
    };
    my.empty_feed = function() {
        return function(tmpl) {
            if (PageData.feed.image_ids && PageData.feed.image_ids.length) {
                return '';
            }
        }
    };
    my.render_notifications = function(data) {
        var markup = jinja.desktop_notifications_tab(data, true);
        var $notification_list = $('#notification_list');
        if (data.action_type != 'scroll_action') {
            $notification_list.find(".dropdown_row").remove();
        }
        $notification_list.find('.tab_dropdown_spinny').before(markup);
        PageData.loading_more_notifs = false;
        if (!data.notifications.length) {
            PageData.last_notification_id = null;
        }
    };
    my.render_messages = function(data) {
        var $messages_list = $('#messages_list');
        var end_of_messages = $messages_list.find(".end_of_messages").size();
        if (!data.threads.length && end_of_messages)
            return;
        var markup = jinja.desktop_messaging_tab(data, true);
        PageData.top_message_tab_page_num = data.next_page;
        if (PageData.message_load_action_type != 'scroll_action') {
            $messages_list.find(".dropdown_row").remove();
        }
        $messages_list.find(".tab_dropdown_spinny").before(markup);
        PageData.loading_more_messages = false;
        if (!data.next_page) {
            if (!end_of_messages) {
                markup = jinja.desktop_messaging_tab({
                    threads: []
                }, true);
                $messages_list.find(".tab_dropdown_spinny").before(markup);
            }
        }
    };
    my.render_page_title_unread_count = function() {
        var total_unread_count = PageData.my_info.unread_notification_count + PageData.my_info.unread_message_count,
            page_title = PageData.page_title;
        if (total_unread_count === undefined || total_unread_count === null) {
            return;
        }
        if (page_title.indexOf(')') != -1 && page_title.indexOf('(') != 1 && page_title.indexOf('(') == 0) {
            var pos_closing_paren = page_title.indexOf(')');
            page_title = page_title.substr(pos_closing_paren + 1);
        }
        page_title = $.trim(page_title);
        if (total_unread_count == 0) {
            PageData.page_title = page_title;
        } else {
            PageData.page_title = '(' + total_unread_count + ') ' + page_title;
        }
        document.title = PageData.page_title;
    };
    my.render_unread_notification_count = function() {
        if (!PageData.my_info.unread_notification_count) {
            PageData.my_info.unread_notification_count = 0;
            $("#notification_button .unread_count").remove();
        } else {
            if ($("#notification_button .unread_count").length) {
                $("#notification_button .unread_count").text(PageData.my_info.unread_notification_count);
            } else {
                var data = {
                    'unread_notification_count': PageData.my_info.unread_notification_count
                };
                var $markup = jinja.desktop_unread_notification_count(data);
                $('#notification_button').append($markup).show();
                my.render_page_title_unread_count();
            }
        }
    };
    my.render_unread_message_count = function() {
        if (!PageData.my_info.unread_message_count) {
            PageData.my_info.unread_message_count = 0;
            $("#messaging_button .unread_count").remove();
        } else {
            if ($("#messaging_button .unread_count").length) {
                $("#messaging_button .unread_count").text(PageData.my_info.unread_message_count);
            } else {
                var data = {
                    'unread_message_count': PageData.my_info.unread_message_count
                };
                var $markup = jinja.desktop_unread_message_count(data);
                $("#messaging_button").append($markup).show();
                my.render_page_title_unread_count();
            }
        }
    };
    return my;
}());
var Forms = (function() {
    var my = {};
    my.has_scrolled = false;
    my.global_selector = 'input[type=text], input[type=password], textarea';
    my.options = {
        'init_css': {
            'font-style': 'normal',
            'color': '#222'
        },
        'default_css': {
            "color": "#ccc",
            "font-style": "normal"
        },
        'changed_css': {
            "color": "#222",
            "font-style": "normal"
        }
    };
    my.placeholderIsSupported = function() {
        var test = document.createElement('input');
        return ('placeholder' in test);
    };
    my.updateDefaultValue = function($elem) {
        var val = $elem.val();
        var default_val = $elem.attr('placeholder') || '';
        if (val === default_val || val === '') {
            $elem.val('');
            $elem.css({
                'color': '#222',
                'font-style': 'normal'
            });
        }
    };
    my.setDefaultValue = function($elem) {
        var val = $elem.val();
        $elem.val($elem.attr('placeholder'));
        var css_package = (val === $elem.attr('placeholder') || val === '') ? my.options.default_css : my.options.changed_css;
        $elem.css(css_package);
    };
    my.initDefaults = function(selector, parent, skip_focus_first) {
        parent = parent || "body";
        selector = selector || my.global_selector;
        skip_focus_first = skip_focus_first || false;
        var i;
        var $fields, $field;
        var default_val;
        var $first_input;
        $fields = $(selector);
        $first_input = $(parent).find('.first_input').filter(':visible').filter(':first');
        if ($first_input.length) {
            if (!skip_focus_first) {
                $first_input.focus();
            }
        }
        for (i = 0; i < $fields.length; i++) {
            $field = $($fields[i]);
            default_val = $field.attr('placeholder') || '';
            if (i == 0 && !$first_input.length) {
                if (!skip_focus_first) {
                    $field.focus();
                }
            }
            $field.data('defaults_set', true);
        }
    };
    my.handleFieldError = function(msg, $field, foffset) {
        foffset = foffset || 10;
        var offset = $field.offset();
        var field_id = $field.attr('id');
        var $error_div = $("#" + field_id + "_error");
        if (!$error_div.length) {
            var markup = ich.error_msg({
                field_id: field_id,
                left: offset.left + $field.width() + foffset + 20 + 'px',
                top: offset.top + 'px',
                msg: msg
            });
            $error_div = $(markup);
            $error_div.appendTo('body');
        }
        $error_div.css({
            left: offset.left + $field.width() + foffset + 20 + 'px',
            top: offset.top + 'px'
        });
        $error_div.show();
    };
    my.setupEvents = function(selector, parent) {
        selector = selector || my.global_selector;
        parent = parent || "body";
        $(parent).on({
            'keydown': function(e) {
                Forms.updateDefaultValue($(this));
            },
            'focus': function(e) {
                Forms.updateDefaultValue($(this));
            },
            'blur': function(e) {
                if ($(this).val() === '') {
                    Forms.setDefaultValue($(this));
                }
            }
        }, selector);
        my.calledsetupalready = true;
    };
    my.getFieldErrors = function() {};
    my.handleError = function(msg, timeToFade, fadeOutDuration) {
        Notifications.renderTemporaryNotification('error', msg, 5000);
    };
    return my;
}(Forms));
$(function() {
    Forms.initDefaults(undefined, undefined, true);
});
var Api = (function() {
    var my = {};
    var extra_opts = {
        lock: true,
        spinny_id: true,
        no_spinny: true,
        break_cache: true
    };
    my.curr_requests = {};
    my.uri_prefix = '//' + window.location.host + '/api/';
    my.before_send = function(params, jqxhr, settings, request_key, $spinny, callback) {
        my.curr_requests[request_key] = jqxhr;
        if ($spinny && $spinny.length) {
            $spinny.show();
        }
        if (callback) {
            callback(params);
        }
    };
    my.ajax_complete = function(request_key, $spinny) {
        if ($spinny && $spinny.length) {
            $spinny.hide();
        }
        $spinny = null;
        spinny_id = null;
        delete my.curr_requests[request_key];
    };
    my.send_api_request = function(callback, request_type, params, opts) {
        opts = opts || {};
        params = params || {};
        var spinny_id;
        var $spinny;
        var k;
        var ajax_opts;
        var lock = opts.lock !== undefined ? opts.lock : true;
        var break_cache = opts.break_cache !== undefined ? opts.break_cache : true;
        var no_spinny = opts.no_spinny || false;
        if (window.PageData && window.PageData.ft) {
            form_token = window.PageData.ft + ':';
            if (window.PageData.ud_coords) {
                form_token += window.PageData.ud_coords;
            }
            params['__token'] = form_token;
        }
        var request_key = opts.request_key || request_type;
        if (my.curr_requests[request_key] && lock) {
            return false;
        }
        if (break_cache) {
            params.break_cache = new Date().getTime().toString() + Math.random().toString();
        }
        if (!no_spinny) {
            if (opts.spinny_id) {
                spinny_id = opts.spinny_id;
            } else {
                spinny_id = '#' + request_type + '_spinny';
            }
            $spinny = $(spinny_id);
        }
        ajax_opts = {
            type: 'POST',
            url: my.get_uri(request_type),
            data: $.param(my.clean_params(params)),
            cache: false,
            dataType: "json",
            beforeSend: function(jqxhr, settings) {
                my.before_send(params, jqxhr, settings, request_key, $spinny, opts.before_send || null);
            },
            success: function(data) {
                my.handle_response_data(data, callback, opts.error || null);
            },
            error: function(data) {
                my.handle_api_request_error(data, opts.error || null);
            },
            complete: function() {
                my.ajax_complete(request_key, $spinny);
            }
        };
        for (k in opts) {
            if (!extra_opts[k]) {
                ajax_opts[k] = opts[k];
            }
        }
        xhr = $.ajax(ajax_opts);
        return true;
    };
    my.get_uri = function(uri) {
        return my.uri_prefix + (uri || '');
    };
    my.handle_api_request_error = function(data, callback) {
        if (data && data.error) {
            if (typeof data.error != 'function') {
                Forms.handleError(data.error);
            }
            if (callback) {
                callback(data);
            }
        } else if (window.xhr && window.xhr.status != 401) {
            my.handle_response_data({
                error: "Oops! Your request could not be completed. Please try again."
            }, callback);
        }
    };
    my.handle_response_data = function(data, callback, error_callback) {
        if (data) {
            if (data.error) {
                Forms.handleError(data.error);
                if (error_callback) {
                    error_callback(data);
                }
            } else {
                if (window.PageData) {
                    PageData.handle_api_response(data);
                }
                if (callback) {
                    callback(data);
                }
            }
        }
    };
    my.clean_params = function(params) {
        var new_params = {};
        var item;
        for (var k in params) {
            item = params[k];
            if (item === undefined) {
                continue;
            }
            new_params[k] = item;
        }
        return new_params;
    };
    return my;
}());
(function() {
    var e_c = {};
    window.$$ = function(selector) {
        if (!e_c[selector]) {
            e_c[selector] = $(selector);
        }
        return e_c[selector];
    };
})();
var ElementCache = (function() {
    var my = {};
    my.cache = {};
    my.get = function(image_id, selector) {
        selector = selector || null;
        if (!selector && my.cache[image_id].length) {
            return my.cache[image_id];
        }
        var found_images = [];
        var i, l;
        var $image;
        for (i = 0, l = my.cache[image_id].length; i < l; i++) {
            $image = my.cache[image_id][i];
            if ($image.is(selector)) continue;
            found_images.push($image);
        }
        return found_images;
    };
    my.set = function(image_id, $value) {
        if (my.cache[image_id] === undefined) {
            my.cache[image_id] = [];
        }
        my.cache[image_id].push($value);
    };
    my.refresh = function(image_id, selector) {
        selector = selector || null;
    };
    my.filter = function(image_id, callback) {
        var k;
        var i;
        var l;
        var all_images = [];
        var filtered_images = [];
        var $image;
        if (image_id) {
            all_images = my.cache[image_id];
        } else {
            for (k in my.cache) {
                for (i = 0, l = my.cache.length; i < l; i++) {
                    all_images.push([k, my.cache[i]]);
                }
            }
        }
        for (i = 0, l = all_images.length; i < l; i++) {
            image_id = all_images[i][0];
            $image = all_images[i][1];
            if (!callback(image_id, $image)) {
                continue;
            }
            filtered_images.push($image);
        }
        return filtered_images;
    };
    my.remove_tmp = function() {
        var k;
        for (k in my.cache) {
            if (k.slice(0, 2) == '>>') {
                my.cache[k] = null;
                delete my.cache[k];
            }
        }
    };
    my.remove_all = function(selector) {
        var k, i, l;
        var $image;
        var image_id;
        var removed_image_ids = {};
        for (k in my.cache) {
            if (removed_image_ids[k]) {
                continue;
            }
            if (my.cache[k].length) {
                for (i = 0, l = my.cache[k].length; i < l; i++) {
                    my.remove(k, selector);
                    removed_image_ids[k] = 1;
                }
            }
        }
    };
    my.remove = function(image_id, selector) {
        if (!my.cache[image_id] || my.cache[image_id] === undefined) {
            return null;
        }
        selector = selector || null;
        if (!selector) {
            my.cache[image_id] = [];
            return true;
        }
        var $image, images;
        var i, l;
        var new_images = [];
        images = my.cache[image_id];
        for (i = 0, l = images.length; i < l; i++) {
            $image = images[i];
            if ($image.is(selector)) {
                continue;
            }
            new_images.push($image);
        }
        my.cache[image_id] = new_images;
        return true;
    };
    my.populate = function(selector) {
        selector = selector || '[image_id]';
        var $images = $(selector);
        var $image;
        var image_id;
        var i;
        var l;
        for (i = 0, l = $images.length; i < l; i++) {
            $image = $($images[i]);
            image_id = $image.attr('image_id');
            if (!image_id) continue;
            if (image_id.slice(0, 2) != '>>') {
                image_id = parseInt(image_id);
            }
            if (my.cache[image_id] === undefined) {
                my.cache[image_id] = [];
            }
            my.cache[image_id].push($image);
        }
    }
    return my;
}());
var Helpers = (function($) {
    var my = {};
    my.each = $.each;
    my.disableScroll = function() {
        var top = $("html").scrollTop();
        $("html").css("overflow", "hidden").scrollTop(top);
    };
    my.enableScroll = function() {
        var top = $("html").scrollTop();
        $("html").css("overflow", "auto").scrollTop(top);
    };
    my.deselectText = function() {
        if (window.getSelection) {
            if (window.getSelection().empty) {
                window.getSelection().empty();
            } else if (window.getSelection().removeAllRanges) {
                window.getSelection().removeAllRanges();
            }
        } else if (document.selection) {
            document.selection.empty();
        }
    };
    my.assert = function(cond, msg) {
        if (!cond || cond === undefined) {
            throw new Error(msg || 'assertion failed' + cond);
        }
    };
    my.whichTransitionEnd = function($elem) {
        var transitions = {
            'WebkitTransition': 'webkitTransitionEnd',
            'MozTransition': 'transitionend',
            'OTransition': 'oTransitionEnd otransitionend',
            'transition': 'transitionend'
        };
        for (var t in transitions) {
            if ($elem.style[t] !== undefined) {
                return transitions[t];
            }
        }
    }, my.updateCountdown = function($elem, max, $countdown) {
        var classname, old_classname;
        max = max || 140;
        $countdown = $countdown || $(".countdown");
        var remaining = max - $elem.val().length;
        classname = (remaining < 0) ? "red" : "grey";
        old_classname = (remaining < 0) ? "grey" : "red";
        $countdown.removeClass(old_classname).addClass(classname).text(remaining);
    };
    my.checkImageURL = function(url) {
        return (url.match(/^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/) != null);
    };
    my.get_window_dimensions = function() {
        PageData.window_height = $(window).height();
        PageData.window_width = $(window).width();
    };
    my.isEmptyObject = function(obj) {
        for (var k in obj) {
            if (obj.hasOwnProperty(k)) {
                return false;
            }
        }
        return true;
    };
    my.makeArrayUniqueObjects = function(array, key_name) {
        var a = array.concat();
        for (var i = 0; i < a.length; ++i) {
            for (var j = i + 1; j < a.length; ++j) {
                if (a[i][key_name] === a[j][key_name])
                    a.splice(j--, 1);
            }
        }
        return a;
    };
    my.copyObj = function(obj, old_obj, include_funcs, deep, pd_key, id) {
        deep = deep !== undefined ? deep : false;
        var new_obj = {};
        var k;
        if (old_obj) {
            for (k in old_obj) {
                if (!old_obj.hasOwnProperty(k)) continue;
                new_obj[k] = old_obj[k];
            }
        }
        var item;
        for (k in obj) {
            item = obj[k];
            if (!obj.hasOwnProperty(k) || (!include_funcs && typeof item == 'function')) {
                continue;
            }
            var action_prefix = PageData.get_prefix(k);
            var final_attr = action_prefix.attr;
            if (deep) {
                if (typeof item == 'object' && item.length === undefined) {
                    item = my.copyObj(obj[k], null, include_funcs, deep);
                }
            } else if ($.isArray(item) && new_obj[final_attr] !== undefined) {
                if (!new_obj[final_attr] || new_obj[final_attr] === undefined) {
                    new_obj[final_attr] = [];
                }
                if (action_prefix.prefix) {
                    item = PageData.handle_action_prefix(action_prefix, k, obj, pd_key, id, true);
                } else {
                    Helpers.extendArray(new_obj[final_attr], item, true);
                    item = new_obj[k];
                }
            }
            new_obj[final_attr] = item;
        }
        return new_obj;
    };
    my.deepCopy = function(obj) {
        return my.copyObj(obj, null, true, true);
    };
    my.extendArray = function(arr_a, arr_b, no_dupes) {
        if (no_dupes) {
            var map = {};
            var member;
            var i, l;
            for (i = 0, l = arr_a.length; i < l; i++) {
                member = arr_a[i];
                map[member] = true;
            }
            for (i = 0, l = arr_b.length; i < l; i++) {
                member = arr_b[i];
                if (!map[member]) {
                    arr_a.push(member);
                    map[member] = true;
                }
            }
            return arr_a;
        } else {
            return arr_a.push.apply(arr_a, arr_b);
        }
    };
    my.getMapFromIds = function(ids) {
        var id;
        var i;
        var l;
        var map = {};
        if (!ids || !ids.length) {
            return map;
        }
        for (i = 0, l = ids.length; i < l; i++) {
            id = ids[i];
            map[id] = 1;
        }
        return map;
    };
    my.closeTo = function(numa, numb, max_distance) {
        max_distance = max_distance === undefined ? 3 : max_distance || 0;
        return Math.abs(numa - numb) <= max_distance;
    };
    my.filterObjFromMap = function(obj, map) {
        var new_obj = {};
        for (var k in obj) {
            if (map[k]) {
                new_obj[k] = obj[k];
            }
        }
        return new_obj;
    };
    my.INFOS_KEY_MAP = {
        recent_user_ids: 'users',
        image_ids: 'images',
        resharer_ids: 'users',
        subscription_ids: 'users',
        subscriber_ids: 'users',
        liked_ids: 'users',
        comment_ids: 'comments'
    };
    my.populateShareUserInfo = function(info, type, infos) {
        var id_suffix = type + '_id';
        if (info[id_suffix] != info['original_' + id_suffix]) {
            var original_user_id = info.original_user_id;
            var original_user_info = infos.users[original_user_id];
            if (original_user_id && original_user_info) {
                info['original_user_info'] = original_user_info;
            }
            var reshared_user_id = info.reshared_user_id;
            var reshared_user_info = infos.users[reshared_user_id];
            if (reshared_user_id && reshared_user_info) {
                info['reshared_user_info'] = reshared_user_info;
            }
        }
    };
    my.buildRenderData = function(ids, id_type, infos, include_users, recursing) {
        if (!ids || ids === undefined) return [];
        infos = infos || {
            feed: PageData.feed,
            users: PageData.users,
            images: PageData.images,
            comments: PageData.comments,
            galleries: PageData.galleries,
            ads: PageData.ads
        };
        id_type = id_type || 'images';
        recursing = recursing || false;
        include_users = include_users !== undefined ? include_users : true;
        var info;
        var id;
        var user_id;
        var i;
        var l;
        var k;
        var subinfo_key;
        var user_info;
        var new_key;
        var offset;
        var render_data = [];
        for (i = 0, l = ids.length; i < l; i++) {
            id = ids[i];
            if (id_type == "users" && State.is_logged_in() && id == PageData.my_info.user_id) {
                info = PageData.my_info;
            } else {
                if (typeof id !== 'number') {
                    if (id.substring(0, 2) == "i:") {
                        id_type = "images";
                        id = id.substring(2);
                    } else if (id.substring(0, 2) == "a:") {
                        id_type = "ads";
                        id = id.substring(2);
                    }
                }
                info = infos[id_type][id];
            }
            if (!info) {
                continue;
            }
            if (id_type == "images" || (id_type == 'ads' && info.gallery_id !== undefined)) {
                if (info.comment_ids && info.comment_ids.length > 5) {
                    info.view_all_comments = 1;
                }
                if (info.type == "video" && !info.video_type) {
                    if (is_youtube_video(info.attribution_url)) {
                        info['video_type'] = 'youtube';
                    } else if (is_vine_video(info.attribution_url)) {
                        info['video_type'] = 'vine';
                    }
                }
                if (info['parsed_description']) {
                    info['parsed_description'].forEach(function(elem, index) {
                        if (elem.type == 'text') {
                            info['parsed_description'][index]['content'] = elem.content.replace(/[\n\r]/g, '&nbsp;\n');
                        }
                    });
                }
            }
            if (include_users && id_type !== 'users') {
                user_id = info.user_id;
                user_info = infos.users[user_id];
                if (user_id && user_info) {
                    info = my.copyObj(info, user_info);
                }
                if (id_type == "images") {
                    my.populateShareUserInfo(info, 'image', infos);
                    if (info.gallery_id && id_type !== 'ads') {
                        var gallery = my.copyObj(infos.galleries[info.gallery_id], null);
                        my.populateShareUserInfo(gallery, 'gallery', infos);
                        gallery['comments'] = (gallery['comment_ids'] && gallery['comment_ids'].length) ? my.buildRenderData(gallery['comment_ids'].slice(-5), 'comments', infos, true, false) : [];
                        if (gallery.comment_ids && gallery.comment_ids.length > 10) {
                            gallery.view_all_comments = 1;
                        }
                        gallery['recent_users'] = (gallery['recent_user_ids'] && gallery['recent_user_ids'].length) ? my.buildRenderData(gallery['recent_user_ids'].slice(0, 10), 'users', infos, false, true) : [];
                        info['gallery_info'] = gallery;
                    }
                }
                if (id_type == "comments" && PageData && PageData.my_info && PageData.images[info['image_id']] && (window.internal_only || PageData.images[info['image_id']].user_id == PageData.my_info.user_id || info['user_id'] == PageData.my_info.user_id)) {
                    info['admin'] = true;
                }
            }
            if (!recursing) {
                for (k in info) {
                    if (!info.hasOwnProperty(k) || !info[k]) continue;
                    offset = k.length - 4;
                    if (k.substr(offset) == '_ids') {
                        new_key = k.slice(0, offset) + 's';
                        subinfo_key = my.INFOS_KEY_MAP[k] || 'users';
                        if (k.slice(k.length - 11, k.length) == 'comment_ids') {
                            info[new_key] = my.buildRenderData(info[k].slice(-5), 'comments', infos, true, false);
                        } else {
                            info[new_key] = my.buildRenderData(info[k].slice(0, 10), subinfo_key, infos, false, true);
                        }
                    }
                }
            }
            if (info && !$.isEmptyObject(info)) {
                render_data.push(info);
            }
        }
        return render_data;
    };
    my.buildImageRows = function(image_rows) {
        var rows = [],
            row, images, image_ids, r, i, l;
        for (i = 0, l = image_rows.length; i < l; i++) {
            row = image_rows[i];
            image_ids = row['image_ids'];
            r = my.buildRenderData(image_ids);
            rows.push({
                'images': r,
                'height': row.height
            });
        }
        return rows;
    };
    my.iFrameCreate = function(api) {
        api = api || {};
        var $iframe = $('<iframe />');
        $iframe.attr({
            id: api.iframe_name || api.name + '_iframe',
            name: api.name
        }).css({
            height: '0px',
            width: '0px',
            position: 'absolute',
            top: '0',
            left: '0',
            display: 'none'
        }).appendTo('body');
        return $iframe;
    };
    my.injectScript = function(src, lock_id) {
        if (lock_id) {
            var $old_script = $('#' + lock_id);
            if ($old_script.length) {
                $old_script.remove();
            }
        }
        var $script = $('<script />');
        $script.attr({
            src: src,
            type: 'text/javascript'
        }).appendTo('head');
        return $script;
    };
    my.parent = function($elem, selector, i) {
        i = i || 0;
        var $par;
        $par = $elem.parent();
        if (!$par.length || $par.is(selector)) {
            return $par
        }
        return my.parent($par, selector, ++i);
    };
    my.save_comment_obj = function(obj_type, content, comment_info, opts) {
        opts = opts || {};
        var comment_obj;
        if (obj_type != "text" && comment_info['curr_text'].length) {
            comment_obj = {
                'type': 'text',
                'content': comment_info['curr_text']
            };
            comment_info['comment_map'].push(comment_obj);
        }
        comment_obj = {
            'type': obj_type,
            'content': content
        };
        if (opts.full_url) {
            comment_obj['full_url'] = opts.full_url;
        }
        comment_info['comment_map'].push(comment_obj);
        comment_info['curr_text'] = "";
        return comment_info;
    };
    my.get_location = function(href) {
        var l = document.createElement("a");
        l.href = href;
        return l;
    };
    var ending_punc_re = /[^A-Za-z0-9]+$/;
    var bad_chars_re = /\W/g;
    var tag_word_re = /[0-9A-Za-z_\-]+/;
    my.get_tags = function(text, hash) {
        var i, l;
        var tags = [];
        var words = text.split(' ');
        var word;
        for (i = 0, l = words.length; i < l; i++) {
            word = words[i];
            if (word.length) {
                if (hash && word[0] === '#') {
                    word = word.slice(1, word.length);
                } else if (hash && word[0] !== '#') {
                    continue;
                }
                word = tag_word_re.exec(word);
                if (word) {
                    word = word[0];
                } else {
                    continue;
                }
                if (word.length > 1) {
                    tags.push(word);
                }
            }
        }
        return tags;
    };
    var final_timeout;
    var give_up = false;
    my.on_create = function(elem_id, callback, subselector, extra) {
        if (final_timeout === undefined) {
            final_timeout = setTimeout(function() {
                give_up = true;
            }, 10000);
        }
        if (give_up) {
            give_up = false;
            return;
        }
        var elem = document.getElementById(elem_id);
        if (!elem) {
            return setTimeout(function() {
                my.on_create(elem_id, callback, subselector, extra);
            }, 200);
        }
        var $elem = $(elem);
        if (subselector) {
            $elem = $elem.find(subselector);
        }
        if (!$elem.length) {
            return setTimeout(function() {
                my.on_create(elem_id, callback, subselector, extra);
            }, 200);
        }
        if (callback) {
            callback($elem, extra);
        }
    };
    my.in_view = function($elem) {
        var inner_h = $(window).height();
        var off_h = window.pageYOffset || document.scrollTop || document.body.scrollTop;
        var elem_height = $elem.height();
        var elem_top = $elem.offset().top;
        if (elem_top + elem_height > off_h && elem_top < off_h + inner_h) {
            return (off_h + inner_h) - elem_top;
        }
        return false;
    };
    my.get_image_height = function(src, cb) {
        var $img = $('<img src="' + src + '" style="position: absolute; left: -10000px; top: -10000px;" />');
        $img.load(function(e) {
            cb($img.height());
            $img.remove();
        });
        $$('body').append($img);
    };
    my.get_external_url_for_image = function(image_id) {
        var user_name;
        if (PageData.images[image_id].user_id == PageData.my_info.user_id) {
            user_name = PageData.my_info.user_name;
        } else {
            user_name = PageData.users[PageData.images[image_id].user_id].user_name;
        }
        return window.location.protocol + PageData.profile_url(user_name, true) + '/' + image_id;
    };
    my.get_external_url_for_gallery = function(gallery_id) {
        var user_name;
        var gallery = PageData.galleries[gallery_id];
        if (gallery.user_id == PageData.my_info.user_id) {
            user_name = PageData.my_info.user_name;
        } else {
            user_name = PageData.users[gallery.user_id].user_name;
        }
        return window.location.protocol + PageData.profile_url(user_name, true) + '/' + gallery.path_name;
    };
    my.image_ids_already_displayed = function() {
        return $("#channel_images img").map(function(index, element) {
            var attr_image_id = $(element).attr('image_id');
            if (attr_image_id != undefined) {
                return parseInt(attr_image_id);
            }
        });
    };
    my.ads_already_displayed = function() {
        return $("#channel_images .promo").map(function(index, element) {
            var attr_ad_id = $(element).attr('prid');
            if (attr_ad_id != undefined) {
                return parseInt(attr_ad_id);
            }
        });
    };
    my.remove_common_elements = function(array_to_change, reference_array, prefix) {
        var pre = prefix ? prefix : 'i:';
        if (typeof array_to_change[0] !== 'number' && typeof reference_array[0] === 'number') {
            reference_array = $.map($(reference_array), function(val, i) {
                return pre + val;
            });
        }
        return $.makeArray($(array_to_change).not($(reference_array)));
    };
    my.remove_consecutive_ads = function(feed_ids, separation) {
        var min_separation = separation || 4;
        var curr_separation = 0;

        function process_feed_state(ids, curr_index, remove) {
            if (ids[curr_index].substring(0, 2) == "a:") {
                if (curr_separation > 0) {
                    if (remove) {
                        ids.splice(curr_index, 1);
                    }
                    return;
                }
                curr_separation = min_separation;
            } else {
                curr_separation--;
            }
        }
        var lookback = PageData.feed.image_ids.length - min_separation * 2;
        for (var j = PageData.feed.image_ids.length - 1; j >= 0 && j >= lookback; j--) {
            process_feed_state(PageData.feed.image_ids, j, false);
        }
        for (var i = feed_ids.length - 1; i >= 0; i--) {
            process_feed_state(feed_ids, i, true);
        }
        return feed_ids;
    };
    return my;
}(jQuery));
(function(jQuery) {
    function now() {
        return (new Date()).getTime();
    }
    var SUPPORTED_PROP_MAP = {};

    function supported_style(prop) {
        if (SUPPORTED_PROP_MAP[prop]) return SUPPORTED_PROP_MAP[prop];
        var vendorProp, supportedProp, capProp = prop.charAt(0).toUpperCase() + prop.slice(1),
            prefixes = ["Moz", "Webkit", "O", "ms"],
            div = document.createElement("div");
        if (prop in div.style) {
            supportedProp = prop;
        } else {
            for (var i = 0; i < prefixes.length; i++) {
                vendorProp = prefixes[i] + capProp;
                if (vendorProp in div.style) {
                    supportedProp = '-' + prefixes[i].toLowerCase() + '-' + prop;
                    break;
                }
            }
        }
        div = null;
        SUPPORTED_PROP_MAP[prop] = supportedProp;
        return supportedProp;
    }
    jQuery.fn.cssAnimate = function(params, options, opt_easing, opt_complete) {
        if (!this.size()) return this;
        var transition_param = supported_style('transition');
        if (!transition_param) return this.animate(params, options, opt_easing, opt_complete);
        this.data('css_animated', 1);
        if (options !== undefined && (typeof options) != 'object') {
            options = {
                duration: options,
                easing: opt_easing,
                complete: opt_complete
            };
        } else {
            options = options || {};
        }
        options.duration = options.duration !== undefined ? options.duration : 400;
        if (options.duration === 0) {
            this.css(params);
            this.data('css_animated', null);
            if (options.complete) options.complete.apply(this[0]);
            return this;
        }
        options.easing = options.easing || 'linear';
        var duration_secs = ' ' + (options.duration / 1000) + 's ' + options.easing;
        var $obj = this;
        var css_params = {};
        var transition_attributes = [],
            transition_attributes_initial = [];
        for (var name in params) {
            if (!params.hasOwnProperty(name)) continue;
            var supported_name = supported_style(name);
            css_params[supported_name] = params[name];
            transition_attributes.push(supported_name + duration_secs);
            transition_attributes_initial.push(supported_name + ' 0s');
        }
        var transition_css = {};
        transition_css[transition_param] = transition_attributes_initial.join(', ');
        $obj.css(transition_css);
        window.setTimeout(function() {
            transition_css[transition_param] = transition_attributes.join(', ');
            $obj.css(transition_css);
            $obj.css(css_params);
            var start_time = now();
            var last_time = now();

            function step_func() {
                var n = now();
                var elapsed = n - start_time,
                    lag = n - last_time;
                if (options.step && lag > 50) {
                    last_time = n;
                    options.step.apply($obj[0], [elapsed / options.duration]);
                }
                if (elapsed < options.duration) {
                    setTimeout(step_func, 5);
                }
            }
            if (options.step) window.setTimeout(step_func, 50);
            var transition_end = 'transitionend';
            if (transition_param == '-webkit-transition') transition_end = 'webkitTransitionEnd';
            else if (transition_param == '-o-transition') transition_end = 'oTransitionEnd';
            else if (transition_param == '-ms-transition') transition_end = 'MSTransitionEnd';
            var completed = false;

            function complete() {
                if (completed) return;
                completed = true;
                transition_css[transition_param] = 'none';
                $obj.css(transition_css);
                $obj.data('css_animated', null);
                if (options.complete) options.complete.apply($obj[0]);
                $obj[0].removeEventListener(transition_end, complete, true);
                $obj.unbind('stop_css_anim');
                $obj = null;
                transition_css = null;
                step_func = null;
                complete = null;
            }
            $obj[0].addEventListener(transition_end, complete, true);
            $obj.bind('stop_css_anim', function() {
                options.complete = null;
                transition_css[transition_param] = transition_attributes_initial.join(', ');
                $obj.css(transition_css);
            });
        }, 1);
        return this;
    };
    jQuery.expr.filters.animated = function(elem) {
        if ($(elem).data('css_animated')) return true;
        return jQuery.grep(jQuery.timers, function(fn) {
            return elem === fn.elem;
        }).length;
    };
    var orig_stop = jQuery.fn.stop;
    jQuery.fn.stop = function() {
        if (this.data('css_animated')) {
            this.trigger('stop_css_anim');
        }
        var args = Array.prototype.slice.apply(arguments);
        orig_stop.apply(this, args);
        return this;
    };
    jQuery.fn.cssFadeOut = function(duration, callback) {
        var obj = this;
        this.cssAnimate({
            opacity: 0
        }, {
            complete: function() {
                obj.hide();
                callback && callback();
            }
        });
    };
    jQuery.fn.cssFadeIn = function(duration, callback) {
        var obj = this;
        obj.css({
            opacity: 0
        }).show();
        obj.cssAnimate({
            opacity: 1
        }, {
            complete: function() {
                callback && callback();
            }
        });
    };
})(jQuery);

function load_images() {
    var count = 0;
    $('img[realsrc],div[realsrc]').each(function() {
        var $this = $(this);
        if ($this.is('img')) {
            $this.attr('src', $this.attr('realsrc'));
        } else {
            $this.css({
                'background-image': 'url(' + $this.attr('realsrc') + ')'
            });
        }
        $this.removeAttr('realsrc');
        count++;
        if (count >= 5) {
            setTimeout(load_images, 500);
            return false;
        }
    });
}

function get_homepage() {
    if (!pass_to_js.next_page) {
        return;
    }
    var params = {
        'position': $(".gallery-big").length,
        'v': pass_to_js.v_param,
        'q': pass_to_js.gallery_keywords,
        'sort': pass_to_js.gallery_sort
    };
    Api.send_api_request(get_homepage_success, "gallery_homepage", params);
}

function get_homepage_success(data) {
    if (data.success) {
        $("#galleries-inner").append(data.markup);
        load_images();
        pass_to_js.next_page = data.next_page;
    } else {
        pass_to_js.next_page = undefined;
    }
}

function scroll_functions_go($this) {
    var $container = $(this);
    var pixels_from_top = $container.scrollTop();
    var pixels_from_bottom = document.getElementById('thepage').scrollHeight - ($container.height() + pixels_from_top);
    if (pixels_from_bottom < 1000 && pass_to_js.next_page) {
        get_homepage();
    }
}

function homepage_gallery_scroll($right_col) {
    var pixels_from_top = $('html').scrollTop();
    var $right_col_inner = $("#gallery_right_col_inner");
    var pixels_from_bottom = document.body.scrollHeight - pixels_from_top;
    if (pixels_from_top >= ($right_col_inner.height() - $(window).height())) {
        if (pixels_from_bottom - $(window).height() <= 100) {
            if (!$right_col.hasClass("absolute")) {
                $right_col.addClass("absolute").removeClass("fixed");
            }
        } else {
            if (!$right_col.hasClass("fixed")) {
                $right_col.addClass("fixed").removeClass("absolute");
            }
        }
    } else {
        if ($right_col.hasClass("fixed")) {
            $right_col.removeClass("fixed");
        }
    }
}

function maybe_toggle_back_to_top() {
    var $container = $(window);
    var $back_to_top = $("#back_to_top");
    if ($back_to_top.length) {
        var pixels_from_top = ($container.height() + $container.scrollTop());
        var back_to_top_visible = $back_to_top.is(":visible");
        if (pixels_from_top > 1200) {
            if (!back_to_top_visible) {
                $back_to_top.show("slow");
            }
        } else {
            if (back_to_top_visible) {
                $back_to_top.hide("slow");
            }
        }
    }
}
$().ready(function() {
    var pass_to_js = window.pass_to_js || {};
    window.MOBILE = pass_to_js.MOBILE || false;
    window.internal_only = pass_to_js.internal_only || false;
    var $carousel = $('#image-carousel>.carousel-inner');

    function animate_away(cur_left) {
        if (!cur_left) cur_left = 0;
        var start_time = now(),
            max_offset = 1000,
            speed_factor = 12,
            duration = Math.round(max_offset + cur_left) * speed_factor;
        if (cur_left < -max_offset) duration = 0;
        $carousel.cssAnimate({
            'left': -max_offset + 'px'
        }, duration, 'linear', function() {
            var total = 0,
                cur_left = parseInt($carousel.css('left'));
            $('#image-carousel .image-item').each(function() {
                var $this = $(this),
                    width = $this.outerWidth(true);
                if (total + width + cur_left > 0) {
                    return false;
                }
                $carousel.append($this);
                total += width;
            });
            var delay = now() - start_time,
                cur_left = Math.round((total - max_offset) - (delay - duration) / speed_factor);
            $carousel.css({
                left: cur_left + 'px'
            });
            animate_away(cur_left);
        });
    }
    animate_away();
    $('#image-carousel').mouseenter(function(e) {
        var current_left = parseInt($carousel.css('left'));
        $carousel.stop();
        $carousel.cssAnimate({
            left: (current_left - 6) + 'px'
        }, 100, 'linear');
        e.stopPropagation();
        return false;
    }).mouseleave(function(e) {
        var current_left = parseInt($carousel.css('left'));
        animate_away(current_left);
        e.stopPropagation();
        return false;
    });
    $('div.top-close').click(function() {
        $('div.homepage-top').cssAnimate({
            height: 0,
            margin: 0,
            padding: 0,
            border: 0
        }, 400);
    });
    setTimeout(load_images, 1000);
    $(window).on({
        'scroll': function(e) {
            maybe_toggle_back_to_top();
            var $gallery_right_col = $("#gallery_right_col");
            if ($gallery_right_col.length) {
                homepage_gallery_scroll($gallery_right_col);
                return;
            }
            var $gallery_grid = $("#galleries-inner");
            if (!$gallery_grid.length || (Api && Api.curr_requests.gallery_homepage)) {
                return;
            }
            scroll_functions_go($(this));
        }
    });
    $("body").on({
        'click': function() {
            $$("html,body").scrollTop(0);
            $(this).hide();
        }
    }, "#back_to_top, .back_to_top");
    $(function() {
        if (!document.getElementById('main_content')) {
            return;
        }
        var maxHeight = document.getElementById('main_content').offsetHeight
        var count = 0;
        $('.side-section .gallery-big').each(function() {
            count = $(this).offset();
            if ((count.top) > maxHeight) {
                $(this).css('display', 'none');
            }
        })
        $('#gallery_right_col.likes_homepage').css({
            'overflow': 'hidden',
            'maxHeight': maxHeight
        });
    });
});
$().ready(function() {
    setup_signup_events();
});

function setup_signup_events() {
    function days_in_month(year, month) {
        return new Date(year, month, 0).getDate();
    }
    $('#birthday_month,#birthday_year').change(function(e) {
        var current_day = $('#birthday_day').val();
        var num_days = days_in_month($('#birthday_year').val(), $('#birthday_month').val());
        var day_options = '<option value="">Day</option>';
        for (var i = 1; i <= num_days; i++) {
            day_options += '<option value="' + i + '" ' + (current_day == i ? 'selected' : '') + '>' + i + '</option>';
        }
        $('#birthday_day').html(day_options);
    });
    var $last_year = $('#birthday_year option[value="' + ((new Date).getFullYear() - 13) + '"]');
    $('#birthday_month,#birthday_day').change(function() {
        var now = new Date(),
            this_month = now.getMonth() + 1,
            this_day = now.getDate();
        var month = +$('#birthday_month').val(),
            day = +$('#birthday_day').val();
        if (month > this_month || month == this_month && day > this_day) {
            $last_year.remove();
        } else {
            if (!$last_year[0].parentNode) {
                $('#birthday_year').append($last_year);
            }
        }
    });
};
var g_animationObjects = null;

function factorNumber(number) {
    if (number === 1)
        return [1];
    var limit = Math.sqrt(number);
    for (var i = 2; i <= limit; i++) {
        if (number % i === 0) {
            var others = factorNumber(number / i);
            others.push(i);
            return others;
        }
    }
    return [number];
}

function calculateGridDimensions(nframes) {
    var factors = factorNumber(nframes);
    var sqrt_dim = Math.ceil(Math.sqrt(nframes));
    var total_frames = sqrt_dim * sqrt_dim;
    var extra_frames = total_frames - nframes;
    var extra_rows = Math.floor(extra_frames / sqrt_dim);
    var min_sqrt_dim = sqrt_dim - extra_rows;
    if (factors.length === 1)
        return [sqrt_dim, min_sqrt_dim];
    var left = factors.slice(0, factors.length / 2);
    var right = factors.slice(factors.length / 2);
    var left_mul = left.reduce(function(a, b) {
        return a * b;
    });
    var right_mul = right.reduce(function(a, b) {
        return a * b;
    });
    if (sqrt_dim + min_sqrt_dim < left_mul + right_mul)
        return [sqrt_dim, min_sqrt_dim];
    else
        return [left_mul, right_mul];
}

function FilmstripAnimationObject(elem, maxWidth) {
    this.elem = $(elem);
    this.nframes = parseInt(this.elem.data("nframes"));
    this.delay = parseInt(this.elem.data("fdelay"));
    this.width = parseInt(this.elem.data("width"));
    this.height = parseInt(this.elem.data("height"));
    this.url = this.elem.data("src");
    if (this.width > maxWidth) {
        this.scaleFactor = maxWidth / this.width;
        this.width = maxWidth;
        this.height = Math.ceil(this.height * this.scaleFactor);
    } else {
        this.scaleFactor = 1.0;
    }
    var grid = calculateGridDimensions(this.nframes);
    this.gridCols = grid[0];
    this.gridRows = grid[1];
    if (this.width % 8 !== 0)
        this.padX = 8 - (this.width % 8);
    else
        this.padX = 0; if (this.height % 8 !== 0)
        this.padY = 8 - (this.height % 8);
    else
        this.padY = 0;
    this.padX = Math.ceil(this.padX * this.scaleFactor);
    this.padY = Math.ceil(this.padY * this.scaleFactor);
    this.elem.css("width", this.width);
    this.elem.css("height", this.height);
    this.elem.css("background-image", "url(" + this.url + ")");
    this.elem.css("background-position", "0px 0px");
    var bgWidth = (this.width + this.padX) * this.gridCols;
    var bgHeight = (this.height + this.padY) * this.gridRows;
    this.elem.css("background-size", bgWidth + "px " + bgHeight + "px");
    this.frameNumber = 0;
    this.__anim = function() {
        if (this.frameNumber < this.nframes) {
            var left = -(this.frameNumber % this.gridCols) * (this.width + this.padX);
            var top = -Math.floor(this.frameNumber / this.gridCols) * (this.height + this.padY);
            this.elem.css("background-position", left + "px " + top + "px");
            ++this.frameNumber;
        } else {
            this.elem.css("background-position", "0px 0px");
            this.frameNumber = 0;
        }
    }.bind(this);
    this.animID = null;
    this.startAnimation = function() {
        if (this.animID !== null)
            return;
        this.animID = setInterval(this.__anim, this.delay);
    }.bind(this);
    this.stopAnimation = function() {
        if (this.animID === null)
            return;
        clearInterval(this.animID);
        this.animID = null;
    }.bind(this);
}

function initAnimations() {
    if (g_animationObjects)
        return g_animationObjects;
    g_animationObjects = new Array();
    $(".filmstrip").each(function(_index, element) {
        var o = new FilmstripAnimationObject(element, 600);
        g_animationObjects.push(o);
        $(element).find("img").remove();
        o.startAnimation();
    });
    $(".filmstrip-mobile").each(function(_index, element) {
        var o = new FilmstripAnimationObject(element, 300);
        g_animationObjects.push(o);
        $(element).find("img").remove();
        o.startAnimation();
    });
    return g_animationObjects;
}
$(document).ready(function() {
    initAnimations();
});
var $signup_pic_spinny, $signup_pic_button, $signup_pic_form;

function signup_pic_preUpload(form) {
    $signup_pic_form = form;
    $signup_pic_button = $signup_pic_form.find('.file_field_wrapper');
    $signup_pic_spinny = $signup_pic_form.find('.pic_chooser_spinny');
    $signup_pic_button.hide();
    $signup_pic_spinny.find("span").text('0%');
    $signup_pic_spinny.find('.progress').text('Uploading...');
    $signup_pic_spinny.find('.upload_file_progress_inner').css('width', '0px');
    $signup_pic_spinny.show().find('img').show();
}

function signup_pic_beginUpload(input_file, data) {
    if (data.gif_max_mb && input_file.size > (data.gif_max_mb * 1024 * 1024) && (input_file.type.indexOf('gif') >= 0)) {
        $signup_pic_spinny.hide();
        $signup_pic_button.show();
        render_signin_errors(['Sorry, this gif is too large. Maximum ' + data.gif_max_mb + "MB."]);
        return false;
    }
    var s3_data = data.s3_data;
    var post_url = 'http://' + s3_data['bucket'] + '.s3.amazonaws.com/';
    var fd = new FormData();
    fd.append('key', s3_data.key);
    fd.append('AWSAccessKeyId', s3_data.AWSAccessKeyId);
    fd.append('acl', s3_data.acl);
    fd.append('policy', s3_data.policy);
    fd.append('signature', s3_data.signature);
    fd.append('Content-Type', input_file.type);
    fd.append('success_action_status', s3_data.success_action_status);
    fd.append('file', input_file);
    $.ajax({
        url: post_url,
        data: fd,
        processData: false,
        contentType: false,
        type: 'POST',
        xhr: function() {
            var xhr = $.ajaxSettings.xhr();
            if (xhr.upload) {
                xhr.upload.addEventListener('progress', function(e) {
                    if (e.lengthComputable) {
                        signup_pic_update_progress(e.loaded, e.total);
                    }
                }, false);
            } else {
                xhr.addEventListener('progress', function(e) {
                    if (e.lengthComputable) {
                        signup_pic_update_progress(e.loaded, e.total);
                    }
                }, false);
            }
            return xhr;
        },
        beforeSend: function(xhr, settings) {
            upload_start_time = now();
        },
        success: function(response) {
            response['full_url'] = 'http://' + data.s3_data['bucket'] + '.s3.amazonaws.com/' + data.s3_data['key'];
            signup_pic_upload_complete(response);
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
            return false;
            render_signin_errors(['Unable to upload your image.']);
        },
    });
    return false;
};

function signup_pic_uploadSubmit(form) {
    signup_pic_preUpload(form);
    $.ajax({
        data: "",
        processData: false,
        contentType: false,
        type: "POST",
        url: Api.get_uri('start_upload') + '?form_id=pic_chooser',
        success: function(data) {
            if (data.s3_data) {
                var input_file = $signup_pic_form.find("input[type='file']")[0].files[0];
                signup_pic_beginUpload(input_file, data);
            } else {
                $signup_pic_spinny.hide();
                $signup_pic_button.show();
                render_signin_errors([data.error, ] || ['File upload failed.', ]);
            }
        },
        error: function(data) {
            $signup_pic_spinny.hide();
            $signup_pic_button.show();
            render_signin_errors([data.error, ] || ['Could not begin picture upload.', ]);
        }
    });
    return false;
};
var last_progress_time = null;
var upload_start_time = null;
var MB = 1024 * 1024;

function now() {
    return (new Date()).getTime();
}

function signup_pic_update_progress(bytes_loaded, total) {
    last_progress_time = now();
    var fraction = bytes_loaded / total;
    var percent = Math.floor(100 * fraction);
    var new_width = Math.floor(fraction * $signup_pic_spinny.find(".upload_file_progress_outer").width());
    $signup_pic_spinny.find(".upload_file_progress_inner").css('width', new_width + 'px');
    $signup_pic_spinny.find("span").text(percent + '%');
}

function signup_pic_upload_complete(image) {
    var $preview = $signup_pic_form.find(".upload_pic_display");
    if (!$preview.hasClass('previewing')) {
        $preview.css('background-image', 'url(' + image['full_url'] + ')');
    }
    $signup_pic_form.find('.picture').val(image['full_url']);
    $signup_pic_spinny.hide();
    $signup_pic_button.show();
}
$().ready(function() {
    $("body").on({
        'change': function() {
            if (!this.files.length) {
                return;
            }
            var $form = $(this).closest(".pic_chooser");
            if (window.FileReader) {
                var oFReader = new FileReader();
                oFReader.readAsDataURL(this.files[0]);
                oFReader.onload = function(oFREvent) {
                    $form.find('.upload_pic_display').addClass('previewing').css({
                        'background-image': 'url("' + oFREvent.target.result + '")'
                    });
                };
            }
            return signup_pic_uploadSubmit($form);
        }
    }, ".pic_chooser .browse_button");
    $("body").on({
        'click': function(e) {
            $(this).parent().find(".browse_button").click();
        }
    }, ".pic_chooser .file_field_wrapper");
});
if ($("#contact_form_inner").length) {
    function validate_contact_form(name, email, message) {
        var error;
        var empty_fields = [];
        if (!name || !name.length) {
            empty_fields.push("name");
        }
        if (!email || !email.length) {
            empty_fields.push("email");
        }
        if (!message || !message.length) {
            empty_fields.push("message");
        }
        if (empty_fields.length) {
            error = "Please provide: " + empty_fields.join(", ");
            return error;
        }
        var filter = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;
        var email_valid = String(email).search(filter) != -1;
        if (!email_valid) {
            return "Email address invalid.";
        }
        if (message.length < 10) {
            return "Please write a longer message so we can better help you.";
        }
    }

    function send_contact_form() {
        var $this = $("#contact_form_inner");
        if ($this.hasClass('clicked'))
            return false;
        var params = {};
        params.ajax = true;
        params.name = $("#contacter_name").val();
        params.email = $.trim($("#contacter_email").val());
        params.message = $("#contacter_message").val();
        var $fields = $this.find("input[type='hidden']");
        for (var i = 0, l = $fields.length; i < l; i++) {
            var field = $fields[i];
            if (field.value && field.value.length) {
                params[field.name] = field.value;
            }
        }
        $this.addClass('clicked');
        Notifications.fadeStaticNotification();
        $.ajax({
            type: "POST",
            dataType: 'json',
            data: $.param(params),
            url: Api.get_uri('send_help_email'),
            success: function(data) {
                if (data.success) {
                    $('#contact_form_inner').hide();
                    if (data.message) {
                        var markup = "<p class='message'>" + data.message + "</p>";
                        $("#contact_inner").append(markup);
                    }
                    $this.removeClass('clicked');
                } else {
                    if (data.error) {
                        Notifications.renderStaticNotification("error", error);
                    }
                    $this.removeClass('clicked');
                }
            }
        });
        return false;
    }
}
if ($("#contact_map").length) {
    var contact_page = {};
    contact_page.initialize_contact_maps = function() {
        var myLatlng = new google.maps.LatLng(37.7700670, -122.4076030);
        var mapOptions = {
            zoom: 14,
            center: myLatlng,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }
        var map = new google.maps.Map(document.getElementById('contact_map'), mapOptions);
        var marker = new google.maps.Marker({
            position: myLatlng,
            map: map,
            title: 'MyLikes Office'
        });
        google.maps.event.addDomListener(window, 'resize', function() {
            map.setCenter(new google.maps.LatLng(37.774582, -122.408981));
        });
    }
    $().ready(contact_page.initialize_contact_maps);
}
var Notifications = (function() {
    var my = {};
    my.showNotification = function(type, content, severity, time_to_show) {};
    my.renderStaticNotification = function(severity, content, opt_name) {
        if (typeof content != "string") {
            if (severity != 'error') {
                return;
            }
            content = 'Whoops, we had trouble handling your request.';
        }
        $("#staticNotificationBg").html("").remove();
        if (severity === undefined) severity = 'recent_action';
        var colorval, bgcolorval, bgclass;
        switch (severity) {
            case 'recent_action':
                bgclass = 'yellow_notification';
                break;
            case 'error':
                bgclass = 'red_notification';
                break;
            case 'success':
                bgclass = 'blue_notification';
                break;
            case 'success_white':
                bgclass = 'white_notification';
                break;
        }
        var notification_markup = "<div id='staticNotificationBg'><div class='staticNotification_inner " + bgclass + "'><div class='transparent_bg'>" + content + "</div><div class='content_over_transparent'>" + content + "</div></div></div>";
        $("body").append(notification_markup);
        if (window.MOBILE) {
            $("#staticNotificationBg").fadeIn(500);
        } else {
            $("#staticNotificationBg").fadeInSafe(500);
        }
        notification_markup = null;
        colorval = null;
        bgcolorval = null;
    };
    my.renderTemporaryNotification = function(severity, content, time_to_show) {
        if (typeof content != "string") {
            if (severity != 'error') {
                return;
            }
            content = 'Whoops, we had trouble handling your request.';
        }
        $("#tempNotificationBg").html("").remove();
        if (severity === undefined) severity = 'recent_action';
        if (time_to_show === undefined) time_to_show = 5000;
        var colorval, bgcolorval, bgclass;
        switch (severity) {
            case 'recent_action':
                bgclass = 'yellow_notification';
                break;
            case 'error':
                bgclass = 'red_notification';
                break;
            case 'success':
                bgclass = 'blue_notification';
                break;
            case 'success_white':
                bgclass = 'white_notification';
                break;
        }
        var notification_markup = "<div id='tempNotificationBg' ";
        if ($("#staticNotificationBg").length) {
            notification_markup += "style='top:115px;'";
        }
        notification_markup += "><div class='tempNotification_inner " + bgclass + "'><div class='transparent_bg'>" + content + "</div><div class='content_over_transparent'>" + content + "</div></div></div>";
        $("body").append(notification_markup);
        if (window.MOBILE) {
            $("#tempNotificationBg").fadeIn(500);
        } else {
            $("#tempNotificationBg").fadeInSafe(500);
        }
        notification_markup = null;
        colorval = null;
        bgcolorval = null;
        setTimeout(my.fadeNotification, time_to_show);
    };
    my.fadeNotification = function() {
        if (window.MOBILE) {
            $("#tempNotificationBg").fadeOut(1000);
        } else {
            $("#tempNotificationBg").fadeOutSafe(1000);
        }
    };
    my.fadeStaticNotification = function() {
        if (window.MOBILE) {
            $("#staticNotificationBg").fadeOut(1000);
        } else {
            $("#staticNotificationBg").fadeOutSafe(1000);
        }
    };
    my.renderNotifications = function(pass_to_js) {
        var i;
        var notification;
        pass_to_js = pass_to_js || window.pass_to_js;
        if (pass_to_js !== undefined && pass_to_js.page_notifications) {
            i = 0;
            for (i = 0; i < pass_to_js.page_notifications.length; i++) {
                notification = pass_to_js.page_notifications[i];
                if (notification.type === 'static') {
                    my.renderStaticNotification(notification.severity, notification.content, notification.name);
                } else {
                    my.renderTemporaryNotification(notification.severity, notification.content, notification.time_to_show);
                }
            }
        }
    };
    return my;
}(Notifications));
(function() {
    function nicetime(date) {
        if (typeof(date) == 'number') {
            date = new Date(date * 1000);
        }
        if (!date) return '';
        var diff = (((new Date()).getTime() - date.getTime()) / 1000),
            day_diff = Math.floor(diff / 86400);
        if (isNaN(day_diff) || day_diff < 0)
            return '';
        return day_diff == 0 && (diff < 5 && "just now" || diff < 60 && (Math.floor(diff) + ' seconds ago') || diff < 120 && "1 minute ago" || diff < 3600 && Math.floor(diff / 60) + " minutes ago" || diff < 7200 && "1 hour ago" || diff < 86400 && Math.floor(diff / 3600) + " hours ago") || day_diff == 1 && "Yesterday" || day_diff < 7 && day_diff + " days ago" || day_diff < 14 && "1 week ago" || day_diff < 30 && Math.floor(day_diff / 7) + " weeks ago" || day_diff < 60 && "1 month ago" || Math.floor(day_diff / 30) + " months ago";
    }

    function format_date(date, format_string) {
        if (typeof(date) == 'number') {
            date = new Date(date * 1000);
        }
        if (!date) return '';
        if (!format_string) format_string = "%a %b %d %Y";
        var mthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
        var dayNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
        var zeroPad = function(number) {
            return ("0" + number).substr(-2, 2);
        };
        var dateMarkers = {
            d: ['getDate',
                function(v) {
                    return zeroPad(v)
                }
            ],
            m: ['getMonth',
                function(v) {
                    return zeroPad(v + 1)
                }
            ],
            b: ['getMonth',
                function(v) {
                    return mthNames[v];
                }
            ],
            a: ['getDay',
                function(v) {
                    return dayNames[v];
                }
            ],
            Y: ['getFullYear'],
            H: ['getHours',
                function(v) {
                    return zeroPad(v)
                }
            ],
            M: ['getMinutes',
                function(v) {
                    return zeroPad(v)
                }
            ],
            S: ['getSeconds',
                function(v) {
                    return zeroPad(v)
                }
            ],
            i: ['toISOString']
        };
        return format_string.replace(/%(.)/g, function(m, p) {
            var rv = date[(dateMarkers[p])[0]]();
            if (dateMarkers[p][1] != null) rv = dateMarkers[p][1](rv);
            return rv;
        });
    }

    function format_number(num, opt_prec) {
        var precision = opt_prec;
        if (num == parseInt(num)) {
            var rounded = opt_prec ? +num.toPrecision(precision) : +num;
            var characters = rounded.toString();
            var output = '';
            for (var offset = characters.length; offset > 0; offset -= 3) {
                output = characters.slice(Math.max(offset - 3, 0), offset) + (output ? ',' + output : '');
            }
            return output;
        }
        if (precision && num) return num.toFixed(precision);
        return num;
    }

    function format_num_k(num, opt_prec) {
        if (!num && num !== 0) return num;
        opt_prec = opt_prec || 3;
        num = parseInt(num);
        if (num < 1000) return '' + num;
        if (num < 10000) return format_number(num, opt_prec);
        if (num < 1000000) {
            num = +num.toPrecision(opt_prec) / 1000;
            return num + 'K';
        }
        num = +num.toPrecision(opt_prec) / 1000000;
        return num + 'M';
    }

    function format_duration(duration) {
        if (!duration) return "0:00";
        duration = parseInt(duration);
        var mins = parseInt(duration / 60);
        var secs = duration % 60;
        return mins.toString() + ':' + (secs < 10 ? '0' : '') + secs.toString();
    }

    function pluralize(numbered_string) {
        var pluralize_re = /([0-9]+)( *)([^ ]+)/;
        var match = pluralize_re.exec(numbered_string);
        if (!match) {
            return numbered_string;
        }
        match.splice(0, 1);
        if (match[0] != '1' && match[2][match[2].length - 1] != 's') {
            match.push('s');
        }
        pluralize_re = null;
        return match.join('');
    }
    var GRID_LIST = ['50l cb', '25', '25', '25', '25', '75r cb', '25', '25', '25'],
        GRID_LIST_MINI = ['75l cb', '25', '25', '25', '50l cb', '50l', '75l cb'],
        MIX_GRID_LIST = ['50l cb', '25', '25', '25', '25', '25 cb', '25', '50r', '25', '25'];

    function grid_size(info) {
        var grid_list = GRID_LIST;
        var array_length = info.array_length;
        if (array_length && array_length < 5) {
            if (array_length == 1) {
                return '75l';
            } else if (array_length == 2 || array_length == 4) {
                return '50l';
            } else if (array_length == 3) {
                return info.index < 2 ? '50l' : '75l';
            } else {
                grid_list = GRID_LIST_MINI;
            }
        }
        return grid_list[info.index % grid_list.length];
    }

    function grid_size_mix(info) {
        return MIX_GRID_LIST[info.index % MIX_GRID_LIST.length];
    }
    var USER_THUMB_CDN = 's.likes-media.com';

    function user_thumb(thumb_key, size) {
        return get_thumb_url(thumb_key, size, USER_THUMB_CDN, 'uimg');
    }

    function get_thumb_url(thumb_key, size, cdn, dir_name) {
        if (!thumb_key || thumb_key.match(/^http/) || (thumb_key.length != 32) || !thumb_key.match(/^[0-9a-f]+$/)) {
            return thumb_key ? thumb_key : '';
        }
        if (size == null || size == undefined || size.length == 0) {
            size = '';
        } else {
            size = '.' + size;
        }
        return '//' + cdn + '/' + dir_name + '/' + thumb_key + size;
    }

    function breakwords(text) {
        if (!text) {
            return text;
        }
        var words = text.split(/ +/);
        for (var i = 0, l = words.length; i < l; i++) {
            if (words[i].length > 8) {
                var parts = [];
                for (var j = 0, wl = words[i].length; j < wl; j += 8) {
                    parts.push(escapeHTMLMustache(words[i].slice(j, j + 8)));
                }
                words[i] = parts.join('&shy;');
            } else {
                words[i] = escapeHTMLMustache(words[i]);
            }
        }
        return words.join(' ');
    }
    var USERNAME_RE = /(.*)@:([0-9]+):([a-zA-Z0-9_]+)(.*)/;

    function escape_and_link(text) {
        var words = text.split(/ +/);
        for (var i = 0, l = words.length; i < l; i++) {
            var match = USERNAME_RE.exec(words[i]);
            if (match) {
                words[i] = escapeHTMLMustache(match[1]) + '<a class="bright-blue show_hover_card" user_id="' + match[2] + '" href="/' + match[3] + '">@' + match[3] + '</a>' + escapeHTMLMustache(match[4]);
            } else if (words[i].length > 8) {
                var parts = [];
                for (var j = 0, wl = words[i].length; j < wl; j += 8) {
                    parts.push(escapeHTMLMustache(words[i].slice(j, j + 8)));
                }
                words[i] = parts.join('&shy;');
            } else {
                words[i] = escapeHTMLMustache(words[i]);
            }
        }
        return words.join(' ');
    }

    function get_from_context(contexts, name) {
        if (typeof(contexts) == "object" && contexts.length == undefined) return contexts[name];
        for (var i = 0; i < contexts.length; i++) {
            if (contexts[i] && contexts[i][name] !== undefined) return contexts[i][name];
        }
    }

    function push_context(context, contexts) {
        if (contexts && Array.isArray(contexts)) {
            var new_contexts = contexts.slice();
            new_contexts.unshift(context);
            return new_contexts;
        } else if (contexts && typeof(contexts) == "object") {
            return [context, contexts];
        }
        return [context];
    }

    function increment_forloop(forloop, item) {
        forloop.index++;
        forloop.counter = forloop.index + 1;
        forloop.first = forloop.index == 0;
        forloop.last = forloop.array_length && forloop.index == forloop.array_length - 1;
        forloop.even = forloop.counter % 2 == 0;
        forloop.odd = !forloop.even;
        forloop.item = item;
    }

    function slice(obj) {
        if (!obj) return obj;
        var args = Array.prototype.slice.call(arguments, 1);
        return Array.prototype.slice.apply(obj, args);
    }

    function count(obj, word, show_zero) {
        if (obj === undefined) obj = 0;
        var length = (typeof obj != 'number') ? obj.length : obj;
        if (length == 0 && !show_zero) {
            return '';
        }
        if (!word) return length;
        return length + ' ' + word + (length != 1 ? 's' : '');
    }
    var escapeMap = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': '&quot;',
        "'": '&#39;'
    };

    function escapeHTMLMustache(string) {
        return String(string).replace(/&(?!\w+;)|[<>\"\']/g, function(s) {
            return escapeMap[s] || s;
        });
    }

    function linkify(text, link_class) {
        if (!(text || text.length)) return text;
        link_class = link_class || 'blue underline';
        var link_re = /(?:[A-Za-z]{3,5}:\/\/)(?:[A-Za-z0-9\-]+\.)?(?:[A-Za-z0-9\-]+\.)?(?:[A-Za-z0-9\-]+\.)?[A-Za-z0-9\-]+\.[A-Za-z]{2,3}(?:\/[^\s]+)?/g;

        function linky(match) {
            return "<a href='" + match + "' target='_blank' onclick='window.open(this.href,'_blank');return false;' class='" + link_class + "'>" + match + "</a>";
        }
        text = escapeHTMLMustache(text);
        return text.replace(link_re, linky);
    }

    function linkify_tags(text, link_class) {
        if (!(text || text.length)) return text;
        link_class = link_class || 'blue grid_tag underline';
        var tag_re = /#[0-9A-Za-z\-]+/g;

        function linky(match) {
            return "<a href='/tagged/" + match.substring(1) + "' class='" + link_class + "'>" + match + "</a>";
        }
        return text.replace(tag_re, linky);
    }

    function number(text) {
        return parseInt(text) || 0;
    }

    function nopad(url) {
        return (url || '') + '.nopad';
    }

    function noanim(url) {
        return (url || '') + '.noanim';
    }

    function truncate_html(html, opt_length, ellipsis) {
        var len = opt_length || 30,
            ellipsis = ellipsis || '...';
        var $div = $('<div>' + html + '</div>');
        if ($div.text().length <= len) return html;
        while ($div.text().length > len) {
            html = html.slice(0, html.length - 1).replace(/<[^>]*$/, '');
            $div.html(html);
        }
        return $div.html() + ellipsis;
    }
    var RTL_RE = /[\u0509-\u06ff]/g;

    function is_rtl(text) {
        if (!text) return false;
        return RTL_RE.test(text);
    }

    function translation_link(text, target_lang) {
        if (!target_lang) target_lang = 'en';
        return "http://translate.google.com/#auto/" + target_lang + "/" + encodeURIComponent(text);
    }

    function message_pic_sizing(message, max_width, max_height) {
        if (!max_width) max_width = 250;
        if (!max_height) max_height = 250;
        if (!message || !message.width || !message.height) {
            return '';
        }
        var width = message['width'],
            height = message['height'];
        if (width > height) {
            if (width > max_width) {
                height = max_width * height / width;
                width = max_width;
            }
        } else {
            if (height > max_height) {
                width = max_height * width / height;
                height = max_height;
            }
        }
        return 'width: ' + width + 'px; height: ' + height + 'px';
    }
    window.Jasinja = {
        escape: function(html) {
            if (typeof html == 'string') {
                return escapeHTMLMustache(html);
            } else if (html && html.is_safe) {
                return html.html;
            }
            return html;
        },
        "utils": {
            "extend": function(base, child) {
                if (child == undefined) return base;
                var current = {
                    "blocks": {}
                };
                for (var key in base.blocks) {
                    if (!child.blocks[key]) {
                        current.blocks[key] = base.blocks[key];
                    } else {
                        current.blocks[key] = child.blocks[key];
                    }
                }
                return current;
            },
            "slice": function(val, start, stop) {
                if (typeof(val) == "string") {
                    return val.substring(start, stop);
                } else if (val instanceof Array) {
                    return val.slice(start, stop);
                }
            },
            "loop": function(iter) {
                function LoopObject() {
                    this.iter = iter;
                    this.l = iter ? iter.length : 0;
                    this.i = 0;
                    this.update = function() {
                        if (arguments.length) this.i = arguments[0];
                        this.index = this.i + 1;
                        this.index0 = this.i;
                        this.revindex = this.l - this.i;
                        this.revindex0 = this.l - this.i - 1;
                        this.first = !this.i;
                        this.last = this.i == this.l - 1;
                    }
                    this.cycle = function() {
                        return arguments[this.index0 % arguments.length];
                    };
                }
                return new LoopObject();
            },
            "contains": function(n, hs) {
                if (hs instanceof Array) {
                    for (var i = 0; i < hs.length; i++) {
                        if (hs[i] == n) return true;
                    }
                    return false;
                } else if (typeof(hs) == "string") {
                    return !!hs.match(RegExp(n));
                } else if (typeof(hs) == "object") {
                    return hs[n] !== undefined;
                } else {
                    throw new TypeError("containment is undefined: " + n + " in " + JSON.stringify(hs));
                }
            },
            "strjoin": function() {
                var buf = [];
                for (var i = 0; i < arguments.length; i++) {
                    buf.push(arguments[i].toString());
                }
                return buf.join("");
            },
            "strmul": function(s, n) {
                var buf = [];
                for (var i = 0; i < n; i++) {
                    buf.push(s);
                }
                return buf.join('');
            },
        },
        "filters": {
            safe: function(thing) {
                return {
                    html: thing,
                    is_safe: 1
                };
            },
            "attr": function(obj, name) {
                return obj[name];
            },
            "abs": function(n) {
                return Math.abs(n);
            },
            "batch": function(ls, num, fill) {
                fill = fill === undefined ? null : fill;
                var res = [];
                var tmp = [];
                for (var i = 0; i < ls.length; i++) {
                    if (tmp.length == num) {
                        res.push(tmp);
                        tmp = [];
                    }
                    tmp.push(ls[i]);
                }
                if (tmp.length && tmp.length < num && fill) {
                    for (var i = num - 1; i > 0; i--) {
                        tmp.push(fill);
                    }
                }
                if (tmp.length) res.push(tmp);
                return res;
            },
            "capitalize": function(s) {
                s = s.toLowerCase();
                return s.charAt(0).toUpperCase() + s.substring(1);
            },
            "center": function(s, width) {
                width = arguments[1] ? width : 80;
                var pre = Math.floor((width - s.length) / 2);
                var post = Math.ceil((width - s.length) / 2);
                var buf = [];
                for (var i = 0; i < pre; i++) {
                    buf.push(' ');
                }
                buf.push(s);
                for (var i = 0; i < post; i++) {
                    buf.push(' ');
                }
                return buf.join('');
            },
            "count": function(val) {
                return Jasinja.filters['length'](val);
            },
            "d": function(val, alt, bool) {
                bool = bool || false;
                if (!bool) {
                    return val !== undefined ? val : alt;
                } else {
                    return val ? val : alt;
                }
            },
            "default": function(val, alt, bool) {
                return Jasinja.filters.d(val, alt, bool);
            },
            "dictsort": function(val) {
                var keys = this.list(val);
                keys.sort();
                var ls = [];
                for (var i = 0; i < keys.length; i++) {
                    ls.push([keys[i], val[keys[i]]]);
                }
                return ls;
            },
            "e": function(s) {
                return this.escape(s);
            },
            "escape": function(s) {
                s = s.replace('&', '&amp;');
                s = s.replace('<', '&lt;');
                s = s.replace('>', '&gt;');
                s = s.replace('"', '&#34;');
                s = s.replace("'", '&#39;');
                return s;
            },
            "forceescape": function(s) {
                return this.escape(s);
            },
            "filesizeformat": function(val, binary) {
                binary = arguments[1] ? binary : false;
                var bytes = parseFloat(val);
                var base = binary ? 1024 : 1000;
                var middle = binary ? 'i' : '';
                if (bytes < base) {
                    var multi = bytes == 1 ? '' : 's';
                    return this.format("%i Byte%s", bytes, multi);
                } else if (bytes < base * base) {
                    return this.format("%.1f K%sB", bytes / base, middle);
                } else if (bytes < base * base * base) {
                    return this.format("%.1f M%sB", bytes / (base * base), middle);
                }
                return this.format("%.1f G%sB", bytes / (base * base * base), middle);
            },
            "first": function(val) {
                if (typeof(val) == "string") {
                    return val.charAt(0);
                } else if (val instanceof Array) {
                    return val[0];
                }
            },
            "float": function(val) {
                return parseFloat(val) || 0.0;
            },
            "format": function(fmt) {
                var vals = Array.prototype.slice.call(arguments, 1);
                var regex = new RegExp('\%([0 ]?)((?:[0-9]+)?)(\.[0-9]+)?([fis%])');
                while (regex.test(fmt)) {
                    var parts = regex.exec(fmt);
                    var ext = parts[1] ? parts[1] : ' ';
                    var wantlen = parseInt(parts[2]);
                    var type = parts[0].substring(parts[0].length - 1);
                    var val = vals.shift();
                    if (type == "f") {
                        val = parseFloat(val);
                        if (parts[3]) {
                            val = val.toFixed(parseInt(parts[3].substring(1)));
                        } else {
                            val = val.toString();
                        }
                        if (val.length < wantlen) {
                            val = Jasinja.utils.strmul(ext, wantlen - val.length) + val;
                        }
                        fmt = fmt.replace(parts[0], val);
                    } else if (type == "i") {
                        val = parseInt(val).toString();
                        if (val.length < wantlen) {
                            val = Jasinja.utils.strmul(ext, wantlen - val.length) + val;
                        }
                        fmt = fmt.replace(parts[0], val);
                    } else if (type == "s") {
                        if (val.length < wantlen) {
                            val = Jasinja.utils.strmul(ext, wantlen - val.length) + val;
                        }
                        fmt = fmt.replace(parts[0], val.toString());
                    } else if (type == "%") {
                        fmt = fmt.replace("%%", "%");
                    }
                }
                return fmt;
            },
            "groupby": function(ls, attr) {
                var groups = {};
                for (var i = 0; i < ls.length; i++) {
                    var key = ls[i][attr];
                    if (!(key in groups)) groups[key] = [];
                    groups[key].push(ls[i]);
                }
                var res = [];
                for (var key in groups) {
                    res.push({
                        0: key,
                        grouper: key,
                        1: groups[key],
                        list: groups[key]
                    });
                }
                return res;
            },
            "indent": function(s, w, first) {
                w = w === undefined ? 4 : w;
                first = first === undefined ? false : first;
                var indent = Jasinja.utils.strmul(' ', w);
                var res = s.split('\n').join('\n' + indent);
                if (first) res = indent + res;
                return res;
            },
            "int": function(val) {
                return Math.floor(val) || 0;
            },
            "last": function(val) {
                if (typeof(val) == "string") {
                    return val.charAt(val.length - 1);
                } else if (val instanceof Array) {
                    return val[val.length - 1];
                }
            },
            "list": function(val) {
                if (val instanceof Array) {
                    return val;
                } else if (typeof(val) == "string") {
                    var ls = [];
                    for (var i = 0; i < val.length; i++) {
                        ls.push(val.charAt(i));
                    }
                    return ls;
                } else if (typeof(val) == "object") {
                    var ls = [];
                    for (var key in val) {
                        ls.push(key);
                    }
                    return ls;
                } else {
                    throw new TypeError("containment is undefined");
                }
            },
            "lower": function(s) {
                return s.toLowerCase();
            },
            "join": function(val, d) {
                return val.join(d);
            },
            "random": function(ls) {
                return ls[Math.floor(Math.random() * ls.length)]
            },
            "replace": function(s, o, n) {
                return s.replace(o, n, 'g');
            },
            "reverse": function(r) {
                var c = r.slice(0);
                c.reverse();
                return c;
            },
            "round": function(val) {
                var num = arguments[1] ? arguments[1] : 0;
                var mul = num ? num * 10 : 1;
                return Math.round(val * mul) / mul;
            },
            "slice": function(ls, num, fill) {
                var ssize = Math.floor(ls.length / num);
                var extra = ls.length % num;
                var offset = 0;
                var res = [];
                var offset = 0;
                for (var i = 0; i < num; i++) {
                    var start = offset + i * ssize;
                    if (i < extra) offset += 1;
                    var end = offset + (i + 1) * ssize;
                    var tmp = ls.slice(start, end);
                    if (fill !== undefined && i >= extra) {
                        tmp.push(fill);
                    }
                    res.push(tmp);
                }
                return res;
            },
            "sort": function(val) {
                var c = val.slice(0);
                c.sort();
                return c;
            },
            "string": function(val) {
                return val.toString();
            },
            "sum": function(ls, attrib, start) {
                start = start === undefined ? 0 : start;
                for (var i = 0; i < ls.length; i++) {
                    if (attrib === undefined) start += ls[i];
                    else start += ls[i][attrib];
                }
                return start;
            },
            "title": function(s) {
                return s.replace(/[a-zA-Z]+/g, this.capitalize);
            },
            "translation_link": translation_link,
            "message_pic_sizing": message_pic_sizing,
            "trim": function(s) {
                return s.replace(/^\s+|\s+$/g, '');
            },
            "upper": function(s) {
                return s.toUpperCase();
            },
            "wordcount": function(s) {
                return s.split(/\s+/g).length;
            },
            "xmlattr": function(d, space) {
                space = space === undefined ? true : space;
                var tmp = [];
                for (var k in d) {
                    if (d[k] === null || d[k] === undefined) continue;
                    tmp.push(this.format('%s="%s"', this.escape(k), this.escape(d[k])));
                }
                var res = (space ? ' ' : '') + tmp.join(' ');
                return res;
            },
            truncate: function(m, opt_length) {
                if (m) {
                    var length = +opt_length || 30;
                    return m.length > length - 3 ? m.substr(0, length - 3) + '...' : m;
                }
                return m;
            },
            truncate_html: truncate_html,
            length: function(m) {
                if (!m) return 0;
                if (m.length !== undefined) return m.length;
                var key_count = 0;
                for (var key in m) {
                    if (m.hasOwnProperty(key)) key_count++;
                }
                return key_count;
            },
            is_context: function(m) {
                return m && (Array.isArray(m) || typeof m == "object");
            },
            is_not_context: function(m) {
                return !Mustache.FILTERS.is_context(m);
            },
            quote_plus: function(m) {
                return encodeURIComponent(m).replace(/%20/g, '+');
            },
            iter_items: function(m) {
                var items = [];
                for (var key in m) {
                    if (m.hasOwnProperty(key)) {
                        items.push([key, m[key]]);
                    }
                }
                return items;
            },
            replace: function(m, opt_find, opt_replace) {
                if (opt_find && opt_replace !== undefined) {
                    return m.replace(opt_find, opt_replace);
                }
                return m;
            },
            json: function(m) {
                return JSON.stringify(m).replace(/<\//g, '<\\/');
            },
            child_tag: function(tag) {
                return (tag.indexOf(':') !== -1) ? tag.split(':')[1] : tag;
            },
            format_number: format_number,
            format_num_k: format_num_k,
            format_duration: format_duration,
            format_date: format_date,
            nicetime: nicetime,
            pluralize: pluralize,
            grid_size: grid_size,
            grid_size_mix: grid_size_mix,
            breakwords: breakwords,
            escape_and_link: escape_and_link,
            slice: slice,
            count: count,
            linkify: linkify,
            linkify_tags: linkify_tags,
            number: number,
            is_rtl: is_rtl,
            user_thumb: user_thumb,
            is_online: function(user_id) {
                return window.RT && window.RT.online_users[user_id];
            },
            in_list: function(obj, arr) {
                if (!arr) return false;
                return arr.indexOf && arr.indexOf(obj) > -1;
            },
            add_url_param: function(url, param) {
                if (!param) return url;
                return (url.match(/[?]/) ? '&' : '?') + param;
            }
        },
        "tests": {
            "callable": function(val) {
                return typeof(val) == "function";
            },
            "defined": function(val) {
                return val !== undefined;
            },
            "divisibleby": function(val, num) {
                return !(val % num);
            },
            "even": function(val) {
                return this.divisibleby(val, 2);
            },
            "lower": function(val) {
                return val.toLowerCase() == val;
            },
            "none": function(val) {
                return val === null;
            },
            "number": function(val) {
                return typeof(val) == "number";
            },
            "odd": function(val) {
                return !this.divisibleby(val, 2);
            },
            "undefined": function(val) {
                return val === undefined;
            },
            "upper": function(val) {
                return val.toUpperCase() == val;
            },
            "string": function(val) {
                return typeof(val) == "string";
            }
        },
        "templates": {
            "fl_login_form.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    if (!ctx.upsell) {
                        _buf.push('<div id="signin_error_box" class="signin_error_box"></div>\n');
                    }
                    _buf.push('\n<a class="button blue_button signup" id=\'signup_fb_button\' href="#" ');
                    if (ctx.likes_upsell) {
                        _buf.push('style="margin-bottom:75px;"');
                    }
                    _buf.push('>\n    <img class="fb_logo" src="/images/likes/fb-logo.png" />\n    <span class="text">Sign Up with Facebook</span> <span class="loggedout_form_spinny">Loading <img src="/images/likes/fb_spinny.gif" /></span>\n</a>\n\n<p id="show_signup_fields">Or <a class="bright-blue underline">Sign Up with Email</a></p>\n<h5 id="login_header">Log In</h5>\n\n<form id="login_form" action="/api/login" method="post">\n    <div id="login_form_fields">\n        <input id="login_redirect_url" type="hidden" name="redirect_url" value="');
                    _buf.push(Jasinja.escape(ctx.redirect_url));
                    _buf.push('" />\n        <input id="login_error_redirect" type="hidden" name="error_redirect" value="');
                    _buf.push(Jasinja.escape(ctx.error_redirect));
                    _buf.push('" />\n        <input id="login_referer_url" type="hidden" name="referer_url" value="');
                    _buf.push(Jasinja.escape(ctx.referer_url));
                    _buf.push('" />\n\n        <input id="login_username" type="text" name="username" size="20" class="logintext first_input" value="');
                    _buf.push(Jasinja.escape(ctx.user_email));
                    _buf.push('" placeholder="Username or Email" />\n        <input id="login_password" type="password" name="password" size="20" class="logintext last_input" placeholder="Password" />\n    </div>\n    <div class="clear"></div>\n\n    <a class="button blue_button med_button fat_button" id="submit_login_form"><span class="text">Sign in</span> <span class="loggedout_form_spinny">Loading <img src="/images/likes/signin_spinny.gif" /></span></a>\n    <p class="medgrey"><a href="/forgot_password');
                    _buf.push(Jasinja.escape(ctx.referer_param));
                    _buf.push('" class="forgot_password_link bright-blue underline">Forgot your Password?</a></p>\n</form>\n');
                    return _buf.join("");
                }
            },
            "fl_signup_form.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    if (ctx.gallery_upsell) {
                        _buf.push('<a class="button blue_button signup" id=\'signup_fb_button\' href="#">\n    <img class="fb_logo" src="/images/likes/fb-logo.png" />\n    <span class="text">Sign Up with Facebook</span> <span class="loggedout_form_spinny">Loading <img src="/images/likes/fb_spinny.gif" /></span>\n</a>\n<p id="show_signup_fields">Or <a>Sign Up with Email</a></p>\n');
                    } else {
                        _buf.push('<div id="signin_error_box" class="signin_error_box"></div>\n');
                    }
                    _buf.push('\n<form id="signup_form');
                    if ((ctx.in_page && ctx.gallery_upsell)) {
                        _buf.push('_gallery_upsell');
                    }
                    _buf.push('" class="signup_form" action="/api/signupprocess" method="POST">\n    <div class="signup_fields stylized_border">\n        <input id="signup_email" type="text" name="email" size="20" class="logintext first_input" value="');
                    _buf.push(Jasinja.escape(ctx.email_to_display));
                    _buf.push('" placeholder="Email"/>\n        <input type="text" name="name" size="20" class="logintext" value="');
                    _buf.push(Jasinja.escape(ctx.curr_name));
                    _buf.push('" placeholder="Name"/>\n        <input type="hidden" name="noname" value="1" />\n        <input type="password" name="password" class="logintext last_input" placeholder="Password" />\n        <input type="hidden" name="redirect_url" value="');
                    _buf.push(Jasinja.escape(ctx.redirect_url));
                    _buf.push('" />\n        <input type="hidden" name="error_redirect" value="');
                    _buf.push(Jasinja.escape(ctx.error_redirect));
                    _buf.push('" />\n    </div>\n\n');
                    if (!ctx.photo_verify_signup) {
                        _buf.push('    <div class="picture_container">\n        <div class="label">Picture</div>\n        <div class="contents">\n');
                        _buf.push(Jasinja.templates['picture_chooser.html'].render($.extend({}, ctx, locals)));
                        _buf.push('        </div>\n        <div class="clear" style="height:10px;width:10px"></div>\n    </div>\n');
                    }
                    _buf.push('\n\n    <div class="nice_select_container birthday_container">\n        <div class="label">Birthday</div>\n        <div class="contents">\n');
                    _buf.push(Jasinja.templates['date_chooser.html'].render($.extend({}, ctx, locals)));
                    _buf.push('        </div>\n        <div class="clear" style="height:10px;width:10px"></div>\n    </div>\n\n    <div class="gender_container">\n        <div class="label">Gender</div>\n        <div class="contents">\n            <input type="radio" id="gender_male" name="gender" value="m" ');
                    if (ctx.gender == 'm') {
                        _buf.push(' checked ');
                    }
                    _buf.push('> <label for="gender_male">Male</label>\n            <input type="radio" id="gender_female" name="gender" value="f" ');
                    if (ctx.gender == 'f') {
                        _buf.push(' checked ');
                    }
                    _buf.push('> <label for="gender_female">Female</label>\n        </div>\n        <div class="clear" style="height:10px;width:10px"></div>\n    </div>\n    <div class="captcha" style="width: 302px; height: 80px; margin-top: 10px; margin-bottom: 20px; float:right; display: none"></div>\n    <div class="clear"></div>\n\n    <input type="hidden" name="signup_token" value="');
                    _buf.push(Jasinja.escape(ctx.signup_token));
                    _buf.push('">\n\n    <div class="clear"></div>\n\n\n    <a id=\'submit_signup_form');
                    if (ctx.gallery_upsell) {
                        _buf.push('_gallery_upsell');
                    }
                    _buf.push('\' class=\'submit_signup_form button orange_button\'><span class="text">Sign Up ');
                    if (ctx.gallery_upsell) {
                        _buf.push(' with Email ');
                    }
                    _buf.push('</span> <span class="loggedout_form_spinny">Loading <img src="/images/likes/signin_spinny.gif" /></span></a>\n</form>\n\n');
                    if (ctx.gallery_upsell) {
                        _buf.push('<div id="signup_terms">By clicking "Sign Up", you are indicating that you have read and agreed to the <a class="med-blue underline" href="/content/terms" tabindex="-1" target="_blank"> Terms of Service</a> and <a class="med-blue underline" href="/content/privacy" tabindex="-1" target="_blank">Privacy Policy</a>.</div>\n<p id=\'login_link\'>Already have an account? <a href=\'/login\' class=\'underline med-blue\'>Log In</a></p>\n\n');
                    } else {
                        _buf.push('<p id="hide_signup_fields">Or <a class=\'bright-blue underline\'>Go Back</a></p>\n');
                    }
                    return _buf.join("");
                }
            },
            "fl_login_dialog_inner.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    _buf.push('<div id="signin_error_box" class="signin_error_box"></div>\n\n<a class="button blue_button signup" id=\'signup_fb_button\' href="#" ');
                    if (ctx.likes_upsell) {
                        _buf.push('style="margin-bottom:75px;"');
                    }
                    _buf.push('>\n    <img class="fb_logo" src="/images/likes/fb-logo.png" />\n    <span class="text">Sign Up with Facebook</span> <span class="loggedout_form_spinny">Loading <img src="/images/likes/fb_spinny.gif" /></span>\n</a>\n\n<p class=\'or_text\'>Don\'t have Facebook?</p>\n\n<div class=\'button grey_button\' id="show_signup_fields">Sign Up with Email</div>\n<div class=\'button grey_button\' id=\'show_login_fields\'>Log In</div>\n');
                    return _buf.join("");
                }
            },
            "forgot_password.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    _buf.push('\n<div class="loggedout_form_desc">\n');
                    if (!ctx.success) {
                        if (!ctx.partner_only_login) {
                            _buf.push('    <h3>Password Reset</h3>\n');
                        }
                        _buf.push('    <p class="instruct">We\'ll email you instructions on how to reset your password.</p>\n');
                    } else {
                        _buf.push('    <h3>Password reset email sent!</h3>\n    <p class="instruct">Your email will have a the reset password link. Please check your spam folder as well.</p>\n');
                    }
                    _buf.push('</div>\n\n<form id="forgot_password_form" action="/api/forgot_password" method="post">\n');
                    if (!ctx.success) {
                        _buf.push('    <div id="login_form_fields" ');
                        if (!ctx.partner_only_login) {
                            _buf.push('class="stylized_border"');
                        }
                        _buf.push('>\n        <input type="text" id="email" name="email" size="20" class="logintext first_input" value="');
                        _buf.push(Jasinja.escape(ctx.email_to_display));
                        _buf.push('" placeholder=\'Email Address\' />\n    </div>\n    <a class=\'submit_loggedout_form button med_button blue_button fat_button grey_fat_button\' id=\'submit_forgot_password_form\'><span class="text">Reset Password</span> <span class="loggedout_form_spinny">LOADING <img src="/images/likes/signin_spinny.gif" /></span></a>\n    <input type="hidden" name="referer_url" value="');
                        _buf.push(Jasinja.escape(ctx.referer_url));
                        _buf.push('" />\n<!--    <input type="submit" style="display:none;"/>-->\n');
                    }
                    _buf.push('    <p class="grey"><a href="/login');
                    _buf.push(Jasinja.escape(ctx.referer_param));
                    _buf.push('" class="bright-blue underline">Go Back to Log In.</a></p>\n</form>\n');
                    return _buf.join("");
                }
            },
            "date_chooser.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    _buf.push('<div class="date_chooser_wrapper" data-name="birthday">\n    <div id="birthday_month_wrapper" class="button white_button nice_native_select"><select name="month" id="birthday_month">\n        <option ');
                    if (!ctx.birthday_month) {
                        _buf.push(' selected ');
                    }
                    _buf.push(' value="">Month</option>\n');
                    var _loopvar0 = Jasinja.utils.loop(ctx.months);
                    for (_loopvar0.i = 0; _loopvar0.i < _loopvar0.l; _loopvar0.i++) {
                        var month = locals.month = _loopvar0.iter[_loopvar0.i];
                        loop = _loopvar0;
                        loop.update();
                        _buf.push('            <option value="');
                        _buf.push(Jasinja.escape(month.number));
                        _buf.push('" ');
                        if (month.number == ctx.birthday_month) {
                            _buf.push('selected');
                        }
                        _buf.push('>');
                        _buf.push(Jasinja.escape(month.name));
                        _buf.push('</option>\n');
                    }
                    _buf.push('    </select></div>\n\n    <div id="birthday_day_wrapper" class="button white_button nice_native_select"><select name="day" id="birthday_day">\n        <option ');
                    if (!ctx.birthday_day) {
                        _buf.push(' selected ');
                    }
                    _buf.push(' value="">Day</option>\n');
                    var _loopvar0 = Jasinja.utils.loop(ctx.days);
                    for (_loopvar0.i = 0; _loopvar0.i < _loopvar0.l; _loopvar0.i++) {
                        var day = locals.day = _loopvar0.iter[_loopvar0.i];
                        loop = _loopvar0;
                        loop.update();
                        _buf.push('<option value="');
                        _buf.push(Jasinja.escape(day.day));
                        _buf.push('" ');
                        if (day.day == ctx.birthday_day) {
                            _buf.push('selected');
                        }
                        _buf.push('>');
                        _buf.push(Jasinja.escape(day.day));
                        _buf.push('</option>');
                    }
                    _buf.push('    </select></div>\n\n    <div id="birthday_year_wrapper" class="button white_button nice_native_select" style="margin-right:0"><select name="year" id="birthday_year">\n        <option ');
                    if (!ctx.selected_year) {
                        _buf.push(' selected ');
                    }
                    _buf.push(' value="">Year</option>\n');
                    var _loopvar0 = Jasinja.utils.loop(ctx.years);
                    for (_loopvar0.i = 0; _loopvar0.i < _loopvar0.l; _loopvar0.i++) {
                        var year = locals.year = _loopvar0.iter[_loopvar0.i];
                        loop = _loopvar0;
                        loop.update();
                        _buf.push('<option value="');
                        _buf.push(Jasinja.escape(year.year));
                        _buf.push('" ');
                        if (year.year == ctx.selected_year) {
                            _buf.push('selected');
                        }
                        _buf.push('>');
                        _buf.push(Jasinja.escape(year.year));
                        _buf.push('</option>');
                    }
                    _buf.push('    </select></div>\n</div>');
                    return _buf.join("");
                }
            },
            "picture_chooser.html": {
                "macros": {},
                "blocks": {},
                "render": function(ctx, tmpl) {
                    tmpl = Jasinja.utils.extend(this, tmpl);
                    var _buf = [];
                    var locals = {}, loop;
                    _buf.push('<div class="pic_chooser">\n    <div class="upload_form_pic">\n        <div class="upload_pic_display"></div>\n    </div>\n    <div class="upload_button_container upload_form_container">\n        <div class="file_field_wrapper button white_button">\n            Upload Profile Picture\n        </div>\n        <input class="browse_button" name="uploaded" type="file" size="30" form_id="pic_chooser">\n        <div class="pic_chooser_spinny">\n            <div class="progress">Uploading...</div>\n            <img class="uploading" src="/images/likes/signin_spinny.gif">\n            <span>0%</span>\n            <div class=\'progress_info\'>\n                <div class="upload_file_progress_outer">\n                    <div class="upload_file_progress_inner"></div>\n                </div>\n            </div>\n        </div>\n        <input class="picture" class="pic_url_field" type="hidden" name="picture" value="" />\n    </div>\n</div>\n\n');
                    return _buf.join("");
                }
            }
        }
    };
    var Mustache = window.Mustache = window.Mustache || {};
    Mustache.FILTERS = Mustache.FILTERS || Jasinja.filters;

    function include_mustache(ctx, tmpl, name, context) {
        var data = $.extend({}, ctx || {}, context || {});
        return ich[name](data, true);
    }
    var jinja = window.jinja = window.jinja || {};
    for (var name in Jasinja.templates) {
        (function(name, func) {
            if (Jasinja.templates.hasOwnProperty(name)) {
                jinja[name.replace(/(^.*\/|\.html$)/g, '')] = function(data, raw) {
                    if (window.$) data = $.extend({}, window.global_ich_data || {}, data || {});
                    func.macros = {
                        include_mustache: include_mustache
                    };
                    var result = func.render(data);
                    return (window.$ && !raw) ? $(result) : result;
                };
            }
        })(name, Jasinja.templates[name]);
    }
})();
